#if !defined(FVUJ__BTKCLASS_H)
#define FVUJ__BTKCLASS_H

#include "utils\d3dtextr.h"
#include "utils\d3dutil.h"
#include "utils\d3dmath.h"
#include "XFiles\xfileloader.h"
#include "gamebase.h"
#include "pomocne.h"

extern char *LoadTexPath;

//-----------spotreba paliva pro jednotlive prostredky
#define JEEP_KLIDSPOTREBA 0.04f
#define TANK_KLIDSPOTREBA 0.16f
#define ARMO_KLIDSPOTREBA 0.08f
#define HELI_KLIDSPOTREBA 0.33f
#define JEEP_SPOTREBA 0.12f
#define TANK_SPOTREBA 0.48f
#define ARMO_SPOTREBA 0.24f
#define HELI_SPOTREBA 0.04f

#pragma pack(1)

extern int AmmoLimit[4][2];
extern float FuelLimit[4];
extern int DamageLimit[4];
extern int SilaStrely[4];


struct TText
{
char *data;
DWORD time;
//BOOL smazat;
TText()
	{
	data=NULL;
	time=timeGetTime();
//	smazat=false;
	}
~TText()
	{
	if(data)
		delete [] data;
	}
};

struct TZdroje
{
BYTE NCar[4];//pocty zbyvajicich vozidel v bunkru

BYTE NMina;//pocet min je omezen (ostatni naboje nejsou)
};

struct TGID//jednoznacny identifikator objektu ve hre
{
DWORD time;
DPID  pid;
};

struct TStrela{
TGID gid;//glob. id. num. obj

BYTE Typ;//0obyc 1raketa 2granat
BYTE Vyska;//0pozemni 1vzdusna
BYTE From;//typ vozitka, ze ktereho byla vystrelena (kvuli zobrazovani)
float X;//aktualni pozice
float Y;
float Dolet;//kolik ji zbyva uletet
float dX;//rychlost
float dY;
HRESULT Display(LPDIRECT3DDEVICE3,DWORD);//zobrazi strelu
HRESULT Move(float time);//posune strelu (cas v sekundach)
};

struct TStatSpoj{//struktura na ukladani statickych objektu do mapky
TGID gid;//glob. id. num. obj

int Index;//cislo statickeho objektu (index v poli vsech statickych objektu)
float X;//relativni sour x v policku
float Y;//--||--
float R;//otoceni

DWORD dw_t;//pro animovani objektu, plyne k nule a u nuly se zrusi (konec animace)
//plati pochopitelne jen pro objekty typu animace (typ<0 v TStatic)
//bude se pouzivat u miny pro stanoveni casu aktivace

int Damage;
};

/*********zbytek application messages*********/

typedef struct _HOSTMSG
{
    BYTE        byType;
    int         usedShipTypes[NUM_SHIP_TYPES];
	int SizeX;
	int SizeY;//musim predat novemu hraci udaje o stavu hry
	int NumOfStatic;
	int NumOfStrela;
	TZdroje zdroje[2];//zdroje pro obe strany
	int score[2];
	BYTE Data[1];//zatim me zajima jen podklad mapky
} HOSTMSG, *LPHOSTMSG;

typedef struct _ADDSTRELAMSG
{
    BYTE        byType;
	TStrela		strela;
} ADDSTRELAMSG, *LPADDSTRELAMSG;

typedef struct _SCOREMSG
{
    BYTE        byType;
	int score[2];//predavaji se akt. udaje
	int zmena[2];//a zmeny kvuli kterym jsem odeslal zpravu
	//aktualizace smerem nahoru, zaporna hodnota zmeny-> nemaji auticka (info)
	//kdyz jsou obe zmeny nulove, znamena to ze jen informuji, ze nekdo jiny ma nizsi skore nez ja a aby si ho upravil
	//podle skore[]
} SCOREMSG, *LPSCOREMSG;

typedef struct _SYNCZDROJMSG
{
    BYTE        byType;
	TZdroje		zdroje[2];
} SYNCZDROJMSG, *LPSYNCZDROJMSG;

typedef struct _ZDROJEMSG
{
    BYTE        byType;
	BOOL        Host;//true...zprava od hosta
	BYTE        What;//jake auto si muze vzit
	BYTE        Miny;//kolik min si muze do auta nalozit

	BYTE		Skup;
} ZDROJEMSG, *LPZDROJEMSG;

typedef struct _DELSTRELAMSG
{
    BYTE        byType;
	TGID		gid;
} DELSTRELAMSG, *LPDELSTRELAMSG;

typedef struct _CHANGESTATMSG
{
    BYTE        byType;
	TStatSpoj   stat;//jaky se ma menit
	int x;//abych vedel kde ji mam na mapce hledat
	int y;
	int cim;//druh upravy mapky viz prototyp sendchangemess
} CHANGESTATMSG, *LPCHANGESTATMSG;

extern ADDSTRELAMSG                     gAddStrelaMsg;               
extern SCOREMSG                     gScoreMsg;               
extern SYNCZDROJMSG                     gSyncZdrojMsg;               
extern ZDROJEMSG                     gZdrojeMsg;               
extern DELSTRELAMSG                     gDelStrelaMsg;               
extern CHANGESTATMSG                     gChangeStatMsg;               
extern SHIPHITMSG                      gShipHitMsg;                // ..
/*************************/

//tahle specialni struktura se pouziva pro prenos mapky po siti k novemu hraci
struct TStatSpoj2{
TStatSpoj StatInfo;
int Mx;
int My;//prislusnost objektu k policku mapky
};

#pragma pack()


struct TexCont
{
    HBITMAP              hbmBitmap;      // Bitmap containing texture image
    LPDIRECTDRAWSURFACE4 pddsSurface;    // Surface of the texture
    LPDIRECT3DTEXTURE2   ptexTexture;    // Direct3D texture for the texture
    DWORD                dwStage;        // Texture stage (for multi-textures)
    TCHAR                strName[80];    // Filename of assoc'd bitmap
    BOOL                 bHasAlpha;
    DWORD                dwFlags;
    
    BYTE*                pSurfaceBits[10];
    DDSURFACEDESC2       ddsd;
    
    ~TexCont();
};


class TStatic{//staticky objekt obecny
public:
//DWORD animtime;//(pro animace)celkova delka animace (nove dopichnout)
int typ;//zde je identifikacni cislo typu objektu pro specialni postupy
float range;
BOOL pojede[3];

int InitDam;//damage limit noveho objektu
virtual HRESULT Display(LPDIRECT3DDEVICE3,float,float,float,DWORD)=0;//zobrazi objekt na x,y,rotace (z=0 default), cas v milisekundach
virtual HRESULT Hit(TStrela *strela,float x,float y,float r);//musim predat i souradnice x,y, kde se stat nachazi (absolutni)
virtual void Restore(LPDIRECT3DDEVICE3 pd3dDevice )=0;
virtual void Invalidate()=0;
virtual ~TStatic(){};
};

class TXStatic:public TStatic{//staticky objekt x-file
public:
CD3DFileObject *Objekt3D;
virtual HRESULT Display(LPDIRECT3DDEVICE3,float,float,float,DWORD);//zobrazi objekt na x,y,rotace (z=0 default)
virtual void Restore(LPDIRECT3DDEVICE3 pd3dDevice ){};
virtual void Invalidate(){};
HRESULT Load(char *filename);
TXStatic(){
	Objekt3D=new CD3DFileObject;
	};
virtual ~TXStatic(){
	SAFE_DELETE(Objekt3D);
	};
};

class TTStatic:public TStatic{//staticky objekt- jednoducha textura
public:
TexCont *TexData;
float ScaleX;//specielne pro texturovy static, jak ma byt textura velka 3D
float ScaleY;//
virtual HRESULT Display(LPDIRECT3DDEVICE3,float,float,float,DWORD);//zobrazi objekt na x,y,rotace (z=0 default)
virtual void Restore(LPDIRECT3DDEVICE3 pd3dDevice );
virtual void Invalidate();
HRESULT Load(char *filename,DWORD dwFlags=0);//loadne texturu ze souboru
TTStatic()
	{
	TexData=NULL;
	ScaleX=0.5;
	ScaleY=0.5;
	};
virtual ~TTStatic(){
	SAFE_DELETE(TexData);
	};
};

/**************************************/


struct TPole{//policko na mapce
BYTE Podklad;
TSpojak <TStatSpoj> *Spojak;//spojak statickych objektu
};

class TMapka {//hraci mapka
public:
int SizeX;
int SizeY;//rozmer mapky
TPole *Mapa;//pole policek (TPole) pro ulozeni dat mapky
public:
TMapka(int x,int y);//pocatecni rozmery
~TMapka();
};

/*******************Prostredky******************************/



class TCar{//staticky objekt obecny
public:
SHIP *share;
char Typ;//tenhle typ je na identifikaci pred naloudovanim sdilene struktury

/******zde bude uloze obrys auta, kvuli vypoctum kolizi******/
float ObrysX[4];//inicializace dodelat v konstruktoru
float ObrysY[4];//souradnice vrcholu ctyruhelniku
/**************/
/*2yxx       1*/
/* y auto     */
/*zad     pred*/
/*3          0*/
/**************/
//pouziva se pri renderovani u deSync...
float deX,deY,deR;

float zoom;//kvuli interfaceu

//DWORD starttime;//pro pocitani animaci vzhledem k casu

float acc;
float decc;
float odpor;
float maxrych;
float maxrotrych;
float maxnormrych;
float invacc;
//float invdecc;brzdeni je stejne na obe strany
float invmaxrych;
void CompDeSync();
virtual HRESULT Move(DWORD actkeys,float time);

virtual HRESULT Hit(TStrela *strela)=0;
//vrati S_OK, kdyz strela ho zasahla
virtual HRESULT Kolize(TStatSpoj *stat,float mx,float my)=0;
virtual HRESULT Kolize(TCar *car)=0;
//vrati S_OK kdyz koliduje se statickym objektem na policku mx my
// ale muze ho projet
//vrati E_ACCESSDENIED kdyz koliduje ale nemuze ho projet
//vrati E_FAIL kdyz nekoliduje
virtual HRESULT Display(LPDIRECT3DDEVICE3,DWORD)=0;
//zobrazi auto na jeho aktualni pozici a v jeho aktualnim stavu
//predavam mu i cas (pro animace)
/*virtual void Restore(LPDIRECT3DDEVICE3 pd3dDevice )=0;
virtual void Invalidate()=0;*///nema smysl protoze bude pouzivat jen externi zdroje (viz AutoModely)
virtual ~TCar(){};
};

class TJeep:public TCar{
public:
virtual HRESULT Hit(TStrela *strela);
virtual HRESULT Kolize(TStatSpoj *stat,float mx,float my);
virtual HRESULT Kolize(TCar *car);
virtual HRESULT Display(LPDIRECT3DDEVICE3,DWORD);
TJeep()
	{
	zoom=0;
	share=NULL;
	Typ=0;//0..3 typ prostredku

	/******Obrys*****/
	ObrysX[0]=0.258f;
	ObrysY[0]=0.167f;
	ObrysX[1]=0.258f;
	ObrysY[1]=-0.167f;
	ObrysX[2]=-0.242f;
	ObrysY[2]=-0.167f;
	ObrysX[3]=-0.242f;
	ObrysY[3]=0.167f;//dopichnout

//	starttime=timeGetTime();//pro pocitani animaci vzhledem k casu

	acc=1;
	decc=1;
	odpor=1;
	maxrych=2;
	maxrotrych=1;
	maxnormrych=1;
	invacc=1;
	invmaxrych=1;//seridit
	};
virtual ~TJeep(){};
};

class TTank:public TCar{
public:
virtual HRESULT Move(DWORD actkeys,float time);//time in second
virtual HRESULT Hit(TStrela *strela);
virtual HRESULT Kolize(TStatSpoj *stat,float mx,float my);
virtual HRESULT Kolize(TCar *car);
virtual HRESULT Display(LPDIRECT3DDEVICE3,DWORD);
TTank()
	{
	zoom=0;
	share=NULL;
	Typ=1;//0..3 typ prostredku

	/******Obrys*****/
	ObrysX[0]=0.52f;
	ObrysY[0]=0.238f;
	ObrysX[1]=0.52f;
	ObrysY[1]=-0.238f;
	ObrysX[2]=-0.47f;
	ObrysY[2]=-0.238f;
	ObrysX[3]=-0.47f;
	ObrysY[3]=0.238f;//dopichnout

//	starttime=timeGetTime();//pro pocitani animaci vzhledem k casu

	acc=1;
	decc=1;
	odpor=1;
	maxrych=1;
	maxrotrych=1;
	maxnormrych=1;
	invacc=1;
	invmaxrych=1;//seridit
	};
virtual ~TTank(){};
};

class TArmo:public TCar{
public:
virtual HRESULT Hit(TStrela *strela);
virtual HRESULT Kolize(TStatSpoj *stat,float mx,float my);
virtual HRESULT Kolize(TCar *car);
virtual HRESULT Display(LPDIRECT3DDEVICE3,DWORD);
TArmo()
	{
	zoom=0;
	share=NULL;
	Typ=2;//0..3 typ prostredku

	/******Obrys*****/
	ObrysX[0]=0.49f;//dodelat zoom tohodle auta
	ObrysY[0]=0.198f;
	ObrysX[1]=0.49f;
	ObrysY[1]=-0.198f;
	ObrysX[2]=-0.5f;
	ObrysY[2]=-0.198f;
	ObrysX[3]=-0.5f;
	ObrysY[3]=0.198f;//dopichnout

//	starttime=timeGetTime();//pro pocitani animaci vzhledem k casu

	acc=1;
	decc=1;
	odpor=1;
	maxrych=1;
	maxrotrych=1;
	maxnormrych=1;
	invacc=1;
	invmaxrych=1;//seridit
	};
virtual ~TArmo(){};
};

class THeli:public TCar{
public:
virtual HRESULT Move(DWORD actkeys,float time);//time in second
virtual HRESULT Hit(TStrela *strela);
virtual HRESULT Kolize(TStatSpoj *stat,float mx,float my){return E_FAIL;};//helikoptera nemuze kolidovat se stat bojektem na zemi
virtual HRESULT Kolize(TCar *car);
virtual HRESULT Display(LPDIRECT3DDEVICE3,DWORD);
THeli()
	{
	zoom=0;
	share=NULL;
	Typ=3;//0..3 typ prostredku

	/******Obrys*****/
	ObrysX[0]=0.35f;
	ObrysY[0]=0.187f;
	ObrysX[1]=0.35f;
	ObrysY[1]=-0.187f;
	ObrysX[2]=-0.65f;
	ObrysY[2]=-0.187f;
	ObrysX[3]=-0.65f;
	ObrysY[3]=0.187f;

//	starttime=timeGetTime();//pro pocitani animaci vzhledem k casu

	acc=1;
	decc=1;
	odpor=1;
	maxrych=2;
	maxrotrych=1;
	maxnormrych=1;
	invacc=1;
	invmaxrych=1;//seridit
	};
virtual ~THeli(){};
};


/********BUDOVY**********/

struct TFloatRect{
float left; 
float top; 
float right; 
float bottom; 
};


class TBudova:public TStatic{//budova
public:
TSpojak <TFloatRect> Obrys;//obrys budovy (naplneno pri inicializaci hry)
/*virtual HRESULT Kolize(float x,float y,float R);//zda bod (relativni souradnice) nekoliduje s budovou dle obrysu
//R..otoceni budovy
virtual HRESULT Kolize(TCar *car,float R);//zda auto (relativni souradnice) nekoliduje s budovou dle obrysu
//R..otoceni *///nove zruseno, probiha pres
HRESULT Kolize(float *x,float *y);//zda ctyruhelnik (relativni souradnice) nekoliduje s budovou dle obrysu
virtual HRESULT Hit(TStrela *strela,float x,float y,float r);//musim predat i souradnice x,y, kde se stat nachazi (absolutni)

CD3DFileObject *Objekt3D;
virtual HRESULT Display(LPDIRECT3DDEVICE3,float,float,float,DWORD);//zobrazi objekt na x,y,rotace (z=0 default)
virtual void Restore(LPDIRECT3DDEVICE3 pd3dDevice ){};
virtual void Invalidate(){};
HRESULT Load(char *filename);
TBudova(){
	Objekt3D=new CD3DFileObject;
	};
virtual ~TBudova(){
	SAFE_DELETE(Objekt3D);
	};
};

/*********dynamicke zmeny mapky*********/

/*struct TZmena{
TStatSpoj obj;
DWORD intime;
int mx;
int my;
int op;
};*/


//funkce

HRESULT MyLoadTextureImage( TexCont* ptcTexture );
TexCont *MyTextr_CreateTexture( TCHAR* strName, DWORD dwStage=0L,
							    DWORD dwFlags=0L );
HRESULT MyTextr_Restore( TexCont* ptcTexture, LPDIRECT3DDEVICE3 pd3dDevice );
HRESULT MyTextr_Invalidate(TexCont* ptcTexture);

HRESULT MoveCameraByCar(float time,BOOL reset);

#endif