/*==========================================================================
 *
 *  Copyright (C) 1995-1997 Microsoft Corporation. All Rights Reserved.
 *
 *  File:		comm.h
 *  Content:	communication routines include file
 *
 *
 ***************************************************************************/
#define IDIRECTPLAY2_OR_GREATER
#include <dplay.h>

#ifdef __cplusplus
extern "C" {
#endif

#define MAX_PLAYERS 16//muze byt i vic (pouze kvuli datovym strukturam)

/*
 * Prototypes
 */
HRESULT DPlayClose(void);
HRESULT DPlayCreate(LPVOID lpCon);
HRESULT DPlayCreatePlayer(LPDPID lppidID, LPTSTR lpPlayerName, HANDLE hEvent, 
						  LPVOID lpData, DWORD dwDataSize);
HRESULT DPlayCreateSession(LPTSTR lptszSessionName);
HRESULT DPlayDestroyPlayer(DPID pid);
HRESULT DPlayEnumPlayers(LPGUID lpSessionGuid, LPDPENUMPLAYERSCALLBACK2 lpEnumCallback, 
						 LPVOID lpContext, DWORD dwFlags);
HRESULT DPlayEnumSessions(DWORD dwTimeout, LPDPENUMSESSIONSCALLBACK2 lpEnumCallback, 
						  LPVOID lpContext, DWORD dwFlags);
HRESULT DPlayGetPlayerData(DPID pid, LPVOID lpData, LPDWORD lpdwDataSize, DWORD dwFlags);
HRESULT DPlayGetPlayerName(DPID pid, LPVOID lpData, LPDWORD lpdwDataSize);
HRESULT DPlayGetSessionDesc(void);
BOOL	IsDPlay(void);
HRESULT DPlayOpenSession(LPGUID lpSessionGuid);
HRESULT DPlayReceive(LPDPID lpidFrom, LPDPID lpidTo, DWORD dwFlags, LPVOID lpData, 
					 LPDWORD lpdwDataSize);
HRESULT DPlayRelease(void);
HRESULT DPlaySend(DPID idFrom, DPID idTo, DWORD dwFlags, LPVOID lpData, 
				  DWORD dwDataSize);
HRESULT DPlaySetPlayerData(DPID pid, LPVOID lpData, DWORD dwSize, DWORD dwFlags);


/*
 * Externals
 */
extern LPGUID			glpGuid;			// duel's guid
extern LPDPLCONNECTION	glpdplConnection;	// connection settings
extern BOOL				gbUseProtocol;		// DirectPlay Protocol messaging
extern BOOL				gbAsyncSupported;	// asynchronous sends supported
extern LPDPSESSIONDESC2		glpdpSD;			// current session description

#ifdef __cplusplus
}
#endif

 

