#if !defined(FVUJ__ENGINE_H)
#define FVUJ__ENGINE_H

/*#include "utils\d3dtextr.h"
#include "utils\d3dutil.h"
#include "XFiles\xfileloader.h"*/
#include "pomocne.h"
#include "btkclass.h"
#include "windows.h"


#define MAX_TEXT_TIME 15000L//in ms, max cas zobrazeni textinfa 
#define MAX_TEXT_RAD 5//max pocet radku infa, pak se umazavaji
#define MIN_TEXT_RAD 1//kolik radek se casove neumazava

#define AKTIVACEMINY_TIME 2000//v milisekundach

#define UMIRANI_LEN 2.0f//vzdalenost od hrobu kdyz ho obletam
#define UMIRANI_KOEF 1.0f//koeficient kterym se nasobi ubehli cas pro vypocet uhlu pohledu pri obletani

#define BASEKA_TIME 1.5f//cas po kterem je mozny navrat do baseky, nebo vylezt z baseky
#define UMIRANI_TIME 7.5f//cas po ktery poletuji okolo mista smrti, nez muzu hrat dal
#define BASEKA_LEN 0.5f//vzdalenost od prostredku baseky, aby se clovek mohl ukryt

#define CERP_STRELIVO 4 //rychlost nakladani streliva za 1s
#define CERP_PALIVO 2.5f //rychlost cerpani paliva za 1s
#define CERP_LEN 1.0f //na jakou vzdalenost se cerpa palivo a strelivo z cerp. stanic
#define HELI_VYS 0.67f

#define ZOOMSPEED 2.0f
#define MAP_RANGE 20.0f
#define RADAR_RANGE 10.0f

#define COMPETE_TIME 5000//dele nez 5s necekam na 
//typy statickych objektu
#define TYP_TSTATIC 0
#define TYP_XSTATIC 1
#define TYP_BUDOVA 2

#define MINSIZEMAP 1 //mezni velikosti mapky
#define MAXSIZEMAP 255//souradnice 255 ja pouzita pro spec ucely

#define LIM_STAT 128//max pocet statickych objektu
#define LIM_MAPTEXMAX 128//max index bitmapy mapy +1

//#define MAPTEX_W 32//rozmery textur policek mapy (podle toho se upravi textura natazena z fajlu)
//#define MAPTEX_H 32//meli by se rovnat a byt mocninou dvojky!!!(<=256)


#ifdef __cplusplus
extern "C" {
#endif

extern BOOL EngSamoZnic;

extern int EngUmiram;//flag zda prave animuji sve umirani

extern int EngCumShora;

extern float INIT_ANGLE;//predelavka kvuli vetsi spravedlnosti
//clovek je pri vylezani z bunkru natocen tak jak byl natocen kdyz do nej mizel +180stup

extern char *NazvyZbrani[4][2];

extern float gBitkaTime;
extern float gBasekaTime;

extern float basekaX;
extern float basekaY;//prostredek baseky (pro vraceni se na zakladnu)

extern int LocState;
extern float GlobX;
extern float GlobY;
extern float GlobZoom;//aktualni nastaveni globalni mapky


extern int EngActZbran;
extern BOOL gbRadar;

extern TSpojak <TText> TextInfo;

extern BOOL EngWaitOnCar;
extern BOOL EngHaveACar;

//struktury uziv rophrani
extern TexCont *EngIntMain;//hlavni textura
extern TexCont *EngRadarTex;//hlavni textura
extern TexCont *EngPodTex;//podzemni textura

extern TexCont *RadTex[8];//hlavni textura


//gloabalni promenne pro samotnou hru
extern TMapka *EngMapa;//mapa prostredi
extern TSpojak <TStrela> *EngSStrely;
extern TStatic **EngStatic;//seznam pointru na vsechny staticke objekty
extern CD3DFileObject *AutoModely;
extern CD3DFileObject *StrelaModely;
extern CD3DFileObject *VlajModely;
//extern TCar *EngActCar;
extern TJeep EngJeep;
extern TTank EngTank;
extern TArmo EngArmo;
extern THeli EngHeli;//sablony pro vypocty multiplayeru pomoci starych rutin

extern TJeep EngJeep2;
extern TTank EngTank2;
extern TArmo EngArmo2;
extern THeli EngHeli2;//sablony pro vypocty multiplayeru pomoci starych rutin

extern TZdroje EngZdroj[2];//zdroje pro 1. i 2. stranu
extern BOOL EngEnd[2];//info od tohoto hrace o konci zdroju pro 1. i 2. stranu

extern int EngScore[2];
extern int EngPocetHracu[2];//pocet hracu za jednotliva druzstva
extern int EngPocetEnabHracu[2];//pocet hracu za jednotliva druzstva, kteri jsou aktivni

//extern TSpojak <TZmena> *EngDynam;nove zruseno
//extern DWORD EngNearestTime;//nove zruseno

extern BOOL DEMOmapvis;


//funkce
HRESULT InitMapTextures();
HRESULT DeInitMapTextures();
HRESULT RestoreMapTextures(LPDIRECT3DDEVICE3 pd3dDevice);
HRESULT InvalidateMapTextures();

HRESULT InitInterfaceTex();
HRESULT DeInitInterfaceTex();
HRESULT RestoreInterfaceTex(LPDIRECT3DDEVICE3 pd3dDevice);
HRESULT InvalidateInterfaceTex();
HRESULT RenderInterface(LPDIRECT3DDEVICE3 pd3dDevice,LPDIRECT3DVIEWPORT3 pvViewport, D3DRECT* prcViewRect );
HRESULT RenderInterface2(LPDIRECT3DDEVICE3 pd3dDevice,LPDIRECT3DVIEWPORT3 pvViewport, D3DRECT* prcViewRect,DWORD time );


HRESULT InitLevel(char* strName);
HRESULT DeInitLevel();

HRESULT RenderMap(LPDIRECT3DDEVICE3 pd3dDevice,LPDIRECT3DVIEWPORT3 pvViewport, D3DRECT* prcViewRect,DWORD ftime);
HRESULT RenderRadar(LPDIRECT3DDEVICE3 pd3dDevice,LPDIRECT3DVIEWPORT3 pvViewport, D3DRECT* prcViewRect,DWORD ftime);

HRESULT RenderGame(LPDIRECT3DDEVICE3 pd3dDevice,LPDIRECT3DVIEWPORT3 pvViewport, D3DRECT* prcViewRect,DWORD ftime);

HRESULT InitGameObjects();
HRESULT DeInitGameObjects();

HRESULT RestoreStatic(LPDIRECT3DDEVICE3 pd3dDevice );
HRESULT InvalidateStatic();
/*HRESULT RestoreAnim(LPDIRECT3DDEVICE3 pd3dDevice );
HRESULT InvalidateAnim();*///ted zahrnuto pod TStatic objekty

HRESULT ComputeGame();
HRESULT SetVisible();

HRESULT VeVode(float x,float y);//zjisti zda se tento bod podle mapky nachazi ve vode

void AddTextInfo(char *str);
void ClearTextInfo();

void SetStartPosition(SHIP *ship);
void SetStartGlobPos();//musi uz byt naplnene EngDruzstvo a EndMapa
void ChangeZbran();
//HRESULT GetMyDruzstvo(int &skup);


/*****dyn zmeny mapky****/
//void PridejZmenu(TZmena *zmena);//nove zruseno

// DEMO, co se tyce samotne hry hrace
//void FireStrela();//nove zruseno

#ifdef __cplusplus
}
#endif


#endif

