/*==========================================================================
 *
 *  Copyright (C) 1995-1997 Microsoft Corporation. All Rights Reserved.
 *
 *  File:       gameproc.c
 *  Content:    Game processing code
 *
 *
 ***************************************************************************/
#include <math.h>
#include "engine.h"
#include "dplay\vsichni.h"
#include "main.h"
#include "render.h"
#include "gamebase.h"
#include "dplay\comm.h"
#include "dplay\lobby.h"
#include "dplay\wizard.h"
//#include "dsound.h"
#include "stdio.h"

//directsound
#include "dsutil.h"
#include "dsnd.h"

#include "input.h"
/*
 * Externals
 */
/*
extern DWORD					gdwKeys;
extern LPDIRECTDRAWSURFACE		glpShip0;
extern LPDIRECTDRAWSURFACE		glpShip1;
extern LPDIRECTDRAWSURFACE		glpShip2;
extern LPDIRECTDRAWSURFACE		glpShip3;
extern BOOL						gbShowFrameCount;
extern LPDIRECTDRAWSURFACE		glpNum;
extern BOOL						gbIsHost;
extern BOOL						gbIsActive;
extern LPDPSESSIONDESC2			glpdpSD;
extern HWND						ghWndMain;
extern HINSTANCE				ghinst;
extern BOOL                     gbReliable;
extern BOOL                     gbAsync;
extern BOOL                     gbUseProtocol;
*/
/*
 * Globals
 */
/*
FRAG							gFrags[64];					// ship framents
BLOCKS							gBlocks;					// field layout*/
LPVOID				            glpvReceiveBuffer = NULL;	// buffer to store received messages
DWORD           				gdwReceiveBufferSize = 0;	// size of buffer
/*DPID							gOurID;						// our player id
*/
BOOL							gbHaveHostInit;				// do we need to do host initializaton
/*
int								gnProgramState;				// current state of the game
DWORD							gdwFrameCount;				// used for fps calc
DWORD							gdwFramesLast;				// ..*/
//DWORD							gdwFrameTime;				// ..
BOOL                            gbUpdate;                   // TRUE if player data needs to be updated
/*BOOL                            gbNoField;                  // display blocks ?*/
BOOL                            gbSessionLost;              // did we get disconnected ?

HOSTMSG                         *gHostMsg=NULL;                   // message buffer
DWORD							gHostMsgSize=0;
DWORD							gHostMsgSizeCurNeed=0;
//nutna promenliva velikost

/*BLOCKHITMSG                     gBlockHitMsg;               // ..*/
SHIPHITMSG                      gShipHitMsg;                // ..
ADDSTRELAMSG                     gAddStrelaMsg;               
SCOREMSG                     gScoreMsg;               
SYNCZDROJMSG                     gSyncZdrojMsg;               
ZDROJEMSG                     gZdrojeMsg;               
DELSTRELAMSG                     gDelStrelaMsg;               
CHANGESTATMSG                     gChangeStatMsg;               
CONTROLMSG                      gControlMsg;                // .. 
SYNCMSG                         gSyncMsg;                   // ..

/********compute/render callback values********/
DWORD ComputeCBTime;
LPDIRECT3DDEVICE3 pd3dDeviceCB;
/*
 * Statics
 */

// used to determine new joiner's ship type
// prislusnost k druzstvu
static int         gShipTypesUsed[NUM_SHIP_TYPES];
/*

static double      gDirx[40] =
{
    0.000000,
    0.156434,
    0.309017,
    0.453991,
    0.587785,
    0.707107,
    0.809017,
    0.891007,
    0.951057,
    0.987688,
    1.000000,
    0.987688,
    0.951057,
    0.891007,
    0.809017,
    0.707107,
    0.587785,
    0.453990,
    0.309017,
    0.156434,
    0.000000,
    -0.156435,
    -0.309017,
    -0.453991,
    -0.587785,
    -0.707107,
    -0.809017,
    -0.891007,
    -0.951057,
    -0.987688,
    -1.000000,
    -0.987688,
    -0.951056,
    -0.891006,
    -0.809017,
    -0.707107,
    -0.587785,
    -0.453990,
    -0.309017,
    -0.156434
};

static double      gDiry[40] =
{
    -1.000000,
    -0.987688,
    -0.951057,
    -0.891007,
    -0.809017,
    -0.707107,
    -0.587785,
    -0.453990,
    -0.309017,
    -0.156434,
    0.000000,
    0.156434,
    0.309017,
    0.453991,
    0.587785,
    0.707107,
    0.809017,
    0.891007,
    0.951057,
    0.987688,
    1.000000,
    0.987688,
    0.951057,
    0.891006,
    0.809017,
    0.707107,
    0.587785,
    0.453990,
    0.309017,
    0.156434,
    0.000000,
    -0.156435,
    -0.309017,
    -0.453991,
    -0.587785,
    -0.707107,
    -0.809017,
    -0.891007,
    -0.951057,
    -0.987688
};*/

void SendChangeMess(TStatSpoj *obj,int x,int y,int cim);

/*************preda nam naplnenou sablonu pro pouziti v byvalych rutinach****************/
TCar *MakeCar(LPSHIP lpShip)
{
switch(lpShip->Typ)
	{
	case 0:
		EngJeep.share=lpShip;
		return &EngJeep;
	break;
	case 1:
		EngTank.share=lpShip;
		return &EngTank;
	break;
	case 2:
		EngArmo.share=lpShip;
		return &EngArmo;
	break;
	case 3:
		EngHeli.share=lpShip;
		return &EngHeli;
	break;
	}
return NULL;//error
}

TCar *MakeCar2(LPSHIP lpShip)
{
switch(lpShip->Typ)
	{
	case 0:
		EngJeep2.share=lpShip;
		return &EngJeep2;
	break;
	case 1:
		EngTank2.share=lpShip;
		return &EngTank2;
	break;
	case 2:
		EngArmo2.share=lpShip;
		return &EngArmo2;
	break;
	case 3:
		EngHeli2.share=lpShip;
		return &EngHeli2;
	break;
	}
return NULL;//error
}


/*
 * InitMessageBuffers
 *
 * Sets up buffes used for sending different types of messages
 */

void InitMessageBuffers(void)
{
    if(gHostMsg)
		gHostMsg->byType        = MSG_HOST;
/*    gBlockHitMsg.byType    = MSG_BLOCKHIT;*/
    gShipHitMsg.byType     = MSG_SHIPHIT;
    gAddStrelaMsg.byType    = MSG_ADDSTRELA;
    gScoreMsg.byType    = MSG_SCORE;
    gSyncZdrojMsg.byType    = MSG_SYNCZDROJ;
    gZdrojeMsg.byType    = MSG_ZDROJE;
    gDelStrelaMsg.byType    = MSG_DELSTRELA;
    gChangeStatMsg.byType    = MSG_CHANGESTAT;
    gControlMsg.byType     = MSG_CONTROL; 
    gSyncMsg.byType        = MSG_SYNC;
}


/*
 * LaunchGame
 *
 * Sets up the game layout and launches
 */
void LaunchGame(void)//ok
{
	HRESULT hr;
	CHAR* strFileName;

	ClearTextInfo();

	// initialize message buffers and other module globals
    InitMessageBuffers();
    gbSessionLost = FALSE;

	// get current session description (glpdpSD is initialized in here)
    hr = DPlayGetSessionDesc();
    if (FAILED(hr) || (!glpdpSD))
	{
        ShowError(IDS_DPLAY_ERROR_GSD);
        goto ABORT;
	}

	// Is this session using the DirectPlay Protocol?
	gbUseProtocol = (glpdpSD->dwFlags & DPSESSION_DIRECTPLAYPROTOCOL) != 0;


	// update window title
	UpdateTitle();

	// initialize random number seed
	srand((int)GetTickCount());

	// clear front buffer before changing palette
//	EraseScreen();
//	FlipScreen();nove

    // Begin collecting input
	ReacquireInput();
    //ReacquireInputDevices();

	// init the ship type tracking
	ZeroMemory(gShipTypesUsed, sizeof(gShipTypesUsed));

    // initialize us
  	hr = InitOurShip();
    if (FAILED(hr))
    {
        goto ABORT;
    }//i kdyz zacinam hrat v bunkru, tak se vytvori vozitko, ale jako ....

    // get the field layout
	if( gbIsHost )
	{
/********loadnuti levelu********************/
            AppPause( TRUE );

			//DWORD dwTid;
			//CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE )DoWizard, 0, 0, &dwTid);//pokus
            //DoWizard(NULL);//pokus
            strFileName = PromptUserForFileToLoad( ghWndMain );
			//strFileName = "Pokusny.lev";//pokusy
        
            if( strFileName )
            {
				DeInitLevel();                
                if( FAILED( InitLevel( strFileName ) ) )
                {
					DeInitLevel();//new
                    MessageBox( ghWndMain, TEXT("Error loading specified level file"),
                                TEXT("LevFile"), MB_OK|MB_ICONERROR );
					AppPause( FALSE );
					goto ABORT;
                }
            }
			else
				{
				AppPause( FALSE );
				goto ABORT;
				}

            AppPause( FALSE );
/******************************/
        // initialize field (done only by host)
//        if (!gbNoField)
//            InitField();//predelano

        // we have host initialization
		gbHaveHostInit = TRUE;

        // start updating screen
        gbIsActive = TRUE;
		ReacquireInput();//po open file dialogu jsme ho ztratili
	}
	else
	{
        // get it from host, if we are joining
		gbHaveHostInit = FALSE;
 	}

    // success
    return;

ABORT:
    // something went wrong, terminate game
    ExitGame();
}


/*
 * ExitGame
 *
 * Game termination code
 */

void ExitGame(void)
{
    // shut down app
	PostMessage( ghWndMain, WM_CLOSE, 0, 0 );
}

/*
 * InitOurShip
 *
 * Initializes our ship's initial attributes
 */

HRESULT InitOurShip(void)//ok
{//vsude, kde se inicializuje vozitko, tak je retezec INITOURSHIP
//    int i;
    SHIP ship;
    HRESULT hr;

	// wipe out everything
	ZeroMemory(&ship, sizeof(ship));

	// initialize sound buffers
	InitPlayerLocalSoundData(&ship);

	// calculate ship type based on the number of players in the game
    // we cycle through four ships (Y,R,G,B) for now.
	// This old algorithm's computation will be overridden by HOST_MSG 


	//ship.byType = (BYTE) ((glpdpSD->dwCurrentPlayers-1) % NUM_SHIP_TYPES);
	ship.byType = EngDruzstvo;
	ship.R=INIT_ANGLE;


	gShipTypesUsed[ship.byType] = 1;	// our color
	//casem zrusit, uz se nepouziva

    /*ship.dPosX  = randInt(0,MAX_SHIP_X);
    ship.dPosY  = randInt(0,MAX_SHIP_Y);
    ship.cFrame = randInt(0, MAX_SHIP_FRAME);//predelat na objeveni v bunkru
  */
/*	ship.Fuel=INIT_FUEL;
	ship.Ammo[0]=10;
	ship.Ammo[1]=10;*///jen pro ucel ladeni (bude se inicializovat pri opusteni bunkru)
//nove se vyplni pri doruceni auta

	ship.Typ=0;//vozitko

	ship.bEnable = FALSE;
	ship.bPodzemi= TRUE;//dopichnout podzemi/nepodzemi

    // set our local data
	hr = DPlaySetPlayerData(gOurID, &ship, sizeof(ship), DPSET_LOCAL);
    if (FAILED(hr))
    {
        ShowError(IDS_DPLAY_ERROR_SPLD);
        goto FAIL;
    }

    // no ship fragments
    /*for(i=0; i<64; i++)
        gFrags[i].valid = FALSE;*///nove zruseno

    // success
    return DP_OK;

FAIL:
    // failed
    return hr;
}

/*
 *FUNCTION:   InitPlayerLocalSoundData
 *
 *
 *NOTES:      Takes a ship and initializes ONLY its soundbuffers and sound flags.
 *            It leaves everything else alone.  Good for when going to
 *            full-screen mode, when we need to get rid of the sound buffers
 *            for a bit, but don't want to change the data.
 */

void InitPlayerLocalSoundData(LPSHIP lpShip)
{
/*int i;
    if (gbSoundInitialized)
    {
        for (i=0; i<MAX_SOUNDS; i++)
        {
            if (FALSE == WaveGetBuffers(gSoundEffect[i],&lpShip->lpDirectSoundBuffer[i], &lpShip->lpDirectSound3DBuffer[i]))
            {//if it didn't work, get rid of all the other sound buffers
                ShowError(IDS_DSOUND_DUPBUF);
                for (--i; i>=0; i--)
                {
                    IDirectSoundBuffer_Release(lpShip->lpDirectSoundBuffer  [i]);
                    IDirectSoundBuffer_Release(lpShip->lpDirectSound3DBuffer[i]);
                    lpShip->lpDirectSoundBuffer  [i] = NULL;
                    lpShip->lpDirectSound3DBuffer[i] = NULL;
                }
                return;
            }
        }

        lpShip->bFiring        = FALSE;
        lpShip->bBounced       = FALSE;
        lpShip->bDeath         = FALSE;
        lpShip->bBlockHit      = FALSE;
        lpShip->bEngineRunning = FALSE;
        lpShip->bMoving        = FALSE;
    }
    else
    {
    //if sound initialization has already failed in InitSfx(), then we want the ships'
    //sound buffers to be NULL so that we don't try to release them later.
        for (i=0; i<MAX_SOUNDS; i++)
        {
            lpShip->lpDirectSoundBuffer  [i] = NULL;
            lpShip->lpDirectSound3DBuffer[i] = NULL;
        }
    }*///nove dodelat sounds
};

/*
 *FUNCTION:   SetPlayerLocalSoundDataCB (CALLBACK)
 *
 *PURPOSE:    Initializes and registers a player's local SOUND data ONLY.
 */
/*
BOOL WINAPI SetPlayerLocalSoundDataCB(DPID dpId, DWORD dwPlayerType, LPCDPNAME lpName, 
				   	                  DWORD dwFlags, LPVOID lpContext)
{
	SHIP ship;
    DWORD dwSize = sizeof(ship);
    HRESULT hr;

    DPlayGetPlayerData(dpId, &ship, &dwSize, DPGET_LOCAL); 

	// no player data yet
	if (0 == dwSize)
		return TRUE;

    InitPlayerLocalSoundData(&ship);

	hr = DPlaySetPlayerData(dpId, &ship, dwSize, DPSET_LOCAL);
    return (DP_OK == hr);
};
*/
/*
 *FUNCTION:   InitLocalSoundData
 *
 *PURPOSE:    Initializes and registers all players' sound data ONLY
 */
/*
HRESULT InitLocalSoundData(void)
{
    HRESULT hr;
	hr = DPlayEnumPlayers(&(glpdpSD->guidInstance), SetPlayerLocalSoundDataCB, NULL, 0);
    return hr;
}
*/
/*
 *FUNCTION:   ReleaseLocalSoundData
 *
 *NOTES:      Releases a single ship's local sound buffers.
 */

void ReleasePlayerLocalSoundData(LPSHIP lpShip)
{
/*int i;

    if (gbSoundInitialized)
    {
        for (i=0; i<MAX_SOUNDS; i++)
        {
            if (lpShip->lpDirectSoundBuffer[i] != NULL)
            {
                IDirectSoundBuffer_Stop     (lpShip->lpDirectSoundBuffer[i]);
                IDirectSoundBuffer_Release  (lpShip->lpDirectSoundBuffer[i]);
                lpShip->lpDirectSoundBuffer[i] = NULL;
            }

            if (lpShip->lpDirectSound3DBuffer[i] != NULL)
            {
                IDirectSound3DBuffer_Release(lpShip->lpDirectSound3DBuffer[i]);	
                lpShip->lpDirectSound3DBuffer[i] = NULL;
            }
        }
    }*///dodelat
};

/*
 *FUNCTION:   ReleasePlayerLocalData  (CALLBACK)
 *
 *PURPOSE:    Retrieves and releases a player's local data from dplay.
 */
BOOL WINAPI ReleasePlayerLocalDataCB(DPID dpId, DWORD dwPlayerType, LPCDPNAME lpName,
					                 DWORD dwFlags, LPVOID lpContext)
{
	SHIP ship;
    DWORD dwSize = sizeof(SHIP);    
    HRESULT hr;
	
    hr = DPlayGetPlayerData(dpId, &ship, &dwSize, DPGET_LOCAL);
    if (FAILED(hr))
    {
        TRACE(TEXT("Get Player local data failed for id %d\n"), dpId);
        goto FAIL;
    }

	// no player data yet
	if (0 == dwSize)
		return TRUE;

    ReleasePlayerLocalSoundData(&ship);

    hr = DPlaySetPlayerData(dpId, &ship,  dwSize, DPSET_LOCAL);
    if (FAILED(hr))
    {
        TRACE(TEXT("Set Player local data failed for id %d\n"), dpId);
        goto FAIL;
    }

    // success
	return TRUE;
FAIL:
    // we failed
    return FALSE;
}

/*
 *FUNCTION:   ReleaseLocalData
 *
 *PURPOSE:    Releases local data of ALL players.
 */

void ReleaseLocalData(void)
{
     HRESULT hr;

     if (gnProgramState == PS_ACTIVE)
     {
         hr = DPlayEnumPlayers(&(glpdpSD->guidInstance), ReleasePlayerLocalDataCB, NULL, 0);
         if (FAILED(hr))
         {
             ShowError(IDS_DPLAY_ERROR_EP);
         }
     }
};

/*
 * ProcessUserInput
 *
 * Processes any input from the user and updates our ship state
 */

void ProcessUserInput(LPSHIP lpShip)//ok krome SOUND
{
    static DWORD dwOldKeys = 0;
    DWORD dwTickCount;
    static DWORD dwFireLastTick = 0;

    gbUpdate = FALSE;

    // DSOUND: check if the engine was turned off
/*    if (!(gdwKeys    & (KEY_DOWN | KEY_UP)) && 
		(dwOldKeys & (KEY_DOWN | KEY_UP)))
    {
        gdwKeys |= KEY_ENGINEOFF;

        gControlMsg.byState = (BYTE) gdwKeys;
        // let everyone know that we just turned our engine off
        SendGameMessage((LPGENERICMSG) &gControlMsg, DPID_ALLPLAYERS);
    }*///predelat new

    // update our ship state
    UpdateState(lpShip, gdwKeys);
/************nove*************/
    dwTickCount = timeGetTime();
	if((gdwKeys & (KEY_FIRE1|KEY_FIRE2))&&_hypot(lpShip->X-basekaX,lpShip->Y-basekaY)<BASEKA_LEN)
		{
		if(gBitkaTime>BASEKA_TIME)
			{//uz je mozny navrat do baseky
//			DestroyShip(&PlayerBuf[i]);neni vlastne znicena
			EngAppState=2;//podzemi, vlezl OK
			gBasekaTime=0;

			INIT_ANGLE=lpShip->R+g_PI;
			/*******je tu moznost zvysit skore*******/
			if(lpShip->Typ==0&&lpShip->Vlajecka)
				{//vezu vlajecku, jupiii
				//musim tedy updatenout score!!
				EngScore[EngDruzstvo]++;

				gScoreMsg.score[0]=EngScore[0];
				gScoreMsg.score[1]=EngScore[1];
				gScoreMsg.zmena[0]=0;
				gScoreMsg.zmena[1]=0;
				gScoreMsg.zmena[EngDruzstvo]++;

				SendGameMessage((LPGENERICMSG) &gScoreMsg,DPID_ALLPLAYERS);
				}
			
			lpShip->dwLastTick = timeGetTime();
			lpShip->bEnable = FALSE;
			SendSync(lpShip);
			//************vraceni zdroju*************
			EngZdroj[EngDruzstvo].NCar[lpShip->Typ]++;
			if(lpShip->Typ==2)
				{//miny omezene, vracet
				EngZdroj[EngDruzstvo].NMina+=lpShip->Ammo[1];
				}
			if(gbIsHost)//lokalne
				{//upravy rozeslat
				/******sync zdroje*****/
				gSyncZdrojMsg.zdroje[0]=EngZdroj[0];
				gSyncZdrojMsg.zdroje[1]=EngZdroj[1];
				SendGameMessage((LPGENERICMSG) &gSyncZdrojMsg,DPID_ALLPLAYERS);
				}
			else
				{//uvedomit server o navraceni auta
			    gZdrojeMsg.Host=false;
				gZdrojeMsg.What=lpShip->Typ+128;
				gZdrojeMsg.Miny=0;
				if(lpShip->Typ==2)//miny omezene, navracet zbytek
					{
					gZdrojeMsg.Miny=lpShip->Ammo[1];
					}
				gZdrojeMsg.Skup=EngDruzstvo;
				SendGameMessage((LPGENERICMSG) &gZdrojeMsg,DPID_ALLPLAYERS );
				}
			}
		}
	else//u baseky to holt nestrili
	if((gdwKeys & (KEY_FIRE1|KEY_FIRE2))&&((dwTickCount - dwFireLastTick) > FIRE_INTERVAL) )
		{//dopichnout vypusteni strely
		TStrela *nova;
		float speed;
		if(!(lpShip->Ammo[EngActZbran]))
			{//beep, neni strelivo!!
			}
		else
			{
			lpShip->Ammo[EngActZbran]--;
			switch(lpShip->Typ)
				{
				case 0://jeep
					nova=new TStrela;
					if(!nova)return;//problem s pameti
					nova->gid.time=dwTickCount;
					nova->gid.pid=gOurID;
					nova->Typ=2;//0obyc 1raketa 2granat
					nova->Vyska=0;//na granat nema vliv
					nova->X=lpShip->X;//aktualni pozice
					nova->Y=lpShip->Y;
					nova->Dolet=2.0;//kolik ji zbyva uletet (doladit)
					nova->From=0;//vystrelena z jeepu
					if(gdwKeys & KEY_FIRE1)//hazi granaty dopredu
						{//pouze granaty
						nova->dX=(float)cos(lpShip->R)*(0.8f);//doladit
						nova->dY=(float)sin(lpShip->R)*(0.8f);
						}
					else//hazi granaty dozadu
						{//pouze granaty
						nova->dX=-(float)cos(lpShip->R)*(0.8f);//doladit
						nova->dY=-(float)sin(lpShip->R)*(0.8f);
						}
					gAddStrelaMsg.strela=*nova;//informovat ostatni
					SendGameMessage((LPGENERICMSG) &gAddStrelaMsg, DPID_ALLPLAYERS);

					EngSStrely->Add(nova);//update svoje strely
					if(bWantSound)
						{//SNDPREDELAT
						SndObjStop(hsoGunShot);
						SndObjPlay(hsoGunShot,0);
						}
					
					dwFireLastTick=dwTickCount;
				break;
				case 1://tank
					nova=new TStrela;
					if(!nova)return;//problem s pameti
					nova->gid.time=dwTickCount;
					nova->gid.pid=gOurID;
					nova->Typ=0;//0obyc 1raketa 2granat
					nova->X=lpShip->X;//aktualni pozice
					nova->Y=lpShip->Y;
					nova->Dolet=5.0;//kolik ji zbyva uletet (doladit)
					nova->From=1;

					speed=1.3f;

					nova->dX=(float)cos(lpShip->R+lpShip->RHlav)*(speed);//doladit
					nova->dY=(float)sin(lpShip->R+lpShip->RHlav)*(speed);

					nova->X+=nova->dX*0.15f/speed;
					nova->Y+=nova->dY*0.15f/speed;//aby vyletavalo z konce hlavne
					if(gdwKeys & KEY_FIRE1)//strily po zemi
						{
						nova->Vyska=0;
						}
					else//strily do vzduchu
						{
						nova->Vyska=1;
						}
					gAddStrelaMsg.strela=*nova;//informovat ostatni
					SendGameMessage((LPGENERICMSG) &gAddStrelaMsg, DPID_ALLPLAYERS);

					EngSStrely->Add(nova);//update svoje strely
					if(bWantSound)
						{//SNDPREDELAT
						SndObjStop(hsoGunShot);
						SndObjPlay(hsoGunShot,0);
						}
					
					dwFireLastTick=dwTickCount;
				break;
				case 2://armo
					if(EngActZbran==1)//mina, dodelat
						{
						int mpx,mpy;
						mpx=(int)(lpShip->X);
						mpy=(int)(lpShip->Y);
						if(mpx>=0&&mpx<EngMapa->SizeX&&mpy>=0&&mpy<EngMapa->SizeY)
							{//jistota, abychom nevylezliz mapky!!!
							TStatSpoj *temp=new TStatSpoj;
							temp->Index=15;//mina
							temp->X=lpShip->X-(float)mpx;
							temp->Y=lpShip->Y-(float)mpy;
							temp->R=lpShip->R;
							temp->gid.time=timeGetTime();
							temp->gid.pid=gOurID;
							temp->dw_t=temp->gid.time;
							EngMapa->Mapa[mpx+mpy*EngMapa->SizeX].Spojak->Add(temp);
							SendChangeMess(temp,mpx,mpy,-1);
							}
						dwFireLastTick=dwTickCount;
						}
					else
						{//raketa
						nova=new TStrela;
						if(!nova)return;//problem s pameti
						nova->gid.time=dwTickCount;
						nova->gid.pid=gOurID;
						nova->X=lpShip->X;//aktualni pozice
						nova->Y=lpShip->Y;
						nova->From=2;
						nova->Typ=1;//0obyc 1raketa 2granat
						nova->Dolet=15.0;//kolik ji zbyva uletet (doladit)

						speed=2.3f;

						nova->dX=(float)cos(lpShip->R)*(speed);//doladit
						nova->dY=(float)sin(lpShip->R)*(speed);

						if(gdwKeys & KEY_FIRE1)//strily po zemi
							{
							nova->X+=nova->dX*0.25f/speed;
							nova->Y+=nova->dY*0.25f/speed;//aby vyletavalo z konce hlavne
							nova->Vyska=0;
							}
						else//strily do vzduchu
							{
							nova->Vyska=1;
							}
						gAddStrelaMsg.strela=*nova;//informovat ostatni
						SendGameMessage((LPGENERICMSG) &gAddStrelaMsg, DPID_ALLPLAYERS);

						EngSStrely->Add(nova);//update svoje strely
						if(bWantSound)
							{//SNDPREDELAT
							SndObjStop(hsoGunShot);
							SndObjPlay(hsoGunShot,0);
							}
						
						dwFireLastTick=dwTickCount;
						}
				break;
				case 3://heli
					nova=new TStrela;
					if(!nova)return;//problem s pameti
					nova->gid.time=dwTickCount;
					nova->gid.pid=gOurID;
					nova->X=lpShip->X;//aktualni pozice
					nova->Y=lpShip->Y;
					nova->From=3;
					if(EngActZbran==1)//basic
						{
						nova->Typ=0;//0obyc 1raketa 2granat
						nova->Dolet=5.0;//kolik ji zbyva uletet (doladit)

						speed=1.3f;

						nova->dX=(float)cos(lpShip->R)*(speed);//doladit
						nova->dY=(float)sin(lpShip->R)*(speed);

						if(gdwKeys & KEY_FIRE2)//strily po zemi
							{
							nova->Vyska=0;
							}
						else//strily do vzduchu
							{
							nova->X+=nova->dX*0.25f/speed;
							nova->Y+=nova->dY*0.25f/speed;//aby vyletavalo z konce hlavne
							nova->Vyska=1;
							}
						}
					else
						{//raketa
						nova->Typ=1;//0obyc 1raketa 2granat
						nova->Dolet=15.0;//kolik ji zbyva uletet (doladit)

						speed=2.3f;

						nova->dX=(float)cos(lpShip->R)*(speed);//doladit
						nova->dY=(float)sin(lpShip->R)*(speed);

						if(gdwKeys & KEY_FIRE2)//strily po zemi
							{
							nova->Vyska=0;
							}
						else//strily do vzduchu
							{
							nova->X+=nova->dX*0.25f/speed;
							nova->Y+=nova->dY*0.25f/speed;//aby vyletavalo z konce hlavne
							nova->Vyska=1;
							}
						}
					gAddStrelaMsg.strela=*nova;//informovat ostatni
					SendGameMessage((LPGENERICMSG) &gAddStrelaMsg, DPID_ALLPLAYERS);

					EngSStrely->Add(nova);//update svoje strely
					if(bWantSound)
						{//SNDPREDELAT
						SndObjStop(hsoGunShot);
						SndObjPlay(hsoGunShot,0);
						}
					
					dwFireLastTick=dwTickCount;
				break;
				}
			}
		}

	if(dwOldKeys!=gdwKeys)//update keys
		gbUpdate = TRUE;
/**********nove******************/		

    // remember current keys for next frame
    dwOldKeys = gdwKeys;
}

/*
 * UpdateState
 *
 * Updates the current state of our ship, given user input
 */

void UpdateState(LPSHIP lpShip, DWORD dwControls)//ok
{//ok               ************ostatni veci v Move u kazdeho hrace*************
//	static DWORD dwTimePrevUpdate = 0;
//	DWORD dwTimeNow = timeGetTime();
	
	lpShip->dwKeys = dwControls;

	// Don't accept these keyboard inputs faster than 50
	// times per second (every 20 ms)
/*	if (dwTimeNow - dwTimePrevUpdate > 20)
	{
		if( dwControls & KEY_LEFT )
		{
			gbUpdate = TRUE;
			lpShip->cFrame -= 1;
			if( lpShip->cFrame < 0 )
				lpShip->cFrame += MAX_SHIP_FRAME;
		}
		if( dwControls & KEY_RIGHT )
		{
			gbUpdate = TRUE;
			lpShip->cFrame += 1;
			if( lpShip->cFrame >= MAX_SHIP_FRAME )
				lpShip->cFrame -= MAX_SHIP_FRAME;
		}
		if( dwControls & KEY_UP )
		{
			gbUpdate = TRUE;
			lpShip->dVelX += gDirx[lpShip->cFrame] * 10.0 / 1000.0;
			lpShip->dVelY += gDiry[lpShip->cFrame] * 10.0 / 1000.0;
		}
		if( dwControls & KEY_DOWN )
		{
			gbUpdate = TRUE;
			lpShip->dVelX -= gDirx[lpShip->cFrame] * 10.0 / 1000.0;
			lpShip->dVelY -= gDiry[lpShip->cFrame] * 10.0 / 1000.0;
		}//new predelat
		dwTimePrevUpdate = dwTimeNow;
	}*/

/*    if( dwControls & KEY_STOP )
    {
        gbUpdate = TRUE;
        lpShip->dVelX = 0.0;
        lpShip->dVelY = 0.0;
    }*///predelat new
/*    if( !lpShip->bBulletEnable && lpShip->bEnable )
    {
		if( dwControls & KEY_FIRE )
		{
            gbUpdate = TRUE;
			// launch a new bullet
			lpShip->dBulletPosX = (WORD) (gDirx[lpShip->cFrame]*6.0 + 16.0 + lpShip->dPosX);
			lpShip->dBulletPosY = (WORD) (gDiry[lpShip->cFrame]*6.0 + 16.0 + lpShip->dPosY);
			lpShip->dBulletVelX = gDirx[lpShip->cFrame]*500.0/1000.0;
			lpShip->dBulletVelY = gDiry[lpShip->cFrame]*500.0/1000.0;
			lpShip->bBulletEnable = TRUE;
			lpShip->dwBulletFrame = 0;
		}
    }*///predelat tohle cele new
}//ok

/*
 * SendSync
 *
 * Sends a sync message with the rendevous position. We are using a synchronization technique in
 * which every player informs everyone else where the player is going to be at the end of the 
 * next sync interval. Based on this rendezvous position, everyone tries to move their corresponding
 * ghosts to the rendezvous position by the end of the interval.
 */
 /*************PREDELANO****************/
 //sdelujeme jinemu hraci, kde jsme nyni
 //on podle stisknutych klaves (nasich, ty mu prubezne posilame)
 //pocita postupne simulaci pohybu naseho vozidla a snazi se zaroven dohnat odchylku
 //kterou mel v dobe synchronizace

void SendSync(LPSHIP lpShip)//ok
{//nova verze
gSyncMsg.byShipType = lpShip->byType;
gSyncMsg.Typ = lpShip->Typ;
gSyncMsg.X  = lpShip->X;
gSyncMsg.Y  = lpShip->Y;
gSyncMsg.R  = lpShip->R;//to uz jsou budouci hodnoty

gSyncMsg.Vlajecka  = lpShip->Vlajecka;

gSyncMsg.RHlav = lpShip->RHlav;//nove pridano
//gSyncMsg.Z  = lpShip->Z;

gSyncMsg.Fuel = lpShip->Fuel>0;

gSyncMsg.bPodzemi= lpShip->bPodzemi;
gSyncMsg.bEnable= lpShip->bEnable;
gSyncMsg.rych= lpShip->rych;
gSyncMsg.normrych= lpShip->normrych;
gSyncMsg.keys= gdwKeys;
SendGameMessage((LPGENERICMSG) &gSyncMsg, DPID_ALLPLAYERS);
/*gSyncMsg.byShipType = lpShip->byType;
gSyncMsg.Typ = lpShip->Typ;
//------musim odhadnout budouci pozici auta
SHIP temp=*lpShip;
TCar *car=MakeCar(&temp);
for(int i=0;i<MIN_COMPUTE_FPS;i++)
	car->Move(temp.dwKeys,1.0f/((float)MIN_COMPUTE_FPS));//pohyb v delce 1 sekunda!!
gSyncMsg.X  = temp.X;
gSyncMsg.Y  = temp.Y;
gSyncMsg.R  = temp.R;//to uz jsou budouci hodnoty
gSyncMsg.bPodzemi= temp.bPodzemi;
SendGameMessage((LPGENERICMSG) &gSyncMsg, DPID_ALLPLAYERS);*/
}//ok

/*
 * UpdateDisplayStatus
 *
 * Updates the disable timeout. Enables the ship if disable timeout has elapsed.
 */

/*void UpdateDisplayStatus(LPSHIP lpShip)//ok
{//nove cele zruseno
    DWORD dwTickDiff;
    DWORD dwTickCount;

    // current time
    dwTickCount = timeGetTime();

    // time elapsed since last update
    dwTickDiff =  dwTickCount - lpShip->dwLastTick;

    // timestamp
    lpShip->dwLastTick = dwTickCount;

    // update time-out
    lpShip->iCountDown -= dwTickDiff;

    // time-out ?
	if( lpShip->iCountDown < 0 )
	{
        // get new position and enable our lpShip
	    lpShip->dPosX = randInt(0,MAX_SHIP_X);
	    lpShip->dPosY = randInt(0,MAX_SHIP_Y);
	    lpShip->cFrame = randInt(0, MAX_SHIP_FRAME);
		lpShip->bEnable = TRUE;//predelat new
	}
}*/

/*
 * UpdatePosition
 *
 * Updates our ship's position
 */

/*void UpdatePosition(DPID dpId, LPSHIP lpShip )
{//bude se rusit, pouze prohledni messages
    int     x,y;new predelat
    BYTE    oldxCell, oldyCell, newxCell, newyCell, mask, col, row;
    double  thisTick, totalTick, xtick, ytick;
    DWORD   dwTickCount;
    DWORD   dwTickDiff;

    if( !lpShip->bEnable )
        return;

    // how long has it been since we last updated
    dwTickCount = timeGetTime();
    dwTickDiff = dwTickCount - lpShip->dwLastTick;

    // current timestamp
    lpShip->dwLastTick = dwTickCount;

	oldxCell = (int)(lpShip->dPosX+16.0) >> 4;
	oldyCell = (int)(lpShip->dPosY+16.0) >> 4;

    // compute new position
    lpShip->dPosX += lpShip->dVelX * dwTickDiff;
    lpShip->dPosY += lpShip->dVelY * dwTickDiff;

	newxCell = (int)(lpShip->dPosX+16.0) >> 4;
	newyCell = (int)(lpShip->dPosY+16.0) >> 4;
	if(oldxCell != newxCell)
	{
        // we allow ghosts to pass through the blocks
		if( (dpId == gOurID) && IsHit( newxCell, newyCell ) )
		{
			if( lpShip->dVelX > 0.0 )
				lpShip->dPosX = (oldxCell << 4) + 15 - 16;
			else
				lpShip->dPosX = (oldxCell << 4) - 16;
			lpShip->dVelX = -lpShip->dVelX*0.9;
			newxCell = oldxCell;
            lpShip->bBounced = TRUE;
		}
	}
	if(oldyCell != newyCell)
	{
        // we allow ghosts to pass through the blocks
		if( (dpId == gOurID) && IsHit( newxCell, newyCell ) )
		{
			if( lpShip->dVelY > 0.0 )
				lpShip->dPosY = (oldyCell << 4) + 15 - 16;
			else
				lpShip->dPosY = (oldyCell << 4) - 16;

            lpShip->dVelY = -lpShip->dVelY*0.9;
            lpShip->bBounced = TRUE;
	    }
	}

    if( lpShip->dPosX > MAX_SHIP_X )
    {
        lpShip->dPosX = MAX_SHIP_X;
        lpShip->dVelX = -lpShip->dVelX*0.9;
        lpShip->bBounced = TRUE;
    }
    else if ( lpShip->dPosX < 0 )
    {
        lpShip->dPosX =0;
        lpShip->dVelX = -lpShip->dVelX*0.9;
        lpShip->bBounced = TRUE;
    }
    if( lpShip->dPosY > MAX_SHIP_Y )
    {
        lpShip->dPosY = MAX_SHIP_Y;
        lpShip->dVelY = -lpShip->dVelY*0.9;
        lpShip->bBounced = TRUE;
    }
    else if ( lpShip->dPosY < 0 )
    {
        lpShip->dPosY =0;
        lpShip->dVelY = -lpShip->dVelY*0.9;
        lpShip->bBounced = TRUE;
    }    

    if ((dpId == gOurID) && lpShip->bBounced)
    {
        SendSync(lpShip);
    }

    if( !lpShip->bBulletEnable )
        return;

    // update the active bullet
    lpShip->dwBulletFrame += dwTickDiff;
    if( lpShip->dwBulletFrame >= MAX_BULLET_FRAME )
    {
        lpShip->bFiring = FALSE;
        lpShip->bBulletEnable = FALSE;
		return;
    }


    if( lpShip->dBulletVelX != 0.0 )
		xtick = 8.0/lpShip->dBulletVelX;
    else
        xtick = 999999.0;

    if( lpShip->dBulletVelY != 0.0 )
		ytick = 8.0/lpShip->dBulletVelY;
    else
        ytick = 999999.0;

    if( xtick < 0.0 )
        xtick = -xtick;
    if( ytick < 0.0 )
        ytick = -ytick;

    if( xtick < ytick )
        thisTick = xtick;
    else
        thisTick = ytick;
	
    if( thisTick > dwTickDiff )
        thisTick = dwTickDiff;
	        
    for( totalTick = 0.0; totalTick < dwTickDiff; )
    {
        totalTick += thisTick;

        lpShip->dBulletPosX += lpShip->dBulletVelX * thisTick;
        lpShip->dBulletPosY += lpShip->dBulletVelY * thisTick;

        if( lpShip->dBulletPosX > MAX_BULLET_X )
        {
            lpShip->dBulletPosX = MAX_BULLET_X;
            lpShip->dBulletVelX = -lpShip->dBulletVelX*0.9;
        }
        else if ( lpShip->dBulletPosX < 0 )
        {
            lpShip->dBulletPosX =0;
            lpShip->dBulletVelX = -lpShip->dBulletVelX*0.9;
        }
        if( lpShip->dBulletPosY > MAX_BULLET_Y )
        {
            lpShip->dBulletPosY = MAX_BULLET_Y;
            lpShip->dBulletVelY = -lpShip->dBulletVelY*0.9;
        }
        else if ( lpShip->dBulletPosY < 0 )
        {
            lpShip->dBulletPosY =0;
            lpShip->dBulletVelY = -lpShip->dBulletVelY*0.9;
        }
    
        // check to see if it hit anything
        x = (int)(lpShip->dBulletPosX + 0.5) + 1;
        y = (int)(lpShip->dBulletPosY + 0.5) + 1;
	
        row = y >> 4;
        col = x >> 4;
        mask = 1 << (col & 0x7);
        col = col >> 3;
        if( gBlocks.bits[row][col] & mask )
        {
			// dwScored a block hit
            gBlockHitMsg.byRow = row;
            gBlockHitMsg.byCol = col;
            gBlockHitMsg.byMask = mask;
			SendGameMessage((LPGENERICMSG) &gBlockHitMsg, DPID_ALLPLAYERS);

			gBlocks.bits[row][col] &= ~mask;
			lpShip->dwScore += 10;
			lpShip->bBulletEnable = FALSE;
            lpShip->bBlockHit = TRUE;
            lpShip->bFiring   = FALSE;
        }
    }
}*///nove zruseno


/*
 * IsHit
 *
 * Tells if there is a block at (x,y) location
 */
/*
BOOL IsHit( int x, int y )
{
    int col, mask;
    
    // outside screen boundaries?
    if( (x < 0) || (y < 0) || (x >= 40) || (y >= 30) )
        return TRUE;
	
    // look at the block bits
    mask = 1 << (x & 0x7);
    col = x >> 3;
    if( gBlocks.bits[y][col] & mask )
        return TRUE;
    else
        return FALSE;
}
*/
/*
 * InitField
 *
 * Initializes block positions on the field
 */
/*
void InitField(void)
{
    int i, x, y;
    
    // clear all gBlocks
    for(x=0; x<5; x++)
        for(y=0; y<30; y++)
		    gBlocks.bits[y][x] = 0;

    // set random gBlocks
    for(i=0; i<400; i++)
    {
        x = randInt(0, 40);
		y = randInt(0, 30);
		if( !setBlock(x, y) ) i--;
    }
}
*/
/*
 * AddBlock
 *
 * Adds a block to the field
 */
/*
void AddBlock(void)
{
	int x,y;

    // maybe add a block?
	if(gbIsHost && gbIsActive && ( randInt( 0, 100 ) > 98 ))
	{
		x = randInt( 0, 40);
		y = randInt( 0, 30);
		if( setBlock( x, y) )
		{
            gAddBlockMsg.byX    = (BYTE) x;
            gAddBlockMsg.byY    = (BYTE) y;
			SendGameMessage((LPGENERICMSG) &gAddBlockMsg, DPID_ALLPLAYERS);
		}
	}
}
*/
/*
 * setBlock
 *
 * Turns on a block
 */
/*
BOOL setBlock( int x, int y )
{
    BYTE  mask, col;

    mask = 1 << (x & 0x7);
    col = x >> 3;
    
    // is Block already set?
    if( gBlocks.bits[y][col] & mask )
        return FALSE;
	
    // set the block and return success
    gBlocks.bits[y][col] |= mask;
    return TRUE;
}
*/
/*
 * AddFrag
 *
 * Turns on a fragment
 */
/*
void AddFrag(LPSHIP lpShip, int offX, int offY)
{
    int i;
    for(i=0; i<64; i++) // find available fragment
    {
        if( !gFrags[i].valid )
	    break;
    }
    if( i == 64 )
        return;
	
    
    gFrags[i].dPosX = offX + lpShip->dPosX;
    gFrags[i].dPosY = offY + lpShip->dPosY;
    switch( lpShip->byType )
    {
    case 0: gFrags[i].surf = glpShip0;    break;
    case 1: gFrags[i].surf = glpShip1;    break;
    case 2: gFrags[i].surf = glpShip2;    break;
    case 3: gFrags[i].surf = glpShip3;    break;
	default: TRACE(TEXT("Unknown ship type\n")); return;
    }
    gFrags[i].src.top = 32 * ( (int)lpShip->cFrame / 10 ) + offX;
    gFrags[i].src.left = 32 * ( (int)lpShip->cFrame % 10 ) + offY;
    gFrags[i].src.right = gFrags[i].src.left + 8;
    gFrags[i].src.bottom = gFrags[i].src.top + 8;
    gFrags[i].dVelX = ((double)offX - 12.0)/24.0;
    gFrags[i].dVelY = ((double)offY - 12.0)/24.0;
    gFrags[i].valid = TRUE;
}
*/
/*
 * UpdateFragment
 *
 * Updates the position of a fragment
 */
/*
void UpdateFragment(int i)
{
    DWORD   dwTickCount;
    static DWORD   dwTickDiff;
    static DWORD dwLastTick;

    if( i == 0)
    {
        dwTickCount = timeGetTime();
        dwTickDiff = dwTickCount - dwLastTick;
        dwLastTick = dwTickCount;
    }
    
    if( !gFrags[i].valid )
        return;
	
    gFrags[i].dPosX += (int) (gFrags[i].dVelX * dwTickDiff);
    gFrags[i].dPosY += (int) (gFrags[i].dVelY * dwTickDiff);
    if( (gFrags[i].dPosX < 0.0) || (gFrags[i].dPosX >= 632.0) ||
        (gFrags[i].dPosY < 0.0) || (gFrags[i].dPosY >= 472.0) )
    {
        gFrags[i].valid = FALSE;
    }
}
*/
/*
 * DestroyShip
 *
 * Renders a bunch of fragments to show that the ship is destroyed
 */

void DestroyShip( LPSHIP lpShip ,int flag=0)
{
	// Set flag for explosion sound//new predelat
//	lpShip->bDeath  = TRUE;dodelat sounds!!

//    AddFrag(lpShip, 24, 24);pridat strepiny

// turn it off
	lpShip->bEnable = FALSE;

if(flag==0)
	{//nicim vlastni lod, je treba informovat ostatni o pridani hrobu
	int mpx,mpy;
	mpx=(int)(lpShip->X);
	mpy=(int)(lpShip->Y);
	if(mpx>=0&&mpx<EngMapa->SizeX&&mpy>=0&&mpy<EngMapa->SizeY)
		{//jistota, abychom nevylezliz mapky!!!
		TStatSpoj *temp=new TStatSpoj;
		temp->Index=17;//rip
		temp->X=lpShip->X-(float)mpx;
		temp->Y=lpShip->Y-(float)mpy;
		temp->R=lpShip->R;
		temp->gid.time=timeGetTime();
		temp->gid.pid=gOurID;
		temp->dw_t=temp->gid.time;
		EngMapa->Mapa[mpx+mpy*EngMapa->SizeX].Spojak->Add(temp);
		SendChangeMess(temp,mpx,mpy,-1);
		}
	}

    // Play explosion sound
    ProcessSoundFlags(lpShip);
}

/*
 * UpdateFrame
 *
 * Refreshes the screen
 */

BOOL UpdateFrame( void )
{
    DWORD dwTickCount;
    SHIP  ship;
    DWORD dwSize;
    HRESULT hr;
    static dwSyncLastTick = 0;
    static dwUpdateLastTick = 0;
    static dwLobbyMsgLastTick = 0;
    
    switch( gnProgramState )
    {
    case PS_ACTIVE://ok
        // DINPUT: use DirectInput to read game-play keys
//	    DI_ReadKeys();
		if(gbIsActive)
			gdwKeys = ReadGameInput();
		else
			gdwKeys = 0;
		//new

        // get our local data
        dwSize = sizeof(ship);
        hr = DPlayGetPlayerData(gOurID, &ship, &dwSize, DPGET_LOCAL);
        if (FAILED(hr))
        {
            TRACE(TEXT("Get Player local data failed for id %d\n"), gOurID);
            goto FAIL;
        }

        if (!ship.bEnable)
        {
            // update disable timeout and display status
            //UpdateDisplayStatus(&ship);//casem dodelat pausy po sestreleni, ale jinak
        }
        else
        {
            // process any change in game controls 
            ProcessUserInput(&ship);

            dwTickCount = timeGetTime();

            // synchronize if it's time
            if (gbIsActive && ((dwTickCount - dwSyncLastTick) > SYNC_INTERVAL))
            {
                SendSync(&ship);
                dwSyncLastTick = dwTickCount;
            }

            // if our player changed any keys, let everyone know
            if (gbUpdate)
            {
                // control the number of packets we send
                if ((dwTickCount - dwUpdateLastTick) > UPDATE_INTERVAL)
                {
        		    // let others know
                    gControlMsg.byState = (BYTE) gdwKeys;
                    SendGameMessage((LPGENERICMSG) &gControlMsg, DPID_ALLPLAYERS);
                    dwUpdateLastTick = dwTickCount;
                }
            }

			// if connected to a lobby, occasionally report score as a property
			if (DoingLobbyMessages() && 
				(dwTickCount - dwLobbyMsgLastTick) > 10000)	// every 10 sec
			{
                DPLDATA_PLAYERSCORE playerScore;
				ZeroMemory(&playerScore, sizeof(DPLDATA_PLAYERSCORE));
				playerScore.dwScoreCount = 1;
				playerScore.Score[0] = EngScore[EngDruzstvo];//nove predelano
				LobbyMessageSetProperty(&DPLPROPERTY_PlayerScore, &playerScore,
										 sizeof(DPLDATA_PLAYERSCORE));
				dwLobbyMsgLastTick = dwTickCount;
			}
        }

	    // save ship data as RenderPlayerCB reads stored data
	    hr = DPlaySetPlayerData(gOurID, &ship, sizeof(ship), DPSET_LOCAL);
        if (FAILED(hr))
        {
            ShowError(IDS_DPLAY_ERROR_SPLD);
            goto FAIL;
        }   

		// update fragments
/*		for(i=0; i<64; i++)
			UpdateFragment(i);*///zruseno new

    	// add a block
/*        if (!gbNoField)
    	    AddBlock();*///zruseno new
/*********************///dopichnout
        // render everything		
        if (FAILED( Render3DEnvironment()))
        {
			MessageBox( NULL, TEXT("An error occurred during rendering."
				"\n\nThis DXBitka DEMO will now exit"),
					g_strAppTitle, MB_ICONERROR|MB_OK );
            goto FAIL;
        }
        break;//ok

    case PS_REST:
		if( gbHaveHostInit )
		{
//			SetGamePalette();new
			gnProgramState = PS_ACTIVE;
		}
		break;
	case PS_SPLASH:
	    if( FAILED( Render3DEnvironment() ) )//kvuli vyplneni plochy, aby tam nebyly nesmysly
			{
			MessageBox( NULL, TEXT("An error occurred during rendering."
				"\n\nThis DXBitka DEMO will now exit"),
				g_strAppTitle, MB_ICONERROR|MB_OK );
			goto FAIL;
			}
	break;
    }

    // success
    return TRUE;

FAIL:
    // failed
    return FALSE;
}

/*
 *FUNCTION:   ProcessSoundFlags
 *
 *PARAMETERS:
 *    lpShip: Points to a ship structure (originally retrieved from
 *            GetPlayerData) in RenderPlayer.
 *
 *NOTES:      All y-coordinates must be made negative, because the
 *            3D Sound API's use an opposite coordinate system than
 *            the screen.
 */

void ProcessSoundFlags(LPSHIP lpShip)
{
/*    int i;//new predelat
    BOOL bStart[MAX_SOUNDS]; //flags, used so we can 
    BOOL bStop [MAX_SOUNDS];

    if (!gbSoundInitialized)
	{
		// clear bounce flag so we don't send a message every time through the loop
        lpShip->bBounced = FALSE;
        return;
	}

    //if one is NULL, so are the other ones and we aren't initialized yet.
    for (i=0; i<MAX_SOUNDS; i++)
    {
        if (lpShip->lpDirectSoundBuffer[i]==NULL)
            return;
    }

    //set all our temporary flags to FALSE.
    for (i=0; i<MAX_SOUNDS; i++)
    {
        bStart[i] = FALSE;
        bStop[i]  = FALSE;
    }

    //
    // Set sound state based on user input and ship state
    //
    if (lpShip->bDeath)          // nothing but the boom
        {
        bStop [BFIRE]   = TRUE;
        bStop [SBOUNCE] = TRUE;
        bStop [SSTOP]   = TRUE;
        bStop [SSTART]  = TRUE;
        bStop [SENGINE] = TRUE;
        bStart[SBOOM]   = TRUE; 
        lpShip->bEngineRunning  = FALSE;
        lpShip->bMoving = FALSE;
        lpShip->dwKeys = 0;       // no point processing input for a dead ship
        lpShip->bDeath  = FALSE;  //turn off sound flag.
        }

    if (lpShip->dwKeys & KEY_STOP)
        {
        if (lpShip->bMoving)
            {
            IDirectSound3DBuffer_SetPosition(lpShip->lpDirectSound3DBuffer[SSTOP],
                                              P2M(lpShip->dPosX - 320),
                                             -P2M(lpShip->dPosY - 240),
                                             D3DVAL(0),
                                             DS3D_DEFERRED);
            bStart[SSTOP]   = TRUE;
            bStop[SENGINE]  = TRUE;
            lpShip->bEngineRunning  = FALSE;
            lpShip->bMoving         = FALSE;
            }
        }

    if (lpShip->dwKeys & KEY_ENGINEOFF)
        {
        bStop[SENGINE] = TRUE;
        lpShip->bEngineRunning = FALSE;
        }

    if (lpShip->dwKeys & (KEY_UP | KEY_DOWN))
        {
        if (!lpShip->bEngineRunning) //turn on engine
            {
            bStart[SENGINE] = TRUE;
            if (!lpShip->bMoving)   //"fire-up-engine" sound
                {
                IDirectSound3DBuffer_SetPosition(lpShip->lpDirectSound3DBuffer[SSTART],
                                                  P2M(lpShip->dPosX - 320),
                                                 -P2M(lpShip->dPosY - 240),
                                                 D3DVAL(0),
                                                 DS3D_DEFERRED);
                bStart[SSTART] = TRUE;
                lpShip->bMoving = TRUE;
                }
            lpShip->bEngineRunning = TRUE;
            }
        }

    if (lpShip->bMoving)
        {
        IDirectSound3DBuffer_SetPosition(lpShip->lpDirectSound3DBuffer[SENGINE],
                                         P2M(lpShip->dPosX - 320),
                                        -P2M(lpShip->dPosY - 240),
                                        D3DVAL(0),
                                        DS3D_DEFERRED);
        IDirectSound3DBuffer_SetVelocity(lpShip->lpDirectSound3DBuffer[SENGINE],
                                         D3DVAL(lpShip->dVelX * 10), //exagerater vel
                                         -D3DVAL(lpShip->dVelY * 10),
                                         D3DVAL(0),
                                         DS3D_DEFERRED);
        }

    if (lpShip->dwKeys & KEY_FIRE)
        {
        if (!lpShip->bFiring)
            {
            IDirectSound3DBuffer_SetPosition(lpShip->lpDirectSound3DBuffer[BFIRE],
                                              P2M(lpShip->dPosX - 320),
                                             -P2M(lpShip->dPosY - 240),
                                             D3DVAL(0),
                                             DS3D_DEFERRED);
            bStart[BFIRE]   = TRUE;
            lpShip->bFiring = TRUE;
            }
        }

    if (lpShip->bBlockHit)
        {
        IDirectSound3DBuffer_SetPosition(lpShip->lpDirectSound3DBuffer[LBOOM],

                                          P2M(lpShip->dBulletPosX - 320),
                                         -P2M(lpShip->dBulletPosY - 240),
                                         D3DVAL(0),
                                         DS3D_DEFERRED);

        bStart[LBOOM] = TRUE;
        lpShip->bBlockHit = FALSE;
        }

    if (lpShip->bBounced)
        {
        IDirectSound3DBuffer_SetPosition(lpShip->lpDirectSound3DBuffer[SBOUNCE],
                                         P2M(lpShip->dPosX - 320),
                                         -P2M(lpShip->dPosY - 240),
                                         D3DVAL(0),
                                         DS3D_DEFERRED);

        bStart[SBOUNCE] = TRUE;
        lpShip->bBounced = FALSE;
        }

    //
    // stop, update, and start sounds.
    //
    for (i=0; i<MAX_SOUNDS; i++)
        {
        if (bStop[i])
            {
            IDirectSoundBuffer_Stop(lpShip->lpDirectSoundBuffer[i]);
            if (bStart[i])
                {
                    bStart[i] = FALSE;
                    TRACE(_T("ASSERT in ProcessSoundFlags: bStart = bStop = TRUE\n"));
                }
            }
        }
    IDirectSound3DListener_CommitDeferredSettings(glpDirectSound3DListener);

    for (i=0; i<MAX_SOUNDS; i++)
        {
        if (bStart[i])
            {
             IDirectSoundBuffer_SetCurrentPosition(lpShip->lpDirectSoundBuffer[i], 0);

             if (DSERR_BUFFERLOST==IDirectSoundBuffer_Play(lpShip->lpDirectSoundBuffer[i],
                                                           0,
                                                           0,
                                                           (i==SENGINE) ? DSBPLAY_LOOPING : 0))
                {
                WaveReload(gSoundEffect[i]);
                }
            }
        }
    lpShip->dwKeys = 0;*/
};


/*
 * ComputePlayerCB
 *
 * Compute a ship in its current state. Also checks if we hit the ship and informs
 * the ship that it has been destroyed.
  */
/*********sem nahazet vypocty (muze jich byt vice nez samotnych 3drenderovacich cyklu!!!)**********/
BOOL WINAPI ComputePlayerCB(DPID dpId, DWORD dwPlayerType, LPCDPNAME lpName, 
	DWORD dwFlags, LPVOID lpContext)
{
    DWORD dwSize = sizeof(SHIP);
    HRESULT hr;
//    DWORD dwTickCount;
	if(PlayerCount>=MAX_PLAYERS)
		{
        MessageBox( ghWndMain, TEXT("Too many players, zvoralo to directplay!"),
                          TEXT("Neplecha ze strany DirectX"), MB_OK|MB_ICONERROR );
		return FALSE;
		}

    // get ship data
	PlayerPID[PlayerCount]=dpId;
    hr = DPlayGetPlayerData(dpId, &PlayerBuf[PlayerCount], &dwSize, DPGET_LOCAL);
    if (FAILED(hr))
    {
        TRACE(TEXT("Get Player local data failed for id %d\n"), dpId);
		return FALSE;
    }
	// no player data yet
	if (0 == dwSize)
		return TRUE; 

	EngPocetHracu[PlayerBuf[PlayerCount].byType]++;//byType musi byt v 0..1 !!! jinak maso
	if(PlayerBuf[PlayerCount].bEnable)
		EngPocetEnabHracu[PlayerBuf[PlayerCount].byType]++;//byType musi byt v 0..1 !!! jinak maso

	PlayerCount++;
	return TRUE;
}

/*
 * RenderPlayerCB
 *
 * Renders a ship in its current state. 
 */
/*******sem nahazet praci s grafikou**********/
BOOL WINAPI RenderPlayerCB(DPID dpId, DWORD dwPlayerType, LPCDPNAME lpName, 
	DWORD dwFlags, LPVOID lpContext)
{
    SHIP ship;
    DWORD dwSize = sizeof(ship);
    BOOL bHit = FALSE;
    HRESULT hr;
    TCar *car;
    // get ship data
    hr = DPlayGetPlayerData(dpId, &ship, &dwSize, DPGET_LOCAL);

    if (FAILED(hr))
    {
        TRACE(TEXT("Get Player local data failed for id %d\n"), dpId);
        goto FAIL;
    }

	// no player data yet
	if (0 == dwSize)
		return TRUE; 

    // ignore current ship ?
    if (ship.bIgnore)
    {
        return TRUE;
    }

    // bail, if ship is disabled
    if (!ship.bEnable) return TRUE;

	// render the ship
	car=MakeCar(&ship);
	car->Display(pd3dDeviceCB,0);//verze 10 animovani auticka

    ProcessSoundFlags(&ship);//tohle se musi dopichnout


	// save ship data
	hr = DPlaySetPlayerData(dpId, &ship, sizeof(ship), DPSET_LOCAL);
    if (FAILED(hr))
    {
		TRACE(TEXT("Set Player local data failed for id %d\n"), dpId);
        goto FAIL;
    }

    // success
    return TRUE;

FAIL:
    // failed
    return FALSE;
}

/*
 * DrawScreen
 * 
 * Renders the current frame
 */

/*BOOL DrawScreen( void )nove nahrazeno render3denvironment
{
//    BYTE    mask, col;new zruseno
    //int     x, y;new zruseno
    HRESULT hr;

	// render players
    hr = DPlayEnumPlayers(NULL, RenderPlayerCB, NULL, 0);
    if (FAILED(hr))
    {
        ShowError(IDS_DPLAY_ERROR_EP);
        goto FAIL;
    }
    // success
    return TRUE;

FAIL:
    return FALSE;
}*/

/*
 * DisplayFrameRate
 * 
 * Renders current frame rate
 */
/*
void DisplayFrameRate( void )
{
    DWORD			time2;
    char			buff[256];
	static DWORD	dwFrames;
	
    gdwFrameCount++;
    time2 = timeGetTime() - gdwFrameTime;
    if( time2 > 1000 )
    {
        dwFrames = (gdwFrameCount*1000)/time2;
        gdwFrameTime = timeGetTime();
        gdwFrameCount = 0;
    }
    if( dwFrames == 0 )
    {
        return;
    }

    if (dwFrames != gdwFramesLast)
    {
        gdwFramesLast = dwFrames;
    }

    if( dwFrames > 99 )
    {
	dwFrames = 99;
    }
    buff[0] = (char)((dwFrames / 10) + '0');
    buff[1] = (char)((dwFrames % 10) + '0');
    buff[2] = '\0';
    bltScore(buff, 295, 10);
}
*/
/*
 * DrawScore
 *
 * Renders our current score
 */
/*
BOOL DrawScore( void )
{
    SHIP        ship;
    DWORD       dwSize;
    char        dwScorebuf[11];
    int         rem;
    HRESULT     hr;

    dwSize = sizeof(ship);
    hr = DPlayGetPlayerData(gOurID, &ship, &dwSize, DPGET_LOCAL);
    if (FAILED(hr))
    {
        TRACE(TEXT("Get Player local data failed for id %d\n"), gOurID);
        goto FAIL;
    }

    // blt everything in reverse order if we are doing destination transparency
    // calculate dwScore string
    dwScorebuf[0] = (BYTE)ship.dwScore/100000 + '0';
    rem = ship.dwScore % 100000;
    dwScorebuf[1] = rem/10000 + '0';
    rem = ship.dwScore % 10000;
    dwScorebuf[2] = rem/1000 + '0';
    rem = ship.dwScore % 1000;
    dwScorebuf[3] = rem/100 + '0';
    rem = ship.dwScore % 100;
    dwScorebuf[4] = rem/10 + '0';
    rem = ship.dwScore % 10;
    dwScorebuf[5] = rem + '0';
    dwScorebuf[6] = '\0';

    bltScore(dwScorebuf, 8, 8);

	// save ship data
	hr = DPlaySetPlayerData(gOurID, &ship, sizeof(ship), DPSET_LOCAL);
    if (FAILED(hr))
    {
        ShowError(IDS_DPLAY_ERROR_SPLD);
        goto FAIL;
    }

    return TRUE;

FAIL:
    // failed
    return FALSE;
}
*/
/*
 * DrawBlock
 *
 * Renders a block
 */
/*
void DrawBlock( int x, int y )
{
    RECT    src;
    
    src.top = 0;
    src.left = 224;
    src.right = src.left + 16;
    src.bottom = src.top + 16;
    bltObject( x << 4, y << 4, glpNum, &src, DDBLTFAST_SRCCOLORKEY );
}
*/
/*
 * DrawShip
 *
 * Renders a ship
 */

/*void DrawShip( LPSHIP lpShip )
{
    RECT    src;//new predelat
    LPDIRECTDRAWSURFACE surf;

    src.top = 32 * (lpShip->cFrame / 10 );
    src.left = 32 * (lpShip->cFrame % 10 );
    src.right = src.left + 32;
    src.bottom = src.top + 32;
    switch( lpShip->byType )
    {
    case 0: surf = glpShip0; break;
    case 1: surf = glpShip1; break;
    case 2: surf = glpShip2; break;
    case 3: surf = glpShip3; break;
    default: TRACE(TEXT("Ship type not specified\n")); return;
    }
    bltObject((int)lpShip->dPosX, (int)lpShip->dPosY, surf, &src, DDBLTFAST_SRCCOLORKEY );
}*/

/*
 * DrawBullet
 *
 * Renders a bullet 
 */
/*
void DrawBullet( LPSHIP lpShip )
{
    RECT    src;
    
    src.top = BULLET_Y;
    src.left = BULLET_X + (lpShip->byType)*4;
    src.right = src.left + 3;
    src.bottom = src.top + 3;
    bltObject((int)lpShip->dBulletPosX, (int)lpShip->dBulletPosY, glpNum, &src, DDBLTFAST_SRCCOLORKEY );
}
*/
/*
 * DrawFragments
 *
 * Renders the fragments
 */
/*
void DrawFragments( void )
{
    int     i;
    
    for(i=0; i<64; i++)
    {
		if( gFrags[i].valid )
		{
			bltObject((int)gFrags[i].dPosX, (int)gFrags[i].dPosY, gFrags[i].surf,
				&(gFrags[i].src), DDBLTFAST_SRCCOLORKEY );
		}
    }
}
*/
/*
 * ReceiveGameMessages
 *
 * Checks if there are any messages for us and receives them
 */

HRESULT ReceiveMessages( void )
{
	DPID				idFrom, idTo;
	LPVOID				lpvMsgBuffer;
	DWORD				dwMsgBufferSize;
	HRESULT				hr;

	// read all messages in queue
	dwMsgBufferSize = gdwReceiveBufferSize;
	lpvMsgBuffer = glpvReceiveBuffer;
	
	while (TRUE)
	{
		// see what's out there
		idFrom = 0;
		idTo = 0;

		hr = DPlayReceive(&idFrom, &idTo, DPRECEIVE_ALL, lpvMsgBuffer, &dwMsgBufferSize);
		if (hr == DPERR_BUFFERTOOSMALL)
		{
			if (lpvMsgBuffer == NULL)
			{
				lpvMsgBuffer = GlobalAllocPtr(GHND, dwMsgBufferSize);
				if (lpvMsgBuffer == NULL)
					return (DPERR_NOMEMORY);
				glpvReceiveBuffer = lpvMsgBuffer;
				gdwReceiveBufferSize = dwMsgBufferSize;
			}
			else if (dwMsgBufferSize > gdwReceiveBufferSize)
			{
				lpvMsgBuffer = GlobalReAllocPtr(lpvMsgBuffer, dwMsgBufferSize, 0);
				if (lpvMsgBuffer == NULL)
					return (DPERR_NOMEMORY);
				glpvReceiveBuffer = lpvMsgBuffer;
				gdwReceiveBufferSize = dwMsgBufferSize;
			}
		}
		else if ((hr == DP_OK) && 
                 ((dwMsgBufferSize >= sizeof(GENERICMSG)) || 
                  (dwMsgBufferSize >= sizeof(DPMSG_GENERIC))))
		{
			if (idFrom == DPID_SYSMSG)
            {
				DoSystemMessage((LPDPMSG_GENERIC) lpvMsgBuffer, dwMsgBufferSize, idFrom, idTo);
            }
			else
            {
				DoApplicationMessage((LPGENERICMSG) lpvMsgBuffer, dwMsgBufferSize, idFrom, idTo);
            }
		}
		else
			break;
	};

    return hr;
}

/*
 * DoSystemMessage
 *
 * Evaluates system messages and performs appropriate actions
 */

void DoSystemMessage( LPDPMSG_GENERIC lpMsg, DWORD dwMsgSize, DPID idFrom, DPID idTo )//ok
{
	switch( lpMsg->dwType)
    {
    case DPSYS_CREATEPLAYERORGROUP://ok
        {
        	LPDPMSG_CREATEPLAYERORGROUP lpAddMsg = (LPDPMSG_CREATEPLAYERORGROUP) lpMsg;
			int	iLeastAmt = -1;
			int	iLeastType = -1;
			int	i;
			int NumOfStrela=0;
			int NumOfStatic=0;

            if( gbIsHost)
		    {//musim popsat situaci novemu hraci       +velikost dat v bytech
			DWORD NeedSize=sizeof(HOSTMSG)-sizeof(BYTE)+EngMapa->SizeX*EngMapa->SizeY*sizeof(BYTE);
				//zatim podklady
			for(i=0;i<EngMapa->SizeX*EngMapa->SizeY;i++)
				{
				NumOfStatic+=(EngMapa->Mapa[i].Spojak->GetCount());
				}//ted uz i staticke objekty na mapce
			NeedSize+=sizeof(TStatSpoj2)*NumOfStatic;

			NumOfStrela=EngSStrely->GetCount();
			NeedSize+=sizeof(TStrela)*NumOfStrela;
				//mam celou potrebnou velikost
			gHostMsgSizeCurNeed=NeedSize;
			if (gHostMsg == NULL)
			{
				gHostMsg = (LPHOSTMSG)GlobalAllocPtr(GHND, NeedSize);
				if (gHostMsg == NULL)
					{
                    MessageBox( ghWndMain, TEXT("Error when allocating memory for sending level specification to new player"),
                                TEXT("FATAL Error"), MB_OK|MB_ICONERROR );
					ExitGame();
					break;
					}
				gHostMsgSize=NeedSize;
			}
			else if (NeedSize > gHostMsgSize)
			{
				gHostMsg = (LPHOSTMSG)GlobalReAllocPtr(gHostMsg, NeedSize, 0);
				if (gHostMsg == NULL)
					{
                    MessageBox( ghWndMain, TEXT("Error when reallocating memory for sending level specification to new player"),
                                TEXT("FATAL Error"), MB_OK|MB_ICONERROR );
					ExitGame();
					break;
					}
				gHostMsgSize=NeedSize;
			}


//				gHostMsg.Blocks = gBlocks;
			//naplneni struktury
			gHostMsg->byType=MSG_HOST;
				//Copy the used ship types array into the message to be sent
			for(i = 0; i < NUM_SHIP_TYPES; i++)
					gHostMsg->usedShipTypes[i] = gShipTypesUsed[i];
			gHostMsg->SizeX=EngMapa->SizeX;
			gHostMsg->SizeY=EngMapa->SizeY;
			gHostMsg->NumOfStatic=NumOfStatic;
			gHostMsg->NumOfStrela=NumOfStrela;
			gHostMsg->zdroje[0]=EngZdroj[0];
			gHostMsg->zdroje[1]=EngZdroj[1];//predani zdroju
			gHostMsg->score[0]=EngScore[0];
			gHostMsg->score[1]=EngScore[1];//predani score
			//ted naplnime info o podkladu
			for(i=0;i<EngMapa->SizeX*EngMapa->SizeY;i++)
				{
				gHostMsg->Data[i]=EngMapa->Mapa[i].Podklad;
				}
			//ted naplnime na pozici Dat (i) vsechny staticke objekty na mapce TStatSpoj2
			TStatSpoj2 *st;
			st=(TStatSpoj2 *)&(gHostMsg->Data[i]);
			int idx=0;
			for(int y=0;y<EngMapa->SizeY;y++)
			for(int x=0;x<EngMapa->SizeX;x++)
				{
				TStatSpoj *temp;
				EngMapa->Mapa[x+y*EngMapa->SizeX].Spojak->Reset();
				while(temp=EngMapa->Mapa[x+y*EngMapa->SizeX].Spojak->Next())
					{
					st[idx].StatInfo=*temp;
					st[idx].Mx=x;
					st[idx].My=y;
					idx++;					
					}
				}
			i+=sizeof(TStatSpoj2)*idx;//update total count
			//ted popiseme strely
			TStrela *str;
			str=(TStrela *)&(gHostMsg->Data[i]);
			idx=0;
			TStrela *temp;
			EngSStrely->Reset();
			while(temp=EngSStrely->Next())
				{
				str[idx]=*temp;
				idx++;	
				}
			/*********a message je naplnena************/

			    SendGameMessage((LPGENERICMSG) gHostMsg, lpAddMsg->dpId);
		    }

			// Loop through the used ship types array and find the one that's been used the least
			for(i = 0; i < NUM_SHIP_TYPES; i++)
			{
				if ((iLeastAmt < 0) || (gShipTypesUsed[i] < iLeastAmt))
				{
					iLeastAmt = gShipTypesUsed[i];
					iLeastType = i;
				}
			}
			gShipTypesUsed[iLeastType]++; // update our copy of the used ship types
        }
		break;//ok

    case DPSYS_DESTROYPLAYERORGROUP://ok
        {
            LPSHIP lpShip;
        	LPDPMSG_DESTROYPLAYERORGROUP lpDestroyMsg = (LPDPMSG_DESTROYPLAYERORGROUP) lpMsg;

            if ((sizeof(SHIP) != lpDestroyMsg->dwLocalDataSize) || 
                (NULL == lpDestroyMsg->lpLocalData))
                break;

            lpShip = (LPSHIP)lpDestroyMsg->lpLocalData;
			gShipTypesUsed[lpShip->byType]--; // decrement the leaving players' ship type usage counter
            ReleasePlayerLocalSoundData(lpShip);
        }
		break;//ok

	case DPSYS_HOST://ok
        {
            gbIsHost = TRUE;
			UpdateTitle();
        }
 		break;//ok

    case DPSYS_SESSIONLOST://ok
        // inform user that session was lost
		TRACE(_T("Session lost\n"));
		if (!gbSessionLost)
		{
		    gbSessionLost = TRUE;
	        ShowError(IDS_DPLAY_ERROR_SL);
		}
        break;

    case DPSYS_SENDCOMPLETE://ok
        // Async send status
        {
        	LPDPMSG_SENDCOMPLETE lpComplete = (LPDPMSG_SENDCOMPLETE) lpMsg;

			if (FAILED(lpComplete->hr))
			{
				LPTSTR lpszErr;
				switch (lpComplete->hr)
				{
				case DPERR_CANCELLED:	lpszErr = _T("Cancelled"); break;
				case DPERR_ABORTED:		lpszErr = _T("Aborted");   break;
				case DPERR_TIMEOUT:		lpszErr = _T("Timed out"); break;
				case DPERR_GENERIC:		lpszErr = _T("Generic");   break;
				default:				lpszErr = _T("Unknown");
				}
				TRACE(_T("Async msg %u to %u transmission failed. err = %s %#08X\n"),
						 lpComplete->dwMsgID, lpComplete->idTo, lpszErr,
						 lpComplete->hr);
			}
        }
        break;//ok
    }
}

/*
 * DoApplicationMessage
 *
 * Evaluates an application message and performs appropriate actions
 */

void DoApplicationMessage( LPGENERICMSG lpMsg, DWORD dwMsgSize, DPID idFrom, DPID idTo )
{        
    HRESULT hr;

    switch( lpMsg->byType )
    {
    case MSG_HOST://ok
		{
			LPHOSTMSG	lpHost;
			SHIP		ship;
			DWORD		dwSize = sizeof (ship);
			int			i;
			int			leastUsed = -1;

			if( !gbIsHost )
			{
				lpHost = (LPHOSTMSG) lpMsg;
                // receive the field layout
				//*****nacist stav hry*********************
				//gBlocks = lpHost->Blocks;zruseno
				DeInitLevel();//jistota, kdybych to predelaval
				EngSStrely=new TSpojak <TStrela>;
				EngMapa=new TMapka(lpHost->SizeX,lpHost->SizeY);//pocatecni rozmery
				if(!EngSStrely||!EngMapa||!EngMapa->Mapa)
					{
					DeInitLevel();//new
					MessageBox( ghWndMain, TEXT("Error initializing level from remote host-player"),
								TEXT("FATAL Error"), MB_OK|MB_ICONERROR );
					ExitGame();
					break;
					}
				/**************ted naplnit promene udaji o levelu******************/
				for(i=0;i<EngMapa->SizeX*EngMapa->SizeY;i++)
					{
					EngMapa->Mapa[i].Podklad=lpHost->Data[i];
					}
				TStatSpoj2 *st;
				st=(TStatSpoj2 *)&(lpHost->Data[i]);
				int idx;
				for(idx=0;idx<lpHost->NumOfStatic;idx++)
					{
					TStatSpoj *temp=new TStatSpoj;
					*temp=st[idx].StatInfo;
					EngMapa->Mapa[st[idx].Mx+st[idx].My*EngMapa->SizeX].Spojak->Add(temp);
					}
				/***********ted strely*******/
				i+=sizeof(TStatSpoj2)*idx;//update total count
				TStrela *str;
				str=(TStrela *)&(lpHost->Data[i]);
				for(idx=0;idx<lpHost->NumOfStrela;idx++)
					{
					TStrela *temp=new TStrela;
					*temp=str[idx];
					EngSStrely->Add(temp);
					}
				EngZdroj[0]=lpHost->zdroje[0];
				EngZdroj[1]=lpHost->zdroje[1];
				EngScore[0]=lpHost->score[0];
				EngScore[1]=lpHost->score[1];
				/****************stav nacten*************************/
				// The Host keeps the official record of ship colors in use.
				// Sync up our data and recompute our color
				hr = DPlayGetPlayerData(gOurID, &ship, &dwSize, DPGET_LOCAL);
				if (FAILED(hr))
					TRACE(_T("Get Player local data failed for id %d\n"), gOurID);

				// Insure that host is not a Beta version of Duel that does not
				// send the additional ShipTypesUsed.
				if (SUCCEEDED(hr)/* && dwMsgSize >= sizeof(HOSTMSG)*/)//zadna beta se nebere v uvahu
				{
					// Loop through the used ship types array we were given,
					// copying it and finding the least used type for ourself.
					for (i = 0; i < NUM_SHIP_TYPES; i++)
					{
						gShipTypesUsed[i] = lpHost->usedShipTypes[i];
						if ((leastUsed < 0) || (gShipTypesUsed[i] < leastUsed))
						{
							leastUsed = gShipTypesUsed[i];
//							ship.byType = i;//nove se uz nepouziva
						}
					}
					gShipTypesUsed[ship.byType]++; // increment it because we used one

					hr = DPlaySetPlayerData(gOurID, &ship, dwSize, DPSET_LOCAL);
					if (FAILED(hr))
						TRACE(_T("Set Player local data failed for id %d\n"), gOurID);
				}

                // have host initializtion at this point
				gbHaveHostInit = TRUE;
                
                // start updating screen
                gbIsActive = TRUE;
				SetStartGlobPos();//init nastaveni glob mapky
				EngAppState=2;//zacina se v podzemi
				gBasekaTime=0;
			}
		}
		break;//ok

/*    case MSG_BLOCKHIT:
		{
			LPBLOCKHITMSG   lpBlockHit;

			lpBlockHit = (LPBLOCKHITMSG) lpMsg;
			gBlocks.bits[lpBlockHit->byRow][lpBlockHit->byCol] &= ~lpBlockHit->byMask;
		}
		break;
*/
    case MSG_ZDROJE:
		{
			LPZDROJEMSG   lpZdr;
			BOOL zmena=false;
			lpZdr = (LPZDROJEMSG) lpMsg;
			
			//dodelat pro cekani na rozhodnuti o compete
			//zatim jen pro hosta
			if(lpZdr->Host)
				{//prisla odpoved-dodelat
				if(EngWaitOnCar)
					{//kdyz cekam na prideleni auta
					EngWaitOnCar=false;
					if(lpZdr->What<128)//ekvivalent pro host v renderinterface2
						{//dostal jsem ho
						AddTextInfo("Auticko bylo prideleno");
						SHIP ship;//INITOURSHIP
						ZeroMemory(&ship, sizeof(ship));//dodelat SOUNDBUFFERS tak aby tohle nevadilo
						/******nastaveni auta******/
						ship.Typ=lpZdr->What;
						ship.byType=EngDruzstvo;
						ship.Fuel=FuelLimit[ship.Typ];
						ship.Ammo[0]=AmmoLimit[ship.Typ][0];
						ship.Ammo[1]=AmmoLimit[ship.Typ][1];
						ship.Damage=DamageLimit[ship.Typ];
						ship.R=INIT_ANGLE;
						if(ship.Typ==3)
							{
							ship.Z=HELI_VYS;
							}
						else
						if(ship.Typ==2)
							{//miny omezene
							ship.Ammo[1]=lpZdr->Miny;
							}
						hr = DPlaySetPlayerData(gOurID, &ship, sizeof(ship), DPSET_LOCAL);
						if (FAILED(hr))
							return;
						EngActZbran=0;
						EngHaveACar=true;//mam ho							
						}
					else
						{//beep
						AddTextInfo("Zadost o auticko zamitnuta, zrejme jiz zadne neni k dispozici");
						}
					//else vsechno OK, jsem bez auta stale v podzemi
					}
				else
					{
					if(lpZdr->What<128)
						{//musim ho odreknout
			            gZdrojeMsg.Host=false;
						gZdrojeMsg.What=lpZdr->What+128;
						gZdrojeMsg.Miny=lpZdr->Miny;
						gZdrojeMsg.Skup=EngDruzstvo;
						SendGameMessage((LPGENERICMSG) &gZdrojeMsg, idFrom);
						}
					//else mi ho stejne nedal a ja na nej uz ani necekal tak OK
					}
				}
			else if(gbIsHost)
				{//je to zadost a ja ji mam obslouzit
				if(lpZdr->What>=128)
					{//zruseni zadosti
					EngZdroj[lpZdr->Skup].NCar[lpZdr->What-128]++;//zrusena zadost o auto
					EngZdroj[lpZdr->Skup].NMina+=lpZdr->Miny;//vraci mi i miny
					zmena=true;
					}
				else
					{//chci auto
					if(EngZdroj[lpZdr->Skup].NCar[lpZdr->What])
						{//jeste je
						EngZdroj[lpZdr->Skup].NCar[lpZdr->What]--;//odeberu
			            gZdrojeMsg.Host=true;
						gZdrojeMsg.What=lpZdr->What;
						if(gZdrojeMsg.What==2)//omezene miny
							{
							gZdrojeMsg.Miny=EngZdroj[lpZdr->Skup].NMina;
							if(gZdrojeMsg.Miny>AmmoLimit[2][1])
								gZdrojeMsg.Miny=AmmoLimit[2][1];
							EngZdroj[lpZdr->Skup].NMina-=gZdrojeMsg.Miny;//odeberu miny ze zdroju
							}
						else
							gZdrojeMsg.Miny=0;
						//gZdrojeMsg.Skup se nepouziva
						SendGameMessage((LPGENERICMSG) &gZdrojeMsg, idFrom);
						zmena=true;//je treba informovat ostatni
						}
					else
						{//uz neni
			            gZdrojeMsg.Host=true;
						gZdrojeMsg.What=lpZdr->What+128;//uz tu zadne volne vozidlo neni
						gZdrojeMsg.Miny=0;
						SendGameMessage((LPGENERICMSG) &gZdrojeMsg, idFrom);
						}
					}
				}
			if(gbIsHost&&zmena)
				{//informuj ostatni
			    gSyncZdrojMsg.zdroje[0]=EngZdroj[0];
			    gSyncZdrojMsg.zdroje[1]=EngZdroj[1];
				SendGameMessage((LPGENERICMSG) &gSyncZdrojMsg,DPID_ALLPLAYERS);
				}
		}
		break;

    case MSG_SYNCZDROJ:
		{
			LPSYNCZDROJMSG   lpSyncZdroj;

			lpSyncZdroj = (LPSYNCZDROJMSG) lpMsg;
			
			EngZdroj[0]=lpSyncZdroj->zdroje[0];
			EngZdroj[1]=lpSyncZdroj->zdroje[1];//sesync zdroju (pouze kdyz se deji nejake zmeny)
		}
		break;

    case MSG_ADDSTRELA:
		{
			LPADDSTRELAMSG   lpAddStrela;

			lpAddStrela = (LPADDSTRELAMSG) lpMsg;

			TStrela *nova=new TStrela;
			*nova=lpAddStrela->strela;
			EngSStrely->Add(nova);//update svoje strely
			if(bWantSound)
				{//SNDPREDELAT
				SndObjStop(hsoGunShot);
				SndObjPlay(hsoGunShot,0);
				}
		}
		break;

    case MSG_SCORE:
		{
			LPSCOREMSG   lpScore;

			lpScore = (LPSCOREMSG) lpMsg;

			if(lpScore->zmena[0]<0||lpScore->zmena[1]<0)
				{//nemaji auticka
				if((lpScore->zmena[0]<0&&EngDruzstvo==0)||(lpScore->zmena[1]<0&&EngDruzstvo==1))
					{
					AddTextInfo(">>>Uz nemate zadna auticka<<<");
					}
				else
					{
					AddTextInfo(">>>Druhe druzstvo uz nema zadna auticka<<<");
					}
				}
			else
				{//aktualizace skore
				EngScore[0]+=lpScore->zmena[0];
				EngScore[1]+=lpScore->zmena[1];//predelano kvuli nesynchronimu stavu hracu v session a zamezeni ztraty skore, kdyz je ziskaji rychle po sobe
				if(lpScore->zmena[0]||lpScore->zmena[1])
					{//zmena po vlajecce
					if(EngScore[0]<lpScore->score[0])
						EngScore[0]=lpScore->score[0];
					if(EngScore[1]<lpScore->score[1])
						EngScore[1]=lpScore->score[1];//vyrovnani na vyssi

					if(EngScore[0]>lpScore->score[0]||EngScore[1]>lpScore->score[1])//kontrola zda odesilatel nema nizke predstavy o skore
						{//je treba vyvest z omylu ty co maji nizke skore
						gScoreMsg.score[0]=EngScore[0];
						gScoreMsg.score[1]=EngScore[1];
						gScoreMsg.zmena[0]=0;//pouze sync a ne aut zvyseni skore
						gScoreMsg.zmena[1]=0;//pouze sync a ne aut zvyseni skore
						SendGameMessage((LPGENERICMSG) &gScoreMsg,DPID_ALLPLAYERS);
						}
					}
				else
					{//info o desynchronizaci skore, nic se uz neposila dal
					if(EngScore[0]<lpScore->score[0])
						EngScore[0]=lpScore->score[0];
					if(EngScore[1]<lpScore->score[1])
						EngScore[1]=lpScore->score[1];//vyrovnani na vyssi
					}
				}
		}
		break;

    case MSG_DELSTRELA:
		{
			LPDELSTRELAMSG   lpDelStrela;

			lpDelStrela = (LPDELSTRELAMSG) lpMsg;
			
		TStrela *strela;
		EngSStrely->Reset();
		while(strela=EngSStrely->Next())
			{//projdu vsechny letici strely
			if(strela->gid.time==lpDelStrela->gid.time&&strela->gid.pid==lpDelStrela->gid.pid)
				{//nasel jsem ji
				EngSStrely->Delete();
				break;
				}
			}
		}
		break;

    case MSG_CHANGESTAT:
		{
			LPCHANGESTATMSG   lpChangeStat;

			lpChangeStat = (LPCHANGESTATMSG) lpMsg;

			int x,y;
			x=lpChangeStat->x;
			y=lpChangeStat->y;
			TStatSpoj *obj;
			EngMapa->Mapa[x+y*EngMapa->SizeX].Spojak->Reset();
			int zmena=0;
			while(obj=EngMapa->Mapa[x+y*EngMapa->SizeX].Spojak->Next())
				{
				if(obj->gid.time==lpChangeStat->stat.gid.time&&
						obj->gid.pid==lpChangeStat->stat.gid.pid)
					{//nasel jsem objekt se stejnym gid
					zmena=1;
					if(lpChangeStat->cim<0)
						{
						if(lpChangeStat->stat.Index==0)//TOTEZ je i u ComputeGame!!!
							{//strom --- dopichnout ostatni staticke 
							if(obj->Index>=1)//uz doslo ke zmene, uz to nema cenu
								break;//pozn. obj se meni vzdy k vyssimu cislu!
							*obj=lpChangeStat->stat;
							obj->Index=1;//upravy
							}
						else
						if(lpChangeStat->stat.Index==2)
							{//chaloupka
							if(obj->Index>=3)//uz doslo ke zmene, uz to nema cenu
								break;//pozn. obj se meni vzdy k vyssimu cislu!
							*obj=lpChangeStat->stat;
							obj->Index=3;//upravy
							}
						else
						if(lpChangeStat->stat.Index==4)
							{//barak
							if(obj->Index>=5)//uz doslo ke zmene, uz to nema cenu
								break;//pozn. obj se meni vzdy k vyssimu cislu!
							*obj=lpChangeStat->stat;
							obj->Index=5;//upravy
							obj->Damage=EngStatic[obj->Index]->InitDam;//inicializovat nove damage
							}
						else
						if(lpChangeStat->stat.Index==5)
							{//polozriceny barak
							if(obj->Index>=6)//uz doslo ke zmene, uz to nema cenu
								break;//pozn. obj se meni vzdy k vyssimu cislu!
							*obj=lpChangeStat->stat;
							obj->Index=6;//upravy
							}
						else
						if(lpChangeStat->stat.Index==9)
							{//munice
							if(obj->Index>=16)//uz doslo ke zmene, uz to nema cenu
								break;//pozn. obj se meni vzdy k vyssimu cislu!
							*obj=lpChangeStat->stat;
							obj->Index=16;//upravy
							}
						else
						if(lpChangeStat->stat.Index==10)
							{//munice
							if(obj->Index>=16)//uz doslo ke zmene, uz to nema cenu
								break;//pozn. obj se meni vzdy k vyssimu cislu!
							*obj=lpChangeStat->stat;
							obj->Index=16;//upravy
							}
						else
						if(lpChangeStat->stat.Index==15)
							{//munice
							if(obj->Index>=18)//uz doslo ke zmene, uz to nema cenu
								break;//pozn. obj se meni vzdy k vyssimu cislu!
							*obj=lpChangeStat->stat;
							obj->Index=18;//upravy
							}
						}
					else
						{//pouze zmenit damage objektu
						*obj=lpChangeStat->stat;//vsechno udelal jiz odesilatel
//						obj->Damage-=SilaStrely[lpChangeStat->cim];
						}
					break;//vybruslit z cyklu
					}
				}
			if(!zmena&&lpChangeStat->cim<0)
				{//zaradit jako novy objekt
				TStatSpoj *temp=new TStatSpoj;
				*temp=lpChangeStat->stat;
				temp->dw_t=timeGetTime();//na rozdil od strel, kolize s minou vyhodnocuji vsichni hraci!, protoze vlastnik se mezitim muze odpojit od session
				EngMapa->Mapa[x+y*EngMapa->SizeX].Spojak->Add(temp);
				}//nove2
		}
		break;

    case MSG_SHIPHIT://!!TO SAME V COMPUTE GAME
        {
		    LPSHIPHITMSG    lpShipHit = (LPSHIPHITMSG) lpMsg;
            SHIP ship;
            DWORD dwSize;

            dwSize = sizeof(SHIP);
			 // get player local data
			hr = DPlayGetPlayerData(lpShipHit->Id, &ship, &dwSize, DPGET_LOCAL);
            if (FAILED(hr))
                return;

			// no player data yet
			if (0 == dwSize)
				return;

			//dodelat synchronizaci poctu zdroju v bunkrech!!!! 
			if (!ship.bIgnore) 
	            {
				// if it is us
				if (lpShipHit->Id == gOurID)
					{//jsem to ja
					ship.Damage-=lpShipHit->Dam;
					if(ship.Damage<0)//smrt
						{
						// explode the ship on our screen
						DestroyShip(&ship);//dodelat
						EngAppState=2;//podzemi UMIRAM na rozstrileni
						EngUmiram=1;
						gBasekaTime=0;
						
						AddTextInfo("Prave jsi prisel o vozitko");
						// set our hide time-out
	//    				ship.iCountDown = HIDE_TIMEOUT;//dodelat pauzy atd.
						ship.dwLastTick = timeGetTime();
						// let the world know that we are dead
						gShipHitMsg.Id = gOurID;
						SendGameMessage((LPGENERICMSG) &gShipHitMsg, DPID_ALLPLAYERS);
						}
					}
				else
					{//info o zniceni neci lodi
					// explode the ship on our screen
					if(ship.byType==EngDruzstvo)//final2
						AddTextInfo("Vase druzstvo prislo o vozitko");
					else
						AddTextInfo("Cizi druzstvo prislo o vozitko");
					DestroyShip(&ship,-1);//dodelat
					}
				if(bWantSound)//final2, zvuk exploze
					{//SNDPREDELAT
					SndObjStop(hsoExplode);
					SndObjPlay(hsoExplode,0);
					}
				}
            // update player local data
  			DPlaySetPlayerData(lpShipHit->Id, &ship, sizeof(ship), DPSET_LOCAL);
        }
		break;

    case MSG_CONTROL://ok
        {
            LPCONTROLMSG lpControlMsg;
            SHIP ship;
            DWORD dwSize;

            lpControlMsg = (LPCONTROLMSG) lpMsg;
            dwSize = sizeof(SHIP);
			// get player local data
			hr = DPlayGetPlayerData(idFrom, &ship, &dwSize, DPGET_LOCAL);
            if (FAILED(hr))
                return;

			// no player data yet
			if (0 == dwSize)
				return;

            // update its State
            UpdateState(&ship, (DWORD)lpControlMsg->byState);

            // save it back
   			DPlaySetPlayerData(idFrom, &ship, dwSize, DPSET_LOCAL);
        }
        break;//ok

    case MSG_SYNC://ok
        {
            LPSYNCMSG lpSyncMsg;
            SHIP ship;
            DWORD dwSize;

            lpSyncMsg = (LPSYNCMSG) lpMsg;
            dwSize = sizeof(SHIP);
			// get player local data
			hr = DPlayGetPlayerData(idFrom, &ship, &dwSize, DPGET_LOCAL);
            if (FAILED(hr))
                return;

/*			if(lpSyncMsg->bEnable)//pokus debug
				{
				int i=1;
				i--;
				}*/
			// we are seeing this player for the first time
			// so do the initialization
			if (0 == dwSize)
			{
				ZeroMemory(&ship, sizeof(ship));

				// initialize sound buffers
				InitPlayerLocalSoundData(&ship);

				ship.byType = lpSyncMsg->byShipType;
                ship.Typ = lpSyncMsg->Typ;
                ship.X = lpSyncMsg->X;
                ship.Y = lpSyncMsg->Y;
                ship.R = lpSyncMsg->R;

                ship.Vlajecka = lpSyncMsg->Vlajecka;

                ship.RHlav = lpSyncMsg->RHlav;//nove pridano

                ship.bPodzemi = lpSyncMsg->bPodzemi;
				ship.Fuel=lpSyncMsg->Fuel ? 100000.0f : 0;

                ship.rych = lpSyncMsg->rych;
                ship.normrych = lpSyncMsg->normrych;
                ship.dwKeys = lpSyncMsg->keys;

				ship.deSyncR=0;//mira uhlove desynchronizace
				ship.deSyncX=0;
				ship.deSyncY=0;//mira prostorove desynchronizace
				ship.NextSyncTime=0;//cas do dalsi predpokladane synchronizace v milisekundach

                ship.dwLastTick = timeGetTime();
				if(ship.Typ==3)
					{
					ship.Z=HELI_VYS;//INITOURSHIP, neni nase!
					}
				ship.bEnable = lpSyncMsg->bEnable;
			}

			if (ship.bEnable)
            {
                // nastavit hodnoty pomale synchronizace
				SHIP puv=ship;//pro vypocet postupne synchronizace
				ship.Typ=lpSyncMsg->Typ;
				ship.X=lpSyncMsg->X;
				ship.Y=lpSyncMsg->Y;
				ship.R=lpSyncMsg->R;

                ship.Vlajecka = lpSyncMsg->Vlajecka;

				ship.RHlav=lpSyncMsg->RHlav;

				ship.Fuel=lpSyncMsg->Fuel ? 100000.0f : 0;
				ship.bPodzemi=lpSyncMsg->bPodzemi;
				ship.rych=lpSyncMsg->rych;
				ship.normrych=lpSyncMsg->normrych;
				ship.dwKeys=lpSyncMsg->keys;
				//aby to nevypadalo trhane, tak synchronizuj postupne:
				float minKoef;
				if(puv.NextSyncTime>0)
					{//minula synchronizace jeste nedobehla
					minKoef=((float)puv.NextSyncTime)/((float)SYNC_INTERVAL);
					}
				else
					minKoef=0;
				ship.deSyncX=puv.X-ship.X+(puv.deSyncX)*minKoef;
				ship.deSyncY=puv.Y-ship.Y+(puv.deSyncY)*minKoef;
				ship.deSyncR=puv.R-ship.R+(puv.deSyncR)*minKoef;
				if(ship.deSyncR>0)
					{
					while(ship.deSyncR>=g_2_PI)
						ship.deSyncR-=g_2_PI;//to same se provadi u move aby nam to nelezlo nekam pryc
					if(ship.deSyncR>g_PI)//je lepsi tocit na druhou stranu
						ship.deSyncR-=g_2_PI;
					}
				else if(ship.deSyncR<0)
					{
					while(ship.deSyncR<=-g_2_PI)
						ship.deSyncR+=g_2_PI;//to same se provadi u move aby nam to nelezlo nekam pryc
					if(ship.deSyncR<-g_PI)//je lepsi tocit na druhou stranu
						ship.deSyncR+=g_2_PI;
					}
				ship.NextSyncTime=SYNC_INTERVAL;//cas do dalsi predpokladane synchronizace v milisekundach
				if(ship.bEnable!=lpSyncMsg->bEnable)
					{
					if(ship.Typ==3)
						ship.Z=HELI_VYS;//INITOURSHIP, neni nase!
					else
						ship.Z=0;//INITOURSHIP, neni nase!
					}
				ship.bEnable=lpSyncMsg->bEnable;
            }
            else if (!ship.bIgnore)
            // Ship is alive, but we just don't know it.
			// So, display it at the rendezvous location.
            {
				ship.Typ=lpSyncMsg->Typ;
				ship.X=lpSyncMsg->X;
				ship.Y=lpSyncMsg->Y;
				ship.R=lpSyncMsg->R;

                ship.Vlajecka = lpSyncMsg->Vlajecka;

				if(ship.Typ==3)
					{
					ship.Z=HELI_VYS;//INITOURSHIP, neni nase!
					}
				ship.RHlav=lpSyncMsg->RHlav;

				ship.Fuel=lpSyncMsg->Fuel ? 100000.0f : 0;
				ship.bPodzemi=lpSyncMsg->bPodzemi;
				ship.rych=lpSyncMsg->rych;
				ship.normrych=lpSyncMsg->normrych;
				ship.dwKeys=lpSyncMsg->keys;

				ship.deSyncR=0;//mira uhlove desynchronizace
				ship.deSyncX=0;
				ship.deSyncY=0;//mira prostorove desynchronizace
				ship.NextSyncTime=0;//cas do dalsi predpokladane synchronizace v milisekundach

                ship.dwLastTick = timeGetTime();
				if(ship.bEnable!=lpSyncMsg->bEnable)
					{
					if(ship.Typ==3)
						ship.Z=HELI_VYS;//INITOURSHIP, neni nase!
					else
						ship.Z=0;//INITOURSHIP, neni nase!
					}
                ship.bEnable = lpSyncMsg->bEnable;
            }

            // save it back
   			DPlaySetPlayerData(idFrom, &ship, sizeof(ship), DPSET_LOCAL);
        }
        break;//ok

    default:
		{
            TRACE(TEXT("Unknown message type %d\n"), lpMsg->byType);
		}
		break;
    }
}

void SendChangeMess(TStatSpoj *obj,int x,int y,int cim)//defaultne pouze zmeni objekt
{//ale treba u miny ho pridat jako novy objekt!
gChangeStatMsg.stat=*obj;
gChangeStatMsg.x=x;
gChangeStatMsg.y=y;
gChangeStatMsg.cim=cim;
SendGameMessage((LPGENERICMSG) &gChangeStatMsg, DPID_ALLPLAYERS);
}

/*
 * SendGameMessage
 *
 * Sends a message to specified player(s)
 */

void SendGameMessage( LPGENERICMSG lpMsg, DPID idTo )
{
    int             nBytes;
	DWORD			dwFlags = 0;

    if (gbSessionLost)
    {
        // no sends when we are not in the session
        return;
    }

    switch( lpMsg->byType )
    {
    case MSG_HOST://ok upraveno
        nBytes = gHostMsgSizeCurNeed;
		dwFlags = DPSEND_GUARANTEED;
		break;

/*    case MSG_BLOCKHIT:
		nBytes = sizeof( BLOCKHITMSG );
		break;
*/
    case MSG_SHIPHIT:
		nBytes = sizeof( SHIPHITMSG );
		break;

    case MSG_ADDSTRELA:
		nBytes = sizeof( ADDSTRELAMSG );
		break;

    case MSG_SCORE:
		nBytes = sizeof( SCOREMSG );
		dwFlags = DPSEND_GUARANTEED;//skore je dulezite
		break;

    case MSG_SYNCZDROJ:
		nBytes = sizeof( SYNCZDROJMSG );
		break;

    case MSG_ZDROJE:
		nBytes = sizeof( ZDROJEMSG );
		dwFlags = DPSEND_GUARANTEED;//compete zdroju je dulezite
		break;

    case MSG_DELSTRELA:
		nBytes = sizeof( DELSTRELAMSG );
		break;

    case MSG_CHANGESTAT:
		nBytes = sizeof( CHANGESTATMSG );
		break;

    case MSG_CONTROL:
		nBytes = sizeof( CONTROLMSG );
        break;

    case MSG_SYNC:
		nBytes = sizeof( SYNCMSG );
        break;

    default:
        return;
	}

    if (gbAsync)
    	dwFlags |= DPSEND_ASYNC;
    if (gbReliable)
    	dwFlags |= DPSEND_GUARANTEED;

	// Send the message to the relevant player(s)
	HRESULT hr=DPlaySend(gOurID, idTo, dwFlags, (LPVOID)lpMsg, nBytes);	
}

/*
 * CleanupComm
 *
 * Cleans up communication stuff
 */

void CleanupComm(void)
{
	HRESULT hr;

	//free up all the local sound buffers
    ReleaseLocalData();

    // free the receive buffer
    if (glpvReceiveBuffer)
	{
    	GlobalFreePtr(glpvReceiveBuffer);
		glpvReceiveBuffer = NULL;
		gdwReceiveBufferSize=0;//new
	}

    // free messages spec. types buffers
    if (gHostMsg)//new
	{
    	GlobalFreePtr(gHostMsg);
		gHostMsg = NULL;
		gHostMsgSize=0;
	}

    // delete our player
    if( gOurID ) 
    {
        hr = DPlayDestroyPlayer(gOurID);
        if (FAILED(hr))
        {
            ShowError(IDS_DPLAY_ERROR_DP);
        }
		gOurID = 0;
    }

	// cleanup directplay objects
	hr = DPlayClose();
	hr = DPlayRelease();
}

