#if !defined(FVUJ__GAMEBASE_H)
#define FVUJ__GAMEBASE_H

/*==========================================================================
 *
 *  Copyright (C) 1995-1997 Microsoft Corporation. All Rights Reserved.
 *
 *  File:		gameproc.h
 *  Content:	game processing info. include file
 *
 *
 ***************************************************************************/
#define IDIRECTPLAY2_OR_GREATER
#include <ddraw.h>
#include <dplay.h>
#include <dsound.h>
#include "btkclass.h"

#ifdef __cplusplus
extern "C" {
#endif
/********C/C++*************/

extern DWORD							gdwFrameTime;				// ..
extern BOOL							gbHaveHostInit;				// do we need to do host initializaton
extern BOOL                            gbSessionLost;              // did we get disconnected ?



//#include "sfx.h"

/********compute/render callback values********/
extern DWORD ComputeCBTime;
extern LPDIRECT3DDEVICE3 pd3dDeviceCB;
// align on single byte boundaries
// this is a stop-gap measure until the structures can be re-arranged.
#pragma pack(1)
/*
#define     MAX_SHIP_X     (MAX_SCREEN_X - 32)
#define     MAX_SHIP_Y     (MAX_SCREEN_Y - 32)
#define     MAX_SHIP_FRAME 40
#define     MAX_BULLET_X    (MAX_SCREEN_X - 3)
#define     MAX_BULLET_Y    (MAX_SCREEN_Y - 3)
#define     MAX_BULLET_FRAME 400
*/

//puvodne 4
#define		NUM_SHIP_TYPES 2 //predelat cely system zprav
/*
#define		DEF_SHOW_DELAY     (2000)
#define		MAX_BUFFER_SIZE	   256
*/
#define     UPDATE_INTERVAL     40      // interval between position updates in milliseconds (25 FPS)
#define     MIN_COMPUTE_FPS		10		//nejvetsi interval mezi vypocty dvou snimku (ne grafika, ale stavy hry) je 100ms
  
#define     SYNC_INTERVAL       1000    // synchronize once every second
#define     SYNCZASEK_INTERVAL  250    // kdyz se zaseknou auta do sebe, tak si podavejte informace o odseknuti kazdou ctvrtsekundu
#define     FIRE_INTERVAL       200    

//#define     HIDE_TIMEOUT        5000    // time for which a ship is disabled after a hit

/*
 * Offsets for the bullet bitmap
 */
/*
#define     BULLET_X    304
#define     BULLET_Y    0

typedef struct _frag
{
    double		dPosX;
    double		dPosY;
    LPDIRECTDRAWSURFACE surf;
    RECT        src;
    double      dVelX;
    double      dVelY;
    BOOL        valid;
} FRAG, *LPFRAG;
*/
/*
 * structures
 */


typedef struct _SHIP
{
char Typ;//0..3 typ prostredku

BYTE byType;// ship type (prislusnost k druzstvu hracu 0/1)

BOOL Vlajecka;//zda vezu vlajecku

int Damage;//ubyva az k nule a pak smrt
float X;//pozice vozidla
float Y;
float R;//natoceni

float RHlav;//natoceni hlavne u tanku
float Z;//zetova poloha u vrtulniku a auta ve vode
float cilZ;//kde by melo vozidlo byt
float RVrt1;//pouziva se pro rotaci vrtule
float RVrt2;//pouziva se pro rotaci vrtule

float rych;//vse viz papiry
float normrych;

//pouziva se k synchronizacipohybu hracu na obrazovce pri rozsynchronizovani
float deSyncR;//mira uhlove desynchronizace
float deSyncX;
float deSyncY;//mira prostorove desynchronizace
int NextSyncTime;//cas do dalsi predpokladane synchronizace v milisekundach

float Fuel;//nove
int Ammo[2];

BOOL bPodzemi;//zda je hrac v bunkru

/*    double				dPosX, dPosY;				// ship x and y position
zrus    double				dBulletPosX, dBulletPosY;	// bullet x and y position
zrus    DWORD				dwBulletFrame;				// bullet frame
    char 				cFrame;*/						// current ship frame
//    BOOL                bBulletEnable;				// Is there an active bullet?
/*    double				dVelX, dVelY;				// ship x and y velocity (pixels/millisecond)
    double				dBulletVelX, dBulletVelY;*/	// bullet x and y velocity (pixels/millisecond)

BOOL                bEnable;					// is this ship active?
//DWORD				dwScore;					// current score
DWORD               dwLastTick;					// most recent time stamp
BOOL                bIgnore;	                // flag used to synchronize ship explosions
//int					iCountDown;                 // enable time-out            
//DWORD               dwFrameCount;               // number of frames since beginning of time


/*********KEYS**********/
DWORD                 dwKeys;                            // the keyboard state

/* DSOUND members *///dopichnout
/*    LPDIRECTSOUNDBUFFER   lpDirectSoundBuffer  [MAX_SOUNDS]; // SoundBuffer interface
    LPDIRECTSOUND3DBUFFER lpDirectSound3DBuffer[MAX_SOUNDS]; // 3D interface (to same buffer)  
*/
/*    BOOL                  bEngineRunning;                    // These BOOLs keep track of the ship's
    BOOL                  bMoving;                           //   last condition so we can play sounds
    BOOL                  bBounced;                          //   when they change
    BOOL                  bBlockHit;
    BOOL                  bDeath;
    BOOL                  bFiring;*/
    /* DSOUND members */

} SHIP, *LPSHIP;

/*typedef struct _BLOCKS//zrusit
{
    BYTE        bits[30][5];
} BLOCKS, *LPBLOCKS;*/

//----------------------------------------------------------
// communication packet structures / predelat
//----------------------------------------------------------
#define MSG_HOST			0x11    // message containing field layout, sent by host
/*#define MSG_BLOCKHIT		0x22    // block hit message*/
#define MSG_SHIPHIT			0x22    // ship hit message
#define MSG_ADDSTRELA		0x33    // add strela message
#define MSG_SCORE			0x35    // add strela message
#define MSG_SYNCZDROJ		0x39    // add strela message
#define MSG_ZDROJE   		0x44    // add strela message
#define MSG_DELSTRELA		0x55    // add strela message
#define MSG_CHANGESTAT		0x66    // add strela message
#define MSG_CONTROL			0x77    // game keys message
#define MSG_SYNC			0x88    // synchronization message containing the rendezvous location

typedef struct _GENERICMSG
{
    BYTE        byType;
} GENERICMSG, *LPGENERICMSG;

//typedef struct _OLDHOSTMSG {BYTE byType;  BLOCKS Blocks;} OLDHOSTMSG;
/*
typedef struct _HOSTMSG
{
    BYTE        byType;
    BLOCKS      Blocks;
    int         usedShipTypes[NUM_SHIP_TYPES];
} HOSTMSG, *LPHOSTMSG;*/


/*typedef struct _BLOCKHITMSG
{
    BYTE        byType;
    BYTE        byRow;
    BYTE        byCol;
    BYTE        byMask;
} BLOCKHITMSG, *LPBLOCKHITMSG;
*/
typedef struct _SHIPHITMSG
{
    BYTE        byType;
    DPID        Id;
	BYTE		Dam;//mira poskozeni
} SHIPHITMSG, *LPSHIPHITMSG;



typedef struct _CONTROLMSG
{
    BYTE        byType;
    BYTE        byState;
} CONTROLMSG, *LPCONTROLMSG;


typedef struct _SYNCMSG
{
    BYTE        byType;//tohle je typ zpravy a ne typ lodi!!!
	char		Typ;//typ vozitka
    BYTE        byShipType;     // this is needed only when sends are unreliable
	float X;//pozice vozidla
	float Y;
	float R;//natoceni

	BOOL Vlajecka;//zda veze vlajecku ci ne

	float RHlav;//obe nove

	BOOL Fuel;//zda ma jeste fuel
//	float Z;

	BOOL bPodzemi;
	BOOL bEnable;

	float rych;
	float normrych;

	DWORD keys;//nove i synchronizace klaves (obcas to delalo neplechu)
} SYNCMSG, *LPSYNCMSG;


/*************************************/

/*
 * Prototypes
 */

void InitMessageBuffers(void);

void	LaunchGame(void);
void	ExitGame(void);
HRESULT InitOurShip(void);
/*

HRESULT InitLocalSoundData(void);*/
void InitPlayerLocalSoundData(LPSHIP lpShip);
/*
BOOL WINAPI SetPlayerLocalSoundDataCB(DPID dpId, DWORD dwPlayerType, LPCDPNAME lpName, 
				   	                  DWORD dwFlags, LPVOID lpContext);
*/
void ReleaseLocalData(void);
void ReleasePlayerLocalSoundData(LPSHIP lpShip);

BOOL WINAPI ReleasePlayerLocalDataCB(DPID dpId, DWORD dwPlayerType, LPCDPNAME lpName,
					                 DWORD dwFlags, LPVOID lpContext);

void    UpdateState(LPSHIP lpShip, DWORD dwControls);
void    SendSync(LPSHIP lpShip);
/*void    UpdateDisplayStatus(LPSHIP lpShip);
void    UpdatePosition( DPID dpId, LPSHIP ship );
BOOL    IsHit( int x, int y );
void    InitField(void);
BOOL    setBlock( int x, int y );
void    AddFrag(LPSHIP lpShip, int offX, int offY);
void    UpdateFragment(int i);
void    DestroyShip( LPSHIP lpShip);
void	DestroyGame( void );*/
BOOL	UpdateFrame( void );

void    ProcessSoundFlags(LPSHIP lpShip);

BOOL WINAPI RenderPlayerCB(DPID dpId, DWORD dwPlayerType, LPCDPNAME lpName, 
	                     DWORD dwFlags, LPVOID lpContext);
BOOL WINAPI ComputePlayerCB(DPID dpId, DWORD dwPlayerType, LPCDPNAME lpName, 
	                     DWORD dwFlags, LPVOID lpContext);
BOOL	DrawScreen( void );
/*
BOOL    DrawScore( void );*/
//void    DrawShip( LPSHIP lpShip );
/*void    DrawBlock( int x, int y );
void    DrawBullet( LPSHIP lpShip );
void    DrawFragments( void );
void    DisplayFrameRate( void );

void	GetConnection(void);*/
HRESULT ReceiveMessages( void );
void	DoSystemMessage( LPDPMSG_GENERIC lpMsg, DWORD dwMsgSize, DPID idFrom, DPID idTo );
void    DoApplicationMessage( LPGENERICMSG lpMsg, DWORD dwMsgSize, DPID idFrom, DPID idTo );

void    SendGameMessage( LPGENERICMSG lpMsg, DPID idTo );
void	CleanupComm(void);

extern CONTROLMSG                      gControlMsg;                // .. 
extern SYNCMSG                         gSyncMsg;                   // ..

// restore default alignment

#pragma pack()


/********C/C++*************/
#ifdef __cplusplus
}
#endif

#endif