// Desc: Windows code for DXBitka

#define STRICT
#include <windows.h>
#include <mmsystem.h>
#include <stdio.h>
#include "utils\D3DFrame.h"
#include "utils\D3DEnum.h"
#include "utils\D3DUtil.h"
#include "resource.h"
#include "render.h"
#include "engine.h"
#include "main.h"
//erooros identifiers
#include "er_def.h"
//directinput
#include "input.h"
//directsound
#include "dsutil.h"
#include "dsnd.h"

/****dplay*********/
#include "dplay\vsichni.h"
#include "dplay\comm.h"
#include "dplay\lobby.h"
#include "dplay\wizard.h"
#include "gamebase.h"

//DWORD mintime=0;//pokus
//-----------------------------------------------------------------------------
// Global variables
//-----------------------------------------------------------------------------

CD3DFramework* g_pFramework        = NULL;
BOOL           g_bActive           = FALSE;
BOOL           g_bReady            = FALSE;
BOOL           g_bFrameMoving      = TRUE;
BOOL           g_bSingleStep       = FALSE;
//BOOL           g_bShowStats        = TRUE;
RECT           g_rcWindow;
DWORD          g_dwBaseTime;
DWORD          g_dwPauseTime;
HINSTANCE      g_hInst			   = NULL;

BOOL					bUseEmulation=FALSE;//kdyz nekdo nechce hardwareovou grafiku
BOOL                    bSoundEnabled = FALSE;
BOOL                    bWantSound = TRUE;  //global hack to turn off sound
BOOL                    bShowFrameCount=TRUE;

/*****directplay****************/

BOOL                    gbAsyncSupported;       // asynchronous sends supported
LPGUID                  glpGuid;				// Duel's GUID
BOOL                    gbUseProtocol;          // DirectPlay Protocol messaging
HINSTANCE				ghinst;					// Application instance handle		
HWND						ghWndMain;			// main window
//LPDIRECTPLAY4			glpDP;		 		// directplay object pointer
BOOL						gbIsHost;			// is the user hosting/joining a game
DPID						gOurID;				// player id
//LPGUID					glpGuid;			// duel's guid
//BOOL						gbUseProtocol;		// DirectPlay Protocol messaging
int								gnProgramState;
BOOL                    gbReliable;             // sends are reliable
BOOL                    gbAsync;                // asynchronous sends
HANDLE					ghThread;				// handle to wizard thread

/*****directplay rutines*/
BOOL                    gbIsActive;	
DWORD                   gdwKeys=NULL;

//prototypes
BOOL		FinishLobbyLaunch(void);
BOOL LaunchedByLobby(void);
void ExitGame(void);
void LaunchGame(void);
void CleanupApplication( void );
void DisplayTextInfo();

// {8743B84E-93C5-11d5-94CB-004F4901EE00}
static const GUID DXBITKA_GUID = 
{ 0x8743b84e, 0x93c5, 0x11d5, { 0x94, 0xcb, 0x0, 0x4f, 0x49, 0x1, 0xee, 0x0 } };
/*******************************/


HWND hWndMain;

enum APPMSGTYPE { MSG_NONE, MSGERR_APPMUSTEXIT, MSGWARN_SWITCHTOSOFTWARE };




//-----------------------------------------------------------------------------
// Local function-prototypes
//-----------------------------------------------------------------------------
INT     CALLBACK AboutProc( HWND, UINT, WPARAM, LPARAM );
LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );
HRESULT Initialize3DEnvironment( HWND );
HRESULT Change3DEnvironment( HWND );
VOID    Cleanup3DEnvironment();
VOID    DisplayFrameworkError( HRESULT, APPMSGTYPE );
VOID    AppShowStats();
VOID    AppOutputText( LPDIRECT3DDEVICE3, DWORD, DWORD, CHAR* );





//-----------------------------------------------------------------------------
// External function-prototypes
//-----------------------------------------------------------------------------
HRESULT App_ConfirmDevice( DDCAPS*, D3DDEVICEDESC* );
HRESULT App_OneTimeSceneInit( HWND );
VOID    App_DeleteDeviceObjects( LPDIRECT3DDEVICE3, LPDIRECT3DVIEWPORT3 );
HRESULT App_InitDeviceObjects( LPDIRECT3DDEVICE3, LPDIRECT3DVIEWPORT3 );
//HRESULT App_FrameMove( LPDIRECT3DDEVICE3, DWORD,DWORD );
HRESULT App_Render( LPDIRECT3DDEVICE3, LPDIRECT3DVIEWPORT3, D3DRECT* );
HRESULT App_RestoreSurfaces();
HRESULT App_FinalCleanup( LPDIRECT3DDEVICE3, LPDIRECT3DVIEWPORT3 );



void CheckOneMenuItem(HMENU hmenu, UINT idc, BOOL fCheck)
{
    CheckMenuItem(hmenu, idc,
                  fCheck ? (MF_BYCOMMAND | MF_CHECKED)
                         : (MF_BYCOMMAND | MF_UNCHECKED));
}

void CheckMenuItems(HWND hwnd)
{
    HMENU hmenu = GetMenu(hwnd);

//    CheckOneMenuItem(hmenu, IDC_AUDIO, bWantSound && bSoundEnabled);
//    CheckOneMenuItem(hmenu, IDC_FRAMERATE, bShowFrameCount);
}


//-----------------------------------------------------------------------------
// Name: WinMain()
// Desc: Entry point to the program. Initializes everything, and goes into a
//       message-processing loop. Idle time is used to render the scene.
//-----------------------------------------------------------------------------
INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR lpCmdLine, INT )
{
//zrusit
/*InitGameObjects();
InitLevel(".\\levels\\pokusny.lev");*/
//VeVode(3.7,-3.1);
//return -1;
//pokus
	AddTextInfo("Vita vas program DXBitka 1.0");
	AddTextInfo("Stisknete ENTER pro zobrazeni konfiguracniho dialogu");

	g_hInst=hInst;
	ghinst=hInst;//dplay utils

	CoInitialize( NULL );//(comclt32.dll atd.)

    while( lpCmdLine[0] == '-' )
    {
        lpCmdLine++;

        switch (*lpCmdLine++)
        {
        case 'e':
            bUseEmulation = TRUE;
            break;
/*        case 't':
            bTest = TRUE;
            break;*/
        case 'S':
		case 's'://sound
            bWantSound = FALSE;
            break;
/*        case 'x':
            bStress= TRUE;
            bTest = TRUE;
            break;*/
        }
        while( IS_SPACE(*lpCmdLine) )
        {
            lpCmdLine++;
        }
    }

	//kdyz nekdo zada mimo rozsah, tak se to pri konverzi prezije
	EngZdroj[0].NCar[0] = getint(&lpCmdLine,6);//defaultni zdroje (nebo nacteni uzivatelskych)
	EngZdroj[0].NCar[1] = getint(&lpCmdLine,3);//defaultni zdroje (nebo nacteni uzivatelskych)
	EngZdroj[0].NCar[2] = getint(&lpCmdLine,3);//defaultni zdroje (nebo nacteni uzivatelskych)
	EngZdroj[0].NCar[3] = getint(&lpCmdLine,3);//defaultni zdroje (nebo nacteni uzivatelskych)

	EngZdroj[0].NMina = 32;

	EngZdroj[1].NCar[0] = getint(&lpCmdLine,6);//defaultni zdroje (nebo nacteni uzivatelskych)
	EngZdroj[1].NCar[1] = getint(&lpCmdLine,3);//defaultni zdroje (nebo nacteni uzivatelskych)
	EngZdroj[1].NCar[2] = getint(&lpCmdLine,3);//defaultni zdroje (nebo nacteni uzivatelskych)
	EngZdroj[1].NCar[3] = getint(&lpCmdLine,3);//defaultni zdroje (nebo nacteni uzivatelskych)

	EngZdroj[1].NMina = 32;

	//kontrola vstupu
	for(int dr=0;dr<2;dr++)
		for(int typ=0;typ<4;typ++)
			{
			if(EngZdroj[dr].NCar[typ]<0)
				EngZdroj[dr].NCar[typ]=0;
			}

	glpGuid = (LPGUID) &DXBITKA_GUID;//dplay
	gnProgramState = PS_SPLASH;//predelat jednotny stav

    // Register the window class
    WNDCLASS wndClass = { CS_HREDRAW | CS_VREDRAW, WndProc, 0, 0, hInst,
                          LoadIcon( hInst, MAKEINTRESOURCE(IDI_MAIN_ICON)),
                          LoadCursor(NULL, IDC_ARROW), 
                          (HBRUSH)GetStockObject(WHITE_BRUSH),
                          MAKEINTRESOURCE(IDR_MENU),
                          TEXT("Render Window") };
    RegisterClass( &wndClass );

    // Create our main window
    HWND hWnd = CreateWindow( TEXT("Render Window"), g_strAppTitle,
                              WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,
                              CW_USEDEFAULT, 264,302 , 0L, 0L, hInst, 0L );
//                              CW_USEDEFAULT, 180,180 , 0L, 0L, hInst, 0L );

	hWndMain=hWnd;//pro rutiny directinput
	ghWndMain=hWnd;//pro rutiny directplay

    ShowWindow( hWnd, SW_SHOWNORMAL );
    UpdateWindow( hWnd );
	//SetFocus( ghWndMain );dplay

    /*
     *  If sound is globally disabled, then disable the sound menu.
     */
    if (!bWantSound) {
/*        EnableMenuItem(GetMenu(hWnd), IDC_AUDIO,
                       MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);*/
    }

    // Save the window size/pos for switching modes
    GetWindowRect( hWnd, &g_rcWindow );

    // Load keyboard accelerators
    HACCEL hAccel = LoadAccelerators( hInst, MAKEINTRESOURCE(IDR_MAIN_ACCEL) );

    // Enumerate available D3D devices, passing a callback that allows devices
    // to be accepted/rejected based on what capabilities the app requires.
    HRESULT hr;
    if( FAILED( hr = D3DEnum_EnumerateDevices( App_ConfirmDevice ) ) )
    {
        DisplayFrameworkError( hr, MSGERR_APPMUSTEXIT );
        return 0;
    }

    // Check if we could not get a device that renders into a window, which
    // means the display must be 16- or 256-color mode. If so, let's bail.
    D3DEnum_DriverInfo* pDriverInfo;
    D3DEnum_DeviceInfo* pDeviceInfo;
    D3DEnum_GetSelectedDriver( &pDriverInfo, &pDeviceInfo );
    if( FALSE == pDeviceInfo->bWindowed )
    {
        Cleanup3DEnvironment();
        DisplayFrameworkError( D3DFWERR_INVALIDMODE, MSGERR_APPMUSTEXIT );
        return 0;
    }

    // Initialize the 3D environment for the app
    if( FAILED( hr = Initialize3DEnvironment( hWnd ) ) )
    {
        Cleanup3DEnvironment();
        DisplayFrameworkError( hr, MSGERR_APPMUSTEXIT );
        return 0;
    }
	/******zakladni inicializace dokoncena**************************************/
/*    if(bWantSound)
        {
        SndObjPlay(hsoBeginLevel,DSBPLAY_LOOPING);
        }*///pokus

/*    if(bWantSound)
        {
        SndObjPlay(hsoBeginLevel,0);
        }//pokus

	/**********************************************/
	// were we launched by a lobby ?
    if (LaunchedByLobby())//dplay
    {
		// start game
		PostMessage(ghWndMain, UM_LAUNCH, (WPARAM)TRUE, 0);
        gbIsActive = TRUE;//duel enabled
    }

	// Setup the app so it can support single-stepping
    //g_dwBaseTime  = timeGetTime();zastarale

	//gdwFrameTime = timeGetTime();

    // Now we're ready to recieve and process Windows messages.
    //BOOL bGotMsg;
    MSG  msg;
    //PeekMessage( &msg, NULL, 0U, 0U, PM_NOREMOVE );
    g_bReady = TRUE;
    /*while( WM_QUIT != msg.message  )zastarale
    {
        // Use PeekMessage() if the app is active, so we can use idle time to
        // render the scene. Else, use GetMessage() to avoid eating CPU time.
        if( g_bActive )
            bGotMsg = PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE );
        else
            bGotMsg = GetMessage( &msg, NULL, 0U, 0U );

        if( bGotMsg )
        {
            // Translate and dispatch the message
            if( 0 == TranslateAccelerator( hWnd, hAccel, &msg ) )
            {
                TranslateMessage( &msg );
                DispatchMessage( &msg );
            }
        }
        else
        {
            // Render a frame during idle time (no messages are waiting)
            if( g_bActive && g_bReady )
            {
                
	            if( FAILED( Render3DEnvironment() ) )
                {
                    MessageBox( NULL, TEXT("An error occurred during rendering."
                                "\n\nThis DXBitka DEMO will now exit"),
                                g_strAppTitle, MB_ICONERROR|MB_OK );
                    DestroyWindow( hWnd );
                }
            }
        }
    }*/
	while( TRUE )
    {
//        if (gbIsActive)//nove predelano, aby to obslouzilo multiplayer pozadavky
        {//casem predelat na timer 10x za sec. aby to zbytecne nezralo procesor, kdyz to neni aktivni
            // any windows messages ? (returns immediately)
            if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
            {
                if( !GetMessage( &msg, NULL, 0, 0 ) )
                {
                    break;
                }
            if( 0 == TranslateAccelerator( hWnd, hAccel, &msg ) )
				{
                TranslateMessage(&msg);
                DispatchMessage(&msg);
				}
            }
            else
            {
                // Poll our receive queue. Polling is used in the sample only for simplicity.
                // Receiving messages using an event is the recommended way.
		        if (gnProgramState != PS_SPLASH)
					{
                    ReceiveMessages();
					LobbyMessageReceive(LMR_PROPERTIES);
					}
                // update screen
	    		if (!UpdateFrame())
                {
                    ExitGame();		// posts QUIT msg
                }
		    }
        }
/*        else
        {
            // any windows messages ? (blocks until a message arrives)
            if( !GetMessage( &msg, NULL, 0, 0 ) )
            {
                break;
            }
            if( 0 == TranslateAccelerator( hWnd, hAccel, &msg ) )
	            {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
				}
        }*/
    }	// message loop

	CoUninitialize();
    return msg.wParam;
}




//-----------------------------------------------------------------------------
// Name: WndProc()
// Desc: This is the basic Windows-programming function that processes
//       Windows messages. We need to handle window movement, painting,
//       and destruction.
//-----------------------------------------------------------------------------
LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
//	HRESULT hr;
UINT        cmd;
DWORD dwTid;

    switch( uMsg )
    {
	    case WM_INITMENU://synchron. menu
			CheckMenuItems(hWnd);
        break;
		//kvuli directinput
	    case WM_ACTIVATEAPP://dopichnout active/neactive 
							//tak aby behal multiplayer (komunikace bezi, prestoze hrac nehraje!!! (casem))
	        g_bActive = (BOOL) wParam;
			if( g_bActive )
	    		{
	            // activated
				gbIsActive = TRUE;//dplay rutines
				if (PS_ACTIVE == gnProgramState)
					{
					KillTimer(hWnd, RECEIVE_TIMER_ID);
					}
				// we are active, need to reacquire the keyboard
				ReacquireInput();
				}
			else
				{
	            // deactivated
	            gbIsActive = FALSE;
				if (PS_ACTIVE == gnProgramState)
					{
	                SetTimer(hWnd, RECEIVE_TIMER_ID, RECEIVE_TIMEOUT, NULL);
					}
				}
	        break;
	    case WM_TIMER://new dplay
			ReceiveMessages();
			LobbyMessageReceive(LMR_PROPERTIES);
			break;
        case WM_PAINT:
            if( g_pFramework )
            {
                // If we are paused, and in fullscreen mode, give the dialogs
                // a GDI surface to draw on.
                if( !g_bReady && !g_bWindowed)
                    g_pFramework->FlipToGDISurface( TRUE );
                else // Simply repaint the frame's contents
                    g_pFramework->ShowFrame();
            }
            break;

        case WM_MOVE:
            if( g_bActive && g_bReady && g_bWindowed )
            {
                GetWindowRect( hWnd, &g_rcWindow );
                g_pFramework->Move( (SHORT)LOWORD(lParam), (SHORT)HIWORD(lParam) );
            }
            break;

        case WM_CREATE:
			break;
			//kvuli directinput
/*            hr = InitDirectInput( hWnd );
            if ( FAILED(hr) )
            {
                MessageBox( NULL, 
                    "Error Initializing DirectInput", 
                    "DirectInput Sample", 
                    MB_ICONERROR | MB_OK );

	            DestroyWindow( hWnd );
				return 0;
            }*///inicializace prenesena do winmain

            /*return TRUE;
            break;*/
    case WM_KEYDOWN:
        switch( wParam )
        {
		case VK_F7:
			// toggle Async sends on/off
			if (gbAsyncSupported)
			{
				gbAsync = !gbAsync;
				UpdateTitle();		// caption bar status 
			}
            break;

        case VK_F8:
			// toggle reliable sends
			gbReliable = !gbReliable;
			UpdateTitle();
            break;

		case 'R'://zap vyp radar
			if(EngAppState==1)
				{
				gbRadar=!gbRadar;//zap/vyp nadzemni radar
				}
		break;

		case 'O'://samozniceni
			EngSamoZnic=true;
		break;


		case VK_F11://demo (pouziti pro pomale pocitace!)
		DEMOmapvis=!DEMOmapvis;
		break;

		case VK_SPACE://prepinani pohledu
		if(EngCumShora)
			EngCumShora=0;
		else
			EngCumShora=1;
		break;

        case VK_RETURN:
			if(EngAppState==1)
				{//zmena zbrane
				ChangeZbran();
				}
			else if(EngAppState==2)
				{
				LocState=!LocState;
				}
			// launch game setup wizard
            if( (gnProgramState == PS_SPLASH)&&(!ghThread ))
			{
			        AppPause( TRUE );
					if(g_bWindowed)
						ghThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE )DoWizard, 0, 0, &dwTid);
					else
						{
						DoWizard(NULL);//pokus, zjistit proc to dela vylomeniny
						AppPause( FALSE );//a jestli to nevadi, ze to volam takhle
						}
			}
            break;
        }
        break;

	case UM_LAUNCH:
	case UM_ABORT://casem predelat aby to slo spoustet bez restartu programu
		// cleanup the wizard thread
		if (ghThread)
		{
			// wait for thread to exit
			WaitForSingleObject(ghThread, INFINITE);
			CloseHandle(ghThread);
			ghThread = NULL;
			AppPause( FALSE );			
		}
		
		if (uMsg == UM_LAUNCH && 
			// AND NOT (failed to finish a lobby launch)
			// where wParam is bLobbyLaunched
			!((BOOL)wParam && !FinishLobbyLaunch()))
		{
			// start the game in rest mode
			gnProgramState = PS_REST;
			LaunchGame();
			return 1;
		}
		// else aborting
        ExitGame();
		return 1;
/*		case WM_KEYDOWN://predchudce directinput
			switch((int)wParam)
				{
				case VK_LEFT:
				KeyState[0]=TRUE;
				break;
				case VK_RIGHT:
				KeyState[1]=TRUE;
				break;
				case VK_UP:
				KeyState[2]=TRUE;
				break;
				case VK_DOWN:
				KeyState[3]=TRUE;
				break;
				case VK_DELETE:
				KeyState[4]=TRUE;
				break;
				case VK_NEXT:
				KeyState[5]=TRUE;
				break;
				case VK_CONTROL:
				if(EngAppState==1&&EngMapa)//level je loudly a bitka probiha na mapce
					FireStrela();//DEMO
				break;
				case VK_SPACE://DEMO ukazka vice vozidel
				if(EngActCar)
					{
					int puvtyp=EngActCar->Typ;
					float puvX=EngActCar->X;
					float puvY=EngActCar->Y;
					float puvR=EngActCar->R;
					delete EngActCar;
					if(puvtyp==0)
						EngActCar=new TTank();
					else
						EngActCar=new TJeep();
					EngActCar->X=puvX;
					EngActCar->Y=puvY;
					EngActCar->R=puvR;
					}
				break;
				case VK_F11:
				DEMOmapvis=!DEMOmapvis;
				break;
				}
		break;*/

/*		case WM_KEYUP://predchudce directinput
			switch((int)wParam)
				{
				case VK_LEFT:
				KeyState[0]=FALSE;
				break;
				case VK_RIGHT:
				KeyState[1]=FALSE;
				break;
				case VK_UP:
				KeyState[2]=FALSE;
				break;
				case VK_DOWN:
				KeyState[3]=FALSE;
				break;
				case VK_DELETE:
				KeyState[4]=FALSE;
				break;
				case VK_NEXT:
				KeyState[5]=FALSE;
				break;
				}
		break;*/

/*        case WM_KILLFOCUS:   //new
            if ( WA_INACTIVE == wParam )
            {
				for(int i=0;i<MAXKEYS;i++)
					KeyState[i]=FALSE;//vyrusit stiskle klavesy
					//predchudce directinput
            }
			break;*/

        case WM_SIZE:
            // Check to see if we are losing our window...
            if( SIZE_MAXHIDE==wParam || SIZE_MINIMIZED==wParam )
				{
                g_bActive = FALSE;
				}
            else
				{
				g_bActive = TRUE;
				// we are active, need to reacquire the keyboard
				ReacquireInput();
				}

            // A new window size will require a new viewport and backbuffer
            // size, so the 3D structures must be changed accordingly.
            if( g_bActive && g_bReady && g_bWindowed )
            {
                g_bReady = FALSE;
                GetWindowRect( hWnd, &g_rcWindow );
                Change3DEnvironment( hWnd );
                g_bReady = TRUE;
            }
            break;

        case WM_GETMINMAXINFO:
            ((MINMAXINFO*)lParam)->ptMinTrackSize.x = 100;
            ((MINMAXINFO*)lParam)->ptMinTrackSize.y = 100;
            break;

        case WM_SETCURSOR:
            if( g_bActive && g_bReady && (!g_bWindowed) )
            {
                SetCursor(NULL);
                return TRUE;
            }
            break;

        case WM_CLOSE:
            DestroyWindow( hWnd );
            return 0;
        
        case WM_DESTROY:
            Cleanup3DEnvironment();
			CleanupApplication();//dplay resources
            PostQuitMessage(0);
            return 0L;

        case WM_ENTERMENULOOP:
            if( g_bFrameMoving )
                g_dwPauseTime = timeGetTime();
            AppPause(TRUE);
            break;

        case WM_EXITMENULOOP:
            if( g_bFrameMoving )
                g_dwBaseTime += timeGetTime() - g_dwPauseTime;
            AppPause(FALSE);
            break;

        case WM_CONTEXTMENU:
            {
                HMENU hMenu = LoadMenu( 0, MAKEINTRESOURCE(IDR_POPUP) );
                
                TrackPopupMenuEx( GetSubMenu( hMenu, 0 ),
                                  TPM_VERTICAL, LOWORD(lParam), 
                                  HIWORD(lParam), hWnd, NULL );
            }
            break;

        case WM_COMMAND:
		    cmd = LOWORD(wParam);
	        if (cmd >= IDC_DEVICES && cmd < IDC_DEVICES + 100)
				{
		        PickInputDevice(cmd - IDC_DEVICES);
				}
			else
				switch (cmd)
				{
                case SC_MONITORPOWER:
                    // Prevent potential crashes when the monitor powers down
                    return 1;

/*                case IDM_TOGGLESTART:
                    g_bFrameMoving = !g_bFrameMoving;

                    if( g_bFrameMoving )
                        g_dwBaseTime += timeGetTime() - g_dwPauseTime;
                    else
                        g_dwPauseTime = timeGetTime();

                    break;*///disabled by vujtech

/*                case IDM_SINGLESTEP:
                    if( g_bFrameMoving )
                    {
                        g_bFrameMoving = FALSE;
                        g_dwPauseTime = timeGetTime();
                    }
                    else
                    {
                        g_bSingleStep = TRUE;
                        g_dwBaseTime += timeGetTime() - ( g_dwPauseTime + 100 );
                        g_dwPauseTime = timeGetTime();
                    }
                    break;*///disabled by vujtech
		        case IDC_AUDIO:
					if(bWantSound)
					{
    					if( bSoundEnabled )
    					{
    						DestroySound();
    					}
    					else
    					{
    						InitializeSound();
    					}
						}
					break;
		        case IDC_FRAMERATE:
				bShowFrameCount=!bShowFrameCount;
					break;

                case IDM_CHANGEDEVICE:
                    // Display the driver-selection dialog box.
                    if( g_bActive && g_bReady )
                    {
                        AppPause(TRUE);
                        if( g_bWindowed )
                            GetWindowRect( hWnd, &g_rcWindow );
                        if( IDOK == D3DEnum_UserDlgSelectDriver( hWnd, g_bWindowed ) )
                        {
                            D3DEnum_DriverInfo* pDriverInfo;
                            D3DEnum_DeviceInfo* pDeviceInfo;
                            D3DEnum_GetSelectedDriver( &pDriverInfo, &pDeviceInfo );
                            g_bWindowed = pDeviceInfo->bWindowed;

                            Change3DEnvironment( hWnd );
                        }
                        AppPause(FALSE);
                    }
                    return 0;

                case IDM_TOGGLEFULLSCREEN:
                    // Toggle the fullscreen/window mode
                    if( g_bActive && g_bReady )
                    {
                        g_bReady = FALSE;
                        if( g_bWindowed )
                            GetWindowRect( hWnd, &g_rcWindow );
                        g_bWindowed = !g_bWindowed;
                        Change3DEnvironment( hWnd );
                        g_bReady = TRUE;
                    }
                    return 0;

                case IDM_HELP:
					//pokus
/*				    if(bWantSound)
						{
						SndObjFreq(hsoBeginLevel,44100);
						}*/


                    AppPause(TRUE);
                    DialogBox( (HINSTANCE)GetWindowLong( hWnd, GWL_HINSTANCE ),
                               MAKEINTRESOURCE(IDD_ABOUT), hWnd, AboutProc );
                    AppPause(FALSE);
                    return 0;

                case IDM_EXIT:
                    // Recieved key/menu command to exit app
                    SendMessage( hWnd, WM_CLOSE, 0, 0 );
                    return 0;
            }
            break;
    }

    return DefWindowProc( hWnd, uMsg, wParam, lParam );
}
            



//-----------------------------------------------------------------------------
// Name: AboutProc()
// Desc: Minimal message proc function for the about box
//-----------------------------------------------------------------------------
BOOL CALLBACK AboutProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM )
{
    if( WM_COMMAND == uMsg )
        if( IDOK == LOWORD(wParam) || IDCANCEL == LOWORD(wParam) )
            EndDialog (hWnd, TRUE);

    return ( WM_INITDIALOG == uMsg ) ? TRUE : FALSE;
}




//-----------------------------------------------------------------------------
// Note: From this point on, the code is DirectX specific support for the app.
//-----------------------------------------------------------------------------




//-----------------------------------------------------------------------------
// Name: AppInitialize()
// Desc: Initializes the framework, then calls the app-specific function
//       to initialize device specific objects. This code is structured to
//       handled any errors that may occur duing initialization
//-----------------------------------------------------------------------------
HRESULT AppInitialize( HWND hWnd )
{
    D3DEnum_DriverInfo* pDriverInfo;
    D3DEnum_DeviceInfo* pDeviceInfo;
    DWORD   dwFrameworkFlags = 0L;
    HRESULT hr;

    D3DEnum_GetSelectedDriver( &pDriverInfo, &pDeviceInfo );

    dwFrameworkFlags |= (!g_bWindowed         ? D3DFW_FULLSCREEN : 0L );
    dwFrameworkFlags |= ( g_bAppUseZBuffer    ? D3DFW_ZBUFFER    : 0L );
    dwFrameworkFlags |= ( g_bAppUseBackBuffer ? D3DFW_BACKBUFFER : 0L );

    // Initialize the D3D framework
    if( SUCCEEDED( hr = g_pFramework->Initialize( hWnd, &pDriverInfo->guid,
                       &pDeviceInfo->guid, &pDeviceInfo->pCurrentMode->ddsd, 
                       dwFrameworkFlags ) ) )
    {
        // Let the app run its startup code which creates the 3d scene.
        if( SUCCEEDED( hr = App_InitDeviceObjects( g_pFramework->GetD3DDevice(),
                                                g_pFramework->GetViewport() ) ) )
            return S_OK;
        else
        {
            App_DeleteDeviceObjects( g_pFramework->GetD3DDevice(),
                                     g_pFramework->GetViewport() );
            g_pFramework->DestroyObjects();
        }
    }

    // If we get here, the first initialization passed failed. If that was with a
    // hardware device, try again using a software rasterizer instead.
    if( pDeviceInfo->bIsHardware )
    {
        // Try again with a software rasterizer
        DisplayFrameworkError( hr, MSGWARN_SWITCHTOSOFTWARE );
        D3DEnum_SelectDefaultDriver( D3DENUM_SOFTWAREONLY );
        return AppInitialize( hWnd );
    }

    return hr;
}




//-----------------------------------------------------------------------------
// Name: Initialize3DEnvironment()
// Desc: Called when the app window is initially created, this triggers
//       creation of the remaining portion (the 3D stuff) of the app.
//-----------------------------------------------------------------------------
HRESULT Initialize3DEnvironment( HWND hWnd )
{
    HRESULT hr;

    // Initialize the app
    if( FAILED( hr = App_OneTimeSceneInit( hWnd ) ) )
        return E_FAIL;

    // Create a new CD3DFramework class. This class does all of our D3D
    // initialization and manages the common D3D objects.
    if( NULL == ( g_pFramework = new CD3DFramework() ) )
        return E_OUTOFMEMORY;

	/**********DirectSound******/
    if(bWantSound)
    {
        InitializeSound();
    }
	/*******DirectInput***************/
   if(!InitInput(g_hInst, hWnd))
      return E_DI_ERRORINIT;


	/********************/

    // Finally, initialize the framework and scene.
    return AppInitialize( hWnd );
}

    


//-----------------------------------------------------------------------------
// Name: Change3DEnvironment()
// Desc: Handles driver, device, and/or mode changes for the app.
//-----------------------------------------------------------------------------
HRESULT Change3DEnvironment( HWND hWnd )
{
    HRESULT hr;
    
    // Release all objects that need to be re-created for the new device
    App_DeleteDeviceObjects( g_pFramework->GetD3DDevice(), 
                             g_pFramework->GetViewport() );

    // Release the current framework objects (they will be recreated later on)
    if( FAILED( hr = g_pFramework->DestroyObjects() ) )
    {
        DisplayFrameworkError( hr, MSGERR_APPMUSTEXIT );
        DestroyWindow( hWnd );
        return hr;
    }

    // In case we're coming from a fullscreen mode, restore the window size
    if( g_bWindowed )
    {
        SetWindowPos( hWnd, HWND_NOTOPMOST, g_rcWindow.left, g_rcWindow.top,
                      ( g_rcWindow.right - g_rcWindow.left ), 
                      ( g_rcWindow.bottom - g_rcWindow.top ), SWP_SHOWWINDOW );
    }

    // Inform the framework class of the driver change. It will internally
    // re-create valid surfaces, a d3ddevice, and a viewport.
    if( FAILED( hr = AppInitialize( hWnd ) ) )
    {
        DisplayFrameworkError( hr, MSGERR_APPMUSTEXIT );
        DestroyWindow( hWnd );
        return hr;
    }

    // If the app is paused, trigger the rendering of the current frame
    if( FALSE == g_bFrameMoving )
    {
        g_bSingleStep = TRUE;
        g_dwBaseTime += timeGetTime() - g_dwPauseTime;
        g_dwPauseTime = timeGetTime();
    }

    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: Render3DEnvironment()
// Desc: Draws the scene (puvodne i hybalo se snimky, ted uz jen vykresluje soucasny stav hry)
//-----------------------------------------------------------------------------
HRESULT Render3DEnvironment()
{
BOOL kreslit=g_bActive;
    // Check the cooperative level before rendering
	if(kreslit)
		{
		if( FAILED( g_pFramework->GetDirectDraw()->TestCooperativeLevel() ) )
	        return S_OK;
		}

    //Render the scene
    if(kreslit)
		{
		if( FAILED( App_Render( g_pFramework->GetD3DDevice(),
                            g_pFramework->GetViewport(), 
                            (D3DRECT*)g_pFramework->GetViewportRect()) ))//nove dodelat casovani animaci atd.
			{
			return E_FAIL;
			}
		}
	else
		{
		if( FAILED( App_Render( 0,0,0) ))
			{//pouze pocitej hru
			return E_FAIL;
			}
		}

    
    // Show the frame rate, etc.
    if(kreslit)
		{
		DisplayTextInfo();
	    if( bShowFrameCount )
		    AppShowStats();
		}

    // Show the frame on the primary surface.
    if(kreslit)
	    if( DDERR_SURFACELOST == g_pFramework->ShowFrame() )
		    {
		    g_pFramework->RestoreSurfaces();
	        App_RestoreSurfaces();
			}

    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: Cleanup3DEnvironment()
// Desc: Cleanup scene objects
//-----------------------------------------------------------------------------
VOID Cleanup3DEnvironment()
{
//uvolneni directinput
CleanupInput();
/*******************/    
	if( g_pFramework )
    {
        App_FinalCleanup( g_pFramework->GetD3DDevice(), 
                          g_pFramework->GetViewport() );

        SAFE_DELETE( g_pFramework );
    }

    D3DEnum_FreeResources();
    g_bActive = FALSE;
    g_bReady  = FALSE;
}


  

//-----------------------------------------------------------------------------
// Name: AppPause()
// Desc: Called in to toggle the pause state of the app. This function
//       brings the GDI surface to the front of the display, so drawing
//       output like message boxes and menus may be displayed.
//-----------------------------------------------------------------------------
VOID AppPause( BOOL bPause )
{
    static DWORD dwAppPausedCount = 0L;

    if( bPause && 0 == dwAppPausedCount )
        if( g_pFramework )
            g_pFramework->FlipToGDISurface( TRUE );

    dwAppPausedCount += ( bPause ? +1 : -1 );

    g_bReady = (0==dwAppPausedCount);
	if(g_bReady)
		ReacquireInput();//nove
}




//-----------------------------------------------------------------------------
// Name: AppShowStats()
// Desc: Shows frame rate and dimensions of the rendering device. Note: a 
//       "real" app wouldn't query the surface dimensions each frame.
//-----------------------------------------------------------------------------
VOID AppShowStats()
{
    static FLOAT fFPS      = 0.0f;
    static FLOAT fLastTime = 0.0f;
    static DWORD dwFrames  = 0L;

    // Keep track of the time lapse and frame count
    FLOAT fTime = timeGetTime() * 0.001f; // Get current time in seconds
    ++dwFrames;

    // Update the frame rate once per second
    if( fTime - fLastTime > 1.0f )
    {
        fFPS      = dwFrames / (fTime - fLastTime);
        fLastTime = fTime;
        dwFrames  = 0L;
    }

    // Get dimensions of the render surface 
    DDSURFACEDESC2 ddsd;
    ddsd.dwSize = sizeof(DDSURFACEDESC2);
    g_pFramework->GetRenderSurface()->GetSurfaceDesc(&ddsd);

    // Setup the text buffer to write out
    CHAR buffer[128];
    sprintf( buffer, "%9.02f fps (%dx%dx%d)", fFPS, ddsd.dwWidth,
             ddsd.dwHeight, ddsd.ddpfPixelFormat.dwRGBBitCount );
//	sprintf(buffer,"%d %d %d %d %d %d",KeyState[0],KeyState[1],KeyState[2],KeyState[3],KeyState[4],KeyState[5]);//pokus
//	sprintf(buffer,"%d %d %d %d",MapVisibleFromX,MapVisibleFromY,MapVisibleToX,MapVisibleToY);//pokus
//MapVisibleFromX=Roh[0];
//MapVisibleFromY=Roh[1];
//MapVisibleToX=Roh[2];
//MapVisibleToY=Roh[3];//tyto polozky vyplni fce SetVisible();
    AppOutputText( g_pFramework->GetD3DDevice(), 0, 0, buffer );
}




//-----------------------------------------------------------------------------
// Name: AppOutputText()
// Desc: Draws text on the window.
//-----------------------------------------------------------------------------
VOID AppOutputText( LPDIRECT3DDEVICE3 pd3dDevice, DWORD x, DWORD y, CHAR* str )
{
    LPDIRECTDRAWSURFACE4 pddsRenderSurface;
    if( FAILED( pd3dDevice->GetRenderTarget( &pddsRenderSurface ) ) )
        return;

    // Get a DC for the surface. Then, write out the buffer
    HDC hDC;
    if( SUCCEEDED( pddsRenderSurface->GetDC(&hDC) ) )
    {
        SetTextColor( hDC, RGB(255,255,0) );
        SetBkMode( hDC, TRANSPARENT );
        ExtTextOut( hDC, x, y, 0, NULL, str, strlen(str), NULL );
    
        pddsRenderSurface->ReleaseDC(hDC);
    }
    pddsRenderSurface->Release();
}




//-----------------------------------------------------------------------------
// Name: DisplayFrameworkError()
// Desc: Displays error messages in a message box
//-----------------------------------------------------------------------------

//+ nove i errory od directinput a directsound a ....
VOID DisplayFrameworkError( HRESULT hr, APPMSGTYPE errType )
{
    CHAR strMsg[512];

    switch( hr )
    {
        case E_DI_ERRORINIT:
            strcpy( strMsg, TEXT("DirectInput initialization Failed!\n"
                    "devices.") );
            break;
        case D3DENUMERR_NOCOMPATIBLEDEVICES:
            strcpy( strMsg, TEXT("Could not find any compatible Direct3D\n"
                    "devices.") );
            break;
        case D3DENUMERR_SUGGESTREFRAST:
            strcpy( strMsg, TEXT("Could not find any compatible devices.\n\n"
                    "Try enabling the reference rasterizer using\n"
                    "EnableRefRast.reg.") );
            break;
        case D3DENUMERR_ENUMERATIONFAILED:
            strcpy( strMsg, TEXT("Enumeration failed. Your system may be in an\n"
                    "unstable state and need to be rebooted") );
            break;
        case D3DFWERR_INITIALIZATIONFAILED:
            strcpy( strMsg, TEXT("Generic initialization error.\n\nEnable "
                    "debug output for detailed information.") );
            break;
        case D3DFWERR_NODIRECTDRAW:
            strcpy( strMsg, TEXT("No DirectDraw") );
            break;
        case D3DFWERR_NODIRECT3D:
            strcpy( strMsg, TEXT("No Direct3D") );
            break;
        case D3DFWERR_INVALIDMODE:
            strcpy( strMsg, TEXT("This DXBitka DEMO requires a 16-bit (or higher) "
                    "display mode\nto run in a window.\n\nPlease switch "
                    "your desktop settings accordingly.") );
            break;
        case D3DFWERR_COULDNTSETCOOPLEVEL:
            strcpy( strMsg, TEXT("Could not set Cooperative Level") );
            break;
        case D3DFWERR_NO3DDEVICE:
            strcpy( strMsg, TEXT("No 3D Device") );
            break;
        case D3DFWERR_NOZBUFFER:
            strcpy( strMsg, TEXT("No ZBuffer") );
            break;
        case D3DFWERR_NOVIEWPORT:
            strcpy( strMsg, TEXT("No Viewport") );
            break;
        case D3DFWERR_NOPRIMARY:
            strcpy( strMsg, TEXT("No primary") );
            break;
        case D3DFWERR_NOCLIPPER:
            strcpy( strMsg, TEXT("No Clipper") );
            break;
        case D3DFWERR_BADDISPLAYMODE:
            strcpy( strMsg, TEXT("Bad display mode") );
            break;
        case D3DFWERR_NOBACKBUFFER:
            strcpy( strMsg, TEXT("No backbuffer") );
            break;
        case D3DFWERR_NONZEROREFCOUNT:
            strcpy( strMsg, TEXT("Nonzerorefcount") );
            break;
        case D3DFWERR_NORENDERTARGET:
            strcpy( strMsg, TEXT("No render target") );
            break;
        case E_OUTOFMEMORY:
            strcpy( strMsg, TEXT("Not enough memory!") );
            break;
        case DDERR_OUTOFVIDEOMEMORY:
            strcpy( strMsg, TEXT("There was insufficient video memory "
                    "to use the\nhardware device.") );
            break;
        default:
            strcpy( strMsg, TEXT("Generic application error.\n\nEnable "
                    "debug output for detailed information.") );
    }

    if( MSGERR_APPMUSTEXIT == errType )
    {
        strcat( strMsg, TEXT("\n\nThis DEMO will now exit.") );
        MessageBox( NULL, strMsg, g_strAppTitle, MB_ICONERROR|MB_OK );
    }
    else
    {
        if( MSGWARN_SWITCHTOSOFTWARE == errType )
            strcat( strMsg, TEXT("\n\nSwitching to software rasterizer.") );
        MessageBox( NULL, strMsg, g_strAppTitle, MB_ICONWARNING|MB_OK );
    }
}


/*
 * Displays error to the user
 */
BOOL ShowError( int iStrID )
{
	TCHAR tszMsg[MAX_ERRORMSG];
	TCHAR tszTitle[MAX_WINDOWTITLE];

	LoadString(ghinst, iStrID, tszMsg, MAX_ERRORMSG);
	LoadString(ghinst, IDS_DUEL_ERROR_TITLE, tszTitle, MAX_WINDOWTITLE);
    MessageBox( ghWndMain, tszMsg, tszTitle, MB_OK );
    return FALSE;
}

/*
 * LaunchedByLobby
 *
 * Determines if we were launched by a lobby. If so, gets the connection settings
 * and creates our player using the information from the lobby
 */
BOOL LaunchedByLobby(void)
{
    HRESULT hr;

    // create a lobby object
    hr = DPLobbyCreate();
    if (FAILED(hr))
    {
		// Interface is not available, so tell them to get DPlay 6 or later
		if (hr == E_NOINTERFACE)
			ShowError(IDS_DPLAY_ERROR_CLSID);
		else
			ShowError(IDS_DPLOBBY_ERROR_C);
        return FALSE;
    }

    // get connection settings from the lobby (into glpdplConnection)
    hr = DPLobbyGetConnectionSettings();
    if (FAILED(hr))
    {
        if (DPERR_NOTLOBBIED != hr)
        {
            ShowError(IDS_DPLOBBY_ERROR_GCS);
		    // Send Close message
			ExitGame();
        }
        // else we were not lobbied - start up game normally
		hr = DPLobbyRelease();
        return FALSE;
    }

    return TRUE;
}


/*
 * FinishLobbyLaunch
 *
 * Connect to the lobby and create our player
 */
BOOL FinishLobbyLaunch(void)
{
    HRESULT hr;

	if (!glpdplConnection)
	{
		TRACE(_T("FinishLobbyLaunch - No lobby interface\n"));
		return FALSE;
	}

	// are we hosting or joining ?
	gbIsHost = (glpdplConnection->dwFlags & DPLCONNECTION_CREATESESSION) != 0;

    // set our session flags
    glpdplConnection->lpSessionDesc->dwFlags = DPSESSION_MIGRATEHOST | 
                                               DPSESSION_KEEPALIVE;

    // let lobby know our connection flags
    hr = DPLobbySetConnectionSettings();
    if (FAILED(hr))
    {
        ShowError(IDS_DPLOBBY_ERROR_SCS);
        goto FAIL;
    }

    // connect to the lobby
	hr = DPLobbyConnect();
    if (FAILED(hr))
    {
        ShowError(IDS_DPLOBBY_ERROR_CONNECT);
        goto FAIL;
    }

	// create our player
    hr = DPlayCreatePlayer(&gOurID,
#ifdef UNICODE
							glpdplConnection->lpPlayerName->lpszShortName,
#else
							glpdplConnection->lpPlayerName->lpszShortNameA,
#endif
							NULL, NULL, 0);
    if (FAILED(hr))
    {
		ShowError(IDS_DPLAY_ERROR_CP);
        goto FAIL;
    }

#ifdef UNICODE
#error nepodporuje UNICODE!!!	
#endif

	if(glpdplConnection->lpPlayerName->lpszShortNameA[0]=='0')
		EngDruzstvo=0;
	else
	if(glpdplConnection->lpPlayerName->lpszShortNameA[0]=='1')
		EngDruzstvo=1;
	else
		goto FAIL;//dodelat errory


    // Init lobby msg support for reporting score
	// Note that we don't release the lobby object
	LobbyMessageInit();

    // successful lobby launch
    return TRUE;

FAIL:
	// cleanup and exit
	DPLobbyRelease();
    return FALSE;
}


/*
 * CleanupApplication
 *
 * Calls clean up on all components
 */
void CleanupApplication( void )
{
	CleanupComm();
//    CleanupSfx();
//	CleanupGraphics();
//	CleanupInput();
    DPLobbyRelease();				// in case we were doing lobby messages
}


/*
 * UpdateTitle
 *
 * Updates the window title based on application status
 */
void UpdateTitle(void)
{//nove dopichnout
/*	DWORD dwFeatures;
  	TCHAR tszTitle[MAX_WINDOWTITLE];
	PTCHAR pSeparator, ptszRemaining;

	// calculate title features
	dwFeatures = 0;
	if (gbIsHost)
		dwFeatures |= 1;
	if (gbUseProtocol)
		dwFeatures |= 2;
	if (gbReliable)
		dwFeatures |= 4;
	if (gbAsync)
		dwFeatures |= 8;

	// get appropriate window title for these features
	LoadString(ghinst,
			   dwFeatures == 0 ? IDS_DUEL_TITLE : IDS_DUEL_OPTIONS_TITLE,
			   tszTitle, MAX_WINDOWTITLE);

	if (dwFeatures > 0)
	{	// blank out any inactive status fields from title string
		// "Duel -|Host|Protocol|Reliable|Async|"
		// and replace separators with blanks
		if (!(ptszRemaining = _tcschr(tszTitle, _T('|'))))
			goto BADSTRING;
		*ptszRemaining = _T(' ');	// replace 1st separator
		do
		{
			BOOL bInactive = (dwFeatures & 1) == 0;
			dwFeatures >>= 1;	// shift to next bit flag
			if (!(pSeparator = _tcschr(ptszRemaining, _T('|'))))
				goto BADSTRING;
			if (bInactive)
			{
				*pSeparator = 0;	// temporarily terminate substring
				_tcsset(ptszRemaining, _T(' '));
			}
			// replace separator with blank or terminate if none are left
			*pSeparator = dwFeatures > 0 ? _T(' ') : 0;
			ptszRemaining = pSeparator;
		} while (dwFeatures > 0);
	}

    // change window title
    SetWindowText(ghWndMain, tszTitle);
	return;
BADSTRING:
    SetWindowText(ghWndMain, _T("Title string resource is corrupted!"));*/
}

void DisplayTextInfo()
{
char buffer[128];
TText *act;
TextInfo.Reset();
DWORD time=timeGetTime();

DDSURFACEDESC2 ddsd;
ddsd.dwSize = sizeof(DDSURFACEDESC2);
g_pFramework->GetRenderSurface()->GetSurfaceDesc(&ddsd);
int radek=ddsd.dwHeight-20;
int count=0;
while(act=TextInfo.Next())
	{
	count++;
	if((count>MIN_TEXT_RAD&&time-act->time>MAX_TEXT_TIME)||count>MAX_TEXT_RAD)
		{
		TextInfo.Delete();
		}
	else
		{
		AppOutputText(g_pFramework->GetD3DDevice(), 5, radek,act->data);
		radek-=15;
		}
	}
/**************typ prenosu dat***************/
sprintf(buffer,"Sound:%s  Data transfer type:%s,%s",bSoundEnabled ? "Enable" : "Disable",gbReliable ? "Reliable" : "Unreliable",gbAsync ? "Async" : "Sync");
AppOutputText(g_pFramework->GetD3DDevice(),5,15,buffer);
//BOOL                    gbReliable;             // sends are reliable
//BOOL                    gbAsync;                // asynchronous sends
/*******score***********/
sprintf(buffer,"Score: %d/%d  Players: %d/%d",EngScore[0],EngScore[1],EngPocetHracu[0],EngPocetHracu[1]);
AppOutputText(g_pFramework->GetD3DDevice(),5,30,buffer);

/********udaje o zbranich***************/
if(EngAppState==1)
	{
	for(int i=0;i<PlayerCount;i++)
		{
		if(gOurID==PlayerPID[i])
			{
			sprintf(buffer,"Zbran: %s (%d)",NazvyZbrani[PlayerBuf[i].Typ][EngActZbran],PlayerBuf[i].Ammo[EngActZbran]);
			AppOutputText(g_pFramework->GetD3DDevice(),5,45,buffer);
			sprintf(buffer,"Fuel: %.1f   Armour: %d",PlayerBuf[i].Fuel,PlayerBuf[i].Damage);
			AppOutputText(g_pFramework->GetD3DDevice(),5,60,buffer);
			break;
			}
		}
	}
/********texty v podzemi*******/
if(EngAppState==2&&!EngWaitOnCar&&LocState==0&&!EngUmiram)
	{
	sprintf(buffer,"%d",EngZdroj[EngDruzstvo].NCar[0]);
	AppOutputText(g_pFramework->GetD3DDevice(),ddsd.dwWidth/2-20,ddsd.dwHeight/2-20,buffer);
	sprintf(buffer,"%d",EngZdroj[EngDruzstvo].NCar[1]);
	AppOutputText(g_pFramework->GetD3DDevice(),ddsd.dwWidth/2+15,ddsd.dwHeight/2-20,buffer);
	sprintf(buffer,"%d",EngZdroj[EngDruzstvo].NCar[2]);
	AppOutputText(g_pFramework->GetD3DDevice(),ddsd.dwWidth/2-20,ddsd.dwHeight/2+10,buffer);
	sprintf(buffer,"%d",EngZdroj[EngDruzstvo].NCar[3]);
	AppOutputText(g_pFramework->GetD3DDevice(),ddsd.dwWidth/2+15,ddsd.dwHeight/2+10,buffer);

	sprintf(buffer,"Miny:%d",EngZdroj[EngDruzstvo].NMina);
	AppOutputText(g_pFramework->GetD3DDevice(),ddsd.dwWidth/2-128,ddsd.dwHeight/2-9,buffer);
	}
}
