#if !defined(FVUJ__POMOCNE_H)
#define FVUJ__POMOCNE_H

#include "utils\d3dutil.h"

#define IS_NUM(c)     ((c) >= '0' && (c) <= '9')
#define IS_SPACE(c)   ((c) == ' ' || (c) == '\r' || (c) == '\n' || (c) == '\t' || (c) == ',')

int Vne(float a1,float a2,float c1,float c2,float b1,float b2);
int Prekryv(float *x1,float *y1,float *x2,float *y2);
int Uvnitr(float *x1,float *y1,float x2,float y2);
float getmax(float *pole,int kolik);
float getmin(float *pole,int kolik);
int getint(char**p, int def);

/****************/
//Casem optimalizovat co do rychlosti

/********sablona spojaku***********/
/****obousmerny****/

/*struct TSpoj2{
	void *Data;
	TSpoj2 *Next;
	TSpoj2 *Prev;
	};

template <class T> class TSpojak{
	private:
	TSpoj2 *Prvni;
	TSpoj2 *Akt;
	public:
	void Reset(){
		Akt=NULL;
		};
	T *Next(){//nasledujici se stane aktualnim a vrati se jeho data
		if(!Akt)
			Akt=Prvni;
		else
			Akt=Akt->Next;
		if(!Akt)
			return NULL;
		return (T *)(Akt->data);
		};
	void *Delete(){//smaze aktualni a vrati NULL kdyz uz dalsi neni
		};
	void Add(void *data){//pridava za aktualni pozici
		if(!Akt)//pokacovani
		TSpoj2 *novy=new TSpoj2;
		novy->Data=data;
		novy->Next=;
		Prvni=novy;
		};
	void DeleteAll(){
		Reset();
		while(Delete());
		};
	TSpojak(){
		Prvni=NULL;
		Akt=NULL;
		};
	~TSpojak()
		{
		DeleteAll();
		}
	};*/


/*****jednosmerny********/

struct TSpoj{
	void *Data;
	TSpoj *Next;
	};

/*Template <class T> class TSpojakVerze0{
	private:
	TSpoj *Prvni;	
	TSpoj **Akt;//ukazatel na ukazatel na aktualni polozku
	public:
	void Reset(){
		Akt=&Prvni;
		};
	T *Next(){
		if(!(*Akt))return NULL;
		void *data=(*Akt)->Data;
		Akt=&((*Akt)->Next);
		return (T *)data;
		};
	void *Delete(){//smaze aktualni a vrati NULL kdyz uz dalsi neni
		if(!(*Akt))return NULL;
		if((*Akt)->Data)
			{
			delete (T *)((*Akt)->Data);
			}
		TSpoj *pom=(*Akt)->Next;
		delete (*Akt);
		*Akt=pom;
		return *Akt;
		};
	void Add(void *data){//pridava na zacatek
		TSpoj *novy=new TSpoj;
		novy->Data=data;
		novy->Next=Prvni;
		Prvni=novy;
		};
	void DeleteAll(){
		Reset();
		while(Delete());
		};
	TSpojakVerze0(){
		Prvni=NULL;
		Akt=&Prvni;
		};
	~TSpojakVerze0()
		{
		DeleteAll();
		}
	};*/

/*****jednosmerny predelavka********/


template <class T> class TSpojak{
	private:
	BOOL justdeleted;
	TSpoj *Prvni;	
	TSpoj **Akt;//ukazatel na ukazatel na aktualni polozku
	public:
	void Reset(){
		Akt=NULL;
		justdeleted=FALSE;
		};
	T *Next(){
/*		if(!(*Akt))return NULL;
		void *data=(*Akt)->Data;
		Akt=&((*Akt)->Next);
		return (T *)data;*/
		if(!justdeleted)//posune se na nasledujici a vcrati jeho data
			{
			if(!Akt)
				{
				Akt=&Prvni;
				if(!(*Akt))
					return NULL;
				}
			else
				{
				if(!(*Akt))
					return NULL;
				Akt=&((*Akt)->Next);
				if(!(*Akt))
					return NULL;
				}
			return (T *)((*Akt)->Data);
			}
		else
			{//pouze vrati aktualni data
			justdeleted=FALSE;
			if(!(*Akt))
				return NULL;
			return (T *)((*Akt)->Data);
			}
		};
	void *Delete(){//smaze aktualni a vrati NULL kdyz uz dalsi neni
		if(!Akt)//je to resetle
			{
			Akt=&Prvni;
			}
		if(!(*Akt))return NULL;//prazdny seznam
		if((*Akt)->Data)
			{
			delete (T *)((*Akt)->Data);
			}
		TSpoj *pom=(*Akt)->Next;
		delete (*Akt);
		*Akt=pom;
		justdeleted=TRUE;
		return *Akt;
		};
	void Add(void *data){//pridava na zacatek seznamu
		TSpoj *novy=new TSpoj;
		novy->Data=data;
		novy->Next=Prvni;
		Prvni=novy;
		};
	void DeleteAll(){//zkontrolovat
		Reset();
		while(Delete());
		};
	int GetCount()
		{
		int i=0;
		Reset();
		while(Next())
			i++;
		return i;
		}
	TSpojak(){
		Prvni=NULL;
		Akt=NULL;
		justdeleted=FALSE;
		};
	~TSpojak()
		{
		DeleteAll();
		}
	};


#endif

