//-----------------------------------------------------------------------------

#define STRICT
#define D3D_OVERLOADS
#include <windows.h>
#include <commdlg.h>
#include <math.h>
#include <stdio.h>
#include "utils\D3DTextr.h"
#include "utils\D3DUtil.h"
#include "utils\D3DMath.h"
#include "resource.h"
#include "xfiles\XFileLoader.h"
#include "dplay\wizard.h"
#include "engine.h"
#include "gamebase.h"
#include "dplay\vsichni.h"
#include "dplay\comm.h"
#include "render.h"

//-----------------------------------------------------------------------------
// Declare the application globals for use in WinMain.cpp
//-----------------------------------------------------------------------------
TCHAR* g_strAppTitle       = TEXT( "DXBitka 1.0" );
BOOL   g_bAppUseZBuffer    = TRUE;
BOOL   g_bAppUseBackBuffer = TRUE;

D3DVECTOR vEyePt;
D3DVECTOR vLookatPt;
D3DVECTOR vUpVec;

TCamera EngCam;

D3DMATRIX matWorld, matView, matProj,matProj2,matViewInvert;

BOOL           g_bWindowed         = TRUE;
float ProjFOV;
float ProjAspect;//nastavuje deviceinit

int MapVisibleFromX;
int MapVisibleFromY;
int MapVisibleToX;
int MapVisibleToY;//tyto polozky vyplni fce SetVisible();

int EngAppState=0;


/**************pro rychlejsi vypocty kolizi hracu atd.***************/
SHIP PlayerBuf[MAX_PLAYERS];
DPID PlayerPID[MAX_PLAYERS];
int PlayerCount;

//-----------------------------------------------------------------------------
// Defines, constants, and global variables
//-----------------------------------------------------------------------------
LPDIRECT3DMATERIAL3 g_pmtrlObjectMtrl     = NULL;
LPDIRECT3DLIGHT     g_pLight              = NULL;
//CD3DFileObject*     g_pFileObject         = NULL;
//BOOL                g_bNewFileObject      = FALSE;




//-----------------------------------------------------------------------------
// Function prototypes and global (or static) variables
//-----------------------------------------------------------------------------
VOID    AppPause( BOOL );
HRESULT App_InitDeviceObjects( LPDIRECT3DDEVICE3, LPDIRECT3DVIEWPORT3 );
VOID    App_DeleteDeviceObjects( LPDIRECT3DDEVICE3, LPDIRECT3DVIEWPORT3 );
LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );
LRESULT CALLBACK App_OverridenWndProc( HWND, UINT, WPARAM, LPARAM );




//-----------------------------------------------------------------------------
// Name: App_OneTimeSceneInit()
// Desc: Called during initial app startup, this function performs all the
//       permanent initialization.
//-----------------------------------------------------------------------------
HRESULT App_OneTimeSceneInit( HWND hWnd )
{
    // Attach a message handler
    SetWindowLong( hWnd, GWL_WNDPROC, (LONG)App_OverridenWndProc );

    // Set the transform matrices
    vEyePt    = D3DVECTOR( 0.0f, 5.0f, -8.5f );
    vLookatPt = D3DVECTOR( 0.0f, 0.0f,  0.0f );
    vUpVec    = D3DVECTOR( 0.0f, 1.0f,  0.0f );
    D3DUtil_SetIdentityMatrix( matWorld );
    D3DUtil_SetViewMatrix( matView, vEyePt, vLookatPt, vUpVec );

    // Create a container for the object to hold the xfile data
//    g_pFileObject = new CD3DFileObject();
	if(FAILED(InitGameObjects()))
		return E_FAIL;
	if(FAILED(InitMapTextures()))//new
		return E_FAIL;
	if(FAILED(InitInterfaceTex()))//new
		return E_FAIL;
    // Load a DirectX .X file
/*    while( FALSE == g_bNewFileObject ) 
    {
        CHAR* strFileName = PromptUserForFileToLoad( hWnd );

        if( NULL == strFileName )
            return S_OK;

        g_pFileObject->Load( strFileName );

        // If the file was loaded, exit the loop. Else, display an error.
        if( g_pFileObject )
            g_bNewFileObject = TRUE;
        else
            MessageBox( NULL, TEXT("Error loading specified X file"),
                        TEXT("XFile"), MB_OK|MB_ICONERROR );
    }*/

    return S_OK;
}



//-----------------------------------------------------------------------------
// Name: App_FrameMove()
// Desc: Called once per frame, the call is the entry point for animating
//       the scene.
//-----------------------------------------------------------------------------
/*HRESULT App_FrameMove( LPDIRECT3DDEVICE3 pd3dDevice, DWORD deltatime,DWORD abstime)
{
static minstate=0;
*/
/*if(EngAppState==1)
	{
	//for(DWORD t=abstime-deltatime;t<=abstime;t+=EngNearestTime
	DWORD predtime=abstime-deltatime;
	while(EngNearestTime<=abstime&&EngNearestTime>predtime)
		{//porad tu jsou nejake zmeny, ktere je treba vyridit
		DWORD d=EngNearestTime-predtime;
		predtime=EngNearestTime;
		ComputeGame(d,EngNearestTime);//druhy parametr je abstime v okamziku nearesttime
		}//computegame pochopitelne upravi NearestTime podle potreby
	if(EngNearestTime!=abstime)//znamena, ze deltatime nebyl vyrizen v predchozim while
		ComputeGame(abstime-predtime,abstime);
    pd3dDevice->SetTransform( D3DTRANSFORMSTATE_VIEW,&matView );
	}*///nove cele bude jinak a jinde
/*
minstate=EngAppState;
return S_OK;
}*/


//-----------------------------------------------------------------------------
// Name: App_Render()
// Desc: Called once per frame, the call is the entry point for 3d
//       rendering. This function sets up render states, clears the
//       viewport, and renders the scene.
//-----------------------------------------------------------------------------
HRESULT App_Render( LPDIRECT3DDEVICE3 pd3dDevice, 
                    LPDIRECT3DVIEWPORT3 pvViewport, D3DRECT* prcViewRect )
{
static int MinAppState=0;
static BOOL NeedReset=true;
static DWORD dwRenderLastTick=0;
DWORD dwRenderTick=timeGetTime();

if(!MinAppState&&EngAppState)//poprve co zacala opravdova hra
	{
	dwRenderLastTick=dwRenderTick;//aby to nepocitalo nesmyslne casy
	}
MinAppState=EngAppState;
    //Clear the viewport
	if(pd3dDevice)//je to i s kreslenim
		pvViewport->Clear2( 1UL, prcViewRect, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER,
                        0x00000000, 1.0f, 0L );
//                        RGB_MAKE(252,66,219), 1.0f, 0L );
/************pohyb hracu***************/
	DWORD CompHot=0;//kolik uz jsem odsimuloval
	if(EngAppState)//level je loudly a ja jsem bud na povrchu nebo v podzemi
		{/****kvuli presnejsim vypoctum nejdu se simulaci stavu pod MIN_COMPUTE_FPS******/
		while(CompHot<dwRenderTick-dwRenderLastTick)//jeste neni nasimulovano co je potreba
			{
			ComputeCBTime=(dwRenderTick-dwRenderLastTick)-CompHot;//co je potreba jeste udelat
			if(ComputeCBTime>1000/MIN_COMPUTE_FPS)//nejvetsi interval co mohu pripustit
				{
				ComputeCBTime=1000/MIN_COMPUTE_FPS;
				}
			if(FAILED(ComputeGame()))
				{
				MessageBox( NULL, TEXT("point1"),TEXT("Detecterror"), MB_OK|MB_ICONERROR );
				dwRenderLastTick=dwRenderTick;
				return E_FAIL;
				}
			CompHot+=ComputeCBTime;
			}
		}
	if(EngUmiram)//umiraci timer
		{
		gBasekaTime+=(float)(dwRenderTick-dwRenderLastTick)*0.001f;//v sekundach
		if(gBasekaTime>=UMIRANI_TIME)//cas umirani vyprsel
			EngUmiram=FALSE;
		}
	if(!pd3dDevice)
		{//pouze obsluz multiplayer
		dwRenderLastTick=dwRenderTick;
		return S_OK;
		}
/*********nastaveni kamery***************/
	if(EngAppState==1||EngUmiram)//level je loudly a ja na povrchu
		{//final2
		MoveCameraByCar((dwRenderTick-dwRenderLastTick)*0.001f,NeedReset);//cas minuleho snimku !!v sekundach!!
		NeedReset=false;
		D3DUtil_SetViewMatrix( matView, vEyePt, vLookatPt, vUpVec );
		D3DMath_MatrixInvert( matViewInvert, matView);//kvuli vypoctu viditelnosti mapky
		SetVisible();//nastaveni viditelnosti mapky (trochu zlobi)
		}
	else
		if(EngAppState==2)//level je loudly a ja v podzemi
		{
		vLookatPt.y=0.0f;
		vLookatPt.x=0.0f;
		vLookatPt.z=0.0f;
		vEyePt.x=0.0f;
		vEyePt.y=(float)(prcViewRect->y2)*4.0f/256.0f;
		vEyePt.z=(float)(prcViewRect->y2)*4.0f/256.0f;

		D3DUtil_SetProjectionMatrix( matProj2, g_PI/4,(float)(prcViewRect->y2)/(float)(prcViewRect->x2), 1.0f, 100.0f );//upravil
		pd3dDevice->SetTransform( D3DTRANSFORMSTATE_PROJECTION, &matProj2 );
		D3DUtil_SetViewMatrix( matView, vEyePt, vLookatPt, vUpVec );
		}
/************samotne renderovani******************/
	pd3dDevice->SetTransform( D3DTRANSFORMSTATE_VIEW,&matView );
    // Begin the scene 
    if( SUCCEEDED( pd3dDevice->BeginScene() ) )
    {
	if(EngAppState==0)//uvodni obrazovka
		{
		NeedReset=true;
		RenderInterface(pd3dDevice,pvViewport,prcViewRect);
		}
	else if(EngAppState==2&&(!EngUmiram))
		{//podzemi
		NeedReset=true;
		RenderInterface2(pd3dDevice,pvViewport,prcViewRect,dwRenderTick-dwRenderLastTick);		
		pd3dDevice->SetTransform( D3DTRANSFORMSTATE_PROJECTION,&matProj);//vratim to zase do puvodniho stavu
		}
	else
	if((EngUmiram||EngAppState==1)&&EngMapa)//level je loudly (predelat)
		{
		if(FAILED(RenderGame(pd3dDevice,pvViewport,prcViewRect,dwRenderTick-dwRenderLastTick)))
			{
			pd3dDevice->EndScene();
			MessageBox( NULL, TEXT("point2"),TEXT("Detecterror"), MB_OK|MB_ICONERROR );
			dwRenderLastTick=dwRenderTick;
			return E_FAIL;
			}
		}//nove cele bude jinde a jinak
        // End the scene.
    pd3dDevice->EndScene();
    }
dwRenderLastTick=dwRenderTick;
return S_OK;
}




//-----------------------------------------------------------------------------
// Name: App_InitDeviceObjects()
// Desc: Initialize scene objects.
//-----------------------------------------------------------------------------
HRESULT App_InitDeviceObjects( LPDIRECT3DDEVICE3 pd3dDevice,
                               LPDIRECT3DVIEWPORT3 pvViewport )
{
    // Check parameters
    if( NULL==pd3dDevice || NULL==pvViewport )
        return E_INVALIDARG;

D3DVIEWPORT2 vp;
vp.dwSize = sizeof(vp);
pvViewport->GetViewport2(&vp);
float Height=(float)vp.dwHeight;
float Width=(float)vp.dwWidth;

    // Get a ptr to the ID3D object to create materials and/or lights. Note:
    // the Release() call just serves to decrease the ref count.
    LPDIRECT3D3 pD3D;
    if( FAILED( pd3dDevice->GetDirect3D( &pD3D ) ) )
        return E_FAIL;
    pD3D->Release();

    HRESULT           hr;
    D3DMATERIAL       mtrl;
    D3DMATERIALHANDLE hmtrl;
    
    // Create and set up the object material
    if( FAILED( hr = pD3D->CreateMaterial( &g_pmtrlObjectMtrl, NULL ) ) )
        return E_FAIL;

    D3DUtil_InitMaterial( mtrl, 1.0f, 1.0f, 1.0f );
    g_pmtrlObjectMtrl->SetMaterial( &mtrl );
    g_pmtrlObjectMtrl->GetHandle( pd3dDevice, &hmtrl );
    pd3dDevice->SetLightState(  D3DLIGHTSTATE_MATERIAL, hmtrl );
	pd3dDevice->SetLightState(  D3DLIGHTSTATE_AMBIENT, 0x006F6F6F);

    D3DTextr_RestoreAllTextures( pd3dDevice );
	RestoreMapTextures( pd3dDevice);//new
	RestoreInterfaceTex( pd3dDevice);//new
	RestoreStatic(pd3dDevice);

    pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
    pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1 );
    pd3dDevice->SetTextureStageState( 0, D3DTSS_MINFILTER, D3DTFN_LINEAR );
    pd3dDevice->SetTextureStageState( 0, D3DTSS_MAGFILTER, D3DTFG_LINEAR );
    pd3dDevice->SetRenderState( D3DRENDERSTATE_DITHERENABLE,   TRUE );
    pd3dDevice->SetRenderState( D3DRENDERSTATE_SPECULARENABLE, FALSE );
    pd3dDevice->SetRenderState( D3DRENDERSTATE_ZENABLE,        TRUE );


    // If we have an object loaded, position the view accordingly
/*    if( g_pFileObject )
    {
        FLOAT fRadius;
        g_pFileObject->GetBoundingSphere( &vLookatPt, &fRadius );
        vEyePt = D3DVECTOR( 0.0f, 0.0f, fRadius*3.0f ) + vLookatPt;

        g_bNewFileObject = FALSE;
    }*/

	//sluselo by se zjistit od windowsu aspect ratio displaye
	//dodelat (predpokladam 1:1 bod)	  
	ProjFOV=g_PI/4;
	ProjAspect=Height/Width;//nastavuje deviceinit
	D3DUtil_SetProjectionMatrix( matProj, ProjFOV,ProjAspect, 1.0f, 100.0f );//upravil
/*	ProjFOV=0.333;//pokus
	ProjAspect=Height/Width;//nastavuje deviceinit
	D3DUtil_SetProjectionMatrix( matProj, ProjFOV,ProjAspect, 1.0f, 100.0f );//upravil*/

    pd3dDevice->SetTransform( D3DTRANSFORMSTATE_WORLD,      &matWorld );
    pd3dDevice->SetTransform( D3DTRANSFORMSTATE_VIEW,       &matView );
    pd3dDevice->SetTransform( D3DTRANSFORMSTATE_PROJECTION, &matProj );


    // Set up the light
    if( FAILED( hr = pD3D->CreateLight( &g_pLight, NULL ) ) )
        return E_FAIL;
    
    D3DLIGHT light;
    D3DUtil_InitLight( light, D3DLIGHT_DIRECTIONAL, 1.0f, -1.0f, 1.0f );
    light.dvAttenuation0 = 1.0f;
    g_pLight->SetLight( &light );
    pvViewport->AddLight( g_pLight );

    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: App_FinalCleanup()
// Desc: Called before the app exits, this function gives the app the chance
//       to cleanup after itself.
//-----------------------------------------------------------------------------
HRESULT App_FinalCleanup( LPDIRECT3DDEVICE3 pd3dDevice, 
                          LPDIRECT3DVIEWPORT3 pvViewport )
{
    App_DeleteDeviceObjects( pd3dDevice, pvViewport );
    
//    SAFE_DELETE( g_pFileObject );
	DeInitLevel();
	DeInitMapTextures();//new
	DeInitInterfaceTex();//new
	DeInitGameObjects();//new
    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: App_DeleteDeviceObjects()
// Desc: Called when the app is exitting, or the device is being changed,
//       this function deletes any device dependant objects.
//-----------------------------------------------------------------------------
VOID App_DeleteDeviceObjects( LPDIRECT3DDEVICE3 pd3dDevice, 
                              LPDIRECT3DVIEWPORT3 pvViewport )
{
	InvalidateStatic();
	InvalidateMapTextures();
	InvalidateInterfaceTex();
    D3DTextr_InvalidateAllTextures();

    SAFE_RELEASE( g_pLight );
    SAFE_RELEASE( g_pmtrlObjectMtrl );
}




//----------------------------------------------------------------------------
// Name: App_RestoreSurfaces
// Desc: Restores any previously lost surfaces. Must do this for all surfaces
//       (including textures) that the app created.
//----------------------------------------------------------------------------
HRESULT App_RestoreSurfaces()
{
    return S_OK;
}




//-----------------------------------------------------------------------------
// Name: App_ConfirmDevice()
// Desc: Called during device intialization, this code checks the device
//       for some minimum set of capabilities
//-----------------------------------------------------------------------------
HRESULT App_ConfirmDevice( DDCAPS* pddDriverCaps,
                           D3DDEVICEDESC* pd3dDeviceDesc )
{
		return S_OK;
}




//----------------------------------------------------------------------------
// Name: App_OverridenWndProc
// Desc: App custom WndProc function for handling mouse and keyboard input.
//----------------------------------------------------------------------------
LRESULT CALLBACK App_OverridenWndProc( HWND hWnd, UINT uMsg, WPARAM wParam,
                                       LPARAM lParam )
{
    // Check for the "Load File..." option selected from the menu
    if( WM_COMMAND == uMsg )
    {
/*        if( IDM_LOADFILE == LOWORD(wParam) )
        {
            AppPause( TRUE );

			//DWORD dwTid;
			//CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE )DoWizard, 0, 0, &dwTid);//pokus
            //DoWizard(NULL);//pokus
            CHAR* strFileName = PromptUserForFileToLoad( hWnd );
			//CHAR* strFileName = "Pokusny.lev";
        
            if( strFileName )
            {
				DeInitLevel();                
                if( FAILED( InitLevel( strFileName ) ) )
                {
					DeInitLevel();//new
                    MessageBox( NULL, TEXT("Error loading specified level file"),
                                TEXT("LevFile"), MB_OK|MB_ICONERROR );
                }
            }

            AppPause( FALSE );
        }*///nove zruseno
    }

    // Fall through to the app's main windows proc function
    return WndProc( hWnd, uMsg, wParam, lParam );
}




//-----------------------------------------------------------------------------
// Name: PromptUserForFileToLoad()
// Desc: Uses Windows' OpenFileName dialog to get the name of an X file to
//       load, then proceeds to load that file.
//-----------------------------------------------------------------------------
CHAR* PromptUserForFileToLoad( HWND hWnd )
{
    static TCHAR strInitialDir[512] = ".\\levels";
    //static TCHAR strPath[512];
    static TCHAR strFileName[512];
    static TCHAR strCurrentName[512] = "*.lev";
//    HKEY         key;
//    DWORD        type, size = 512;
    
    OPENFILENAME ofn = { sizeof(OPENFILENAME), hWnd, NULL, "DXBitka level files\0*.lev\0", NULL,
                         0, 1, strCurrentName, 512, strFileName, 512, NULL,
                         "Open level file", OFN_NOCHANGEDIR |OFN_FILEMUSTEXIST|OFN_HIDEREADONLY , 0, 1, ".lev", 0,
                         NULL, NULL };

    ofn.lpstrInitialDir = strInitialDir;

    // Display the OpenFileName dialog. Then, try to load the specified file
    if( TRUE == GetOpenFileName( &ofn ) )
        return strCurrentName;

    return NULL;
}




